VERSION 5.00
Begin VB.Form HostEthernetCCM 
   Caption         =   "Host Ethernet CCM Transaction"
   ClientHeight    =   7920
   ClientLeft      =   60
   ClientTop       =   420
   ClientWidth     =   12255
   LinkTopic       =   "Form1"
   ScaleHeight     =   7920
   ScaleWidth      =   12255
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton CCM_ProcessCommand 
      Caption         =   "4. Send Command To the ECOM"
      Height          =   375
      Left            =   5520
      TabIndex        =   26
      Top             =   2280
      Width           =   3255
   End
   Begin VB.Frame CCM_WriteFrame 
      Caption         =   "Data to Write   ( must use 2 characters per BYTE )"
      Height          =   615
      Left            =   4080
      TabIndex        =   24
      Top             =   1560
      Width           =   6855
      Begin VB.TextBox CCM_WriteData 
         Height          =   285
         Left            =   120
         TabIndex        =   25
         Text            =   "0000"
         Top             =   240
         Width           =   6615
      End
   End
   Begin VB.Frame CCM_SizeFrame 
      Caption         =   "Size"
      Height          =   615
      Left            =   4080
      TabIndex        =   21
      Top             =   840
      Width           =   2175
      Begin VB.TextBox CCM_SizeData 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   120
         TabIndex        =   22
         Text            =   "1"
         Top             =   240
         Width           =   495
      End
      Begin VB.Label CCM_SizeLabel 
         Height          =   255
         Left            =   720
         TabIndex        =   23
         Top             =   270
         Width           =   1095
      End
   End
   Begin VB.Frame CCM_AddressFrame 
      Caption         =   "Start Address (Hex)"
      Height          =   615
      Left            =   6480
      TabIndex        =   20
      ToolTipText     =   "To find CCM Address, Convert V-address (octal) to HEX, then add 1,  e.g. V2000(Octal) = 400(Hex) = CCM address 401"
      Top             =   840
      Width           =   2535
      Begin VB.TextBox CCM_AddressData 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   120
         TabIndex        =   27
         Text            =   "401"
         ToolTipText     =   "To find CCM Address, Convert V-address (octal) to HEX, then add 1,  e.g. V2000(Octal) = 400(Hex) + 1 = CCM address 401"
         Top             =   225
         Width           =   735
      End
      Begin VB.Label CCM_AddressLabel 
         Height          =   255
         Left            =   960
         TabIndex        =   28
         Top             =   270
         Width           =   1095
      End
   End
   Begin VB.Frame CCM_DataTypeFrame 
      Caption         =   "Data Type"
      Height          =   615
      Left            =   6480
      TabIndex        =   16
      Top             =   120
      Width           =   4455
      Begin VB.OptionButton CCM_DataType33 
         Caption         =   "33 - Outputs"
         Height          =   255
         Left            =   3000
         TabIndex        =   19
         Top             =   240
         Width           =   1335
      End
      Begin VB.OptionButton CCM_DataType32 
         Caption         =   "32 - Inputs"
         Height          =   255
         Left            =   1560
         TabIndex        =   18
         Top             =   240
         Width           =   1335
      End
      Begin VB.OptionButton CCM_DataType31 
         Caption         =   "31 - Registers"
         Height          =   255
         Left            =   120
         TabIndex        =   17
         Top             =   240
         Width           =   1335
      End
   End
   Begin VB.Frame CCM_CommandFrame 
      Caption         =   "Command"
      Height          =   615
      Left            =   4080
      TabIndex        =   13
      Top             =   120
      Width           =   2175
      Begin VB.OptionButton CCM_CommandWrite 
         Caption         =   "Write"
         Height          =   255
         Left            =   1080
         TabIndex        =   15
         Top             =   240
         Width           =   735
      End
      Begin VB.OptionButton CCM_CommandRead 
         Caption         =   "Read"
         Height          =   255
         Left            =   120
         TabIndex        =   14
         Top             =   240
         Width           =   735
      End
   End
   Begin VB.Frame DisplayDevicesFrame 
      Caption         =   "Devices"
      Height          =   855
      Left            =   120
      TabIndex        =   10
      Top             =   1080
      Width           =   1455
      Begin VB.OptionButton DisplayOnlyECOMs 
         Caption         =   "Only ECOMs"
         Height          =   255
         Left            =   120
         TabIndex        =   12
         Top             =   240
         Width           =   1215
      End
      Begin VB.OptionButton DisplayAllDevices 
         Caption         =   "All Devices"
         Height          =   255
         Left            =   120
         TabIndex        =   11
         Top             =   480
         Width           =   1095
      End
   End
   Begin VB.CommandButton NetworkInit 
      Caption         =   "1. Init Network"
      Default         =   -1  'True
      Height          =   375
      Left            =   1680
      TabIndex        =   9
      Top             =   120
      Width           =   1455
   End
   Begin VB.CommandButton Disconnect 
      Caption         =   "Disconnect"
      Height          =   375
      Left            =   1680
      TabIndex        =   8
      Top             =   1560
      Width           =   1455
   End
   Begin VB.CommandButton Exit 
      Caption         =   "Exit"
      Height          =   375
      Left            =   1680
      TabIndex        =   7
      Top             =   2280
      Width           =   1455
   End
   Begin VB.Frame ProtocolFrame 
      Caption         =   "Protocol"
      Height          =   855
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   1455
      Begin VB.OptionButton UseIP 
         Caption         =   "UDP/IP"
         Height          =   255
         Left            =   120
         TabIndex        =   6
         Top             =   240
         Width           =   975
      End
      Begin VB.OptionButton UseIPX 
         Caption         =   "IPX"
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   480
         Width           =   975
      End
   End
   Begin VB.CommandButton Connect 
      Caption         =   "3. Connect"
      Height          =   375
      Left            =   1680
      TabIndex        =   3
      Top             =   1080
      Width           =   1455
   End
   Begin VB.CommandButton ClearDisplay 
      Caption         =   "Clear Display"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   2280
      Width           =   1455
   End
   Begin VB.ListBox DisplayList 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   5010
      ItemData        =   "EtherCCM.frx":0000
      Left            =   120
      List            =   "EtherCCM.frx":0002
      TabIndex        =   1
      Top             =   2760
      Width           =   12015
   End
   Begin VB.CommandButton ScanNetwork 
      Caption         =   "2. Scan Network"
      Height          =   375
      Left            =   1680
      TabIndex        =   0
      Top             =   600
      Width           =   1455
   End
End
Attribute VB_Name = "HostEthernetCCM"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit                 ' Must explicitly declare variable types


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' HEI API Defines
'
    Const HEIAPIVersion As Byte = 3
    Const HEIAPIVersionString As String = "3"
    Const HEIP_HOST As Integer = 1
    Const HEIP_IPX As Integer = 2
    Const HEIP_IP As Integer = 3
    Const HEIT_HOST As Integer = 1
    Const HEIT_IPX As Integer = 2
    Const HEIT_WINSOCK As Integer = 4
    
    Const DefDevTimeout As Integer = 50                        ' value in milliseconds
    Const LongDevTimeout As Integer = DefDevTimeout + 200      ' value in milliseconds
    Const DefDevRetrys As Byte = 3
    Const DefDevUseAddressedBroadcast As Boolean = False

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Error Messages
'
    Const HEIE_NULL As Integer = 0                              ' No error
    Const HEIE_FIRST_ERROR As Integer = &H8000                  ' Number for first error
    Const HEIE_LAST_ERROR As Integer = &HFFFF                   ' Number for last error
    Const HEIE_NOT_IMPLEMENTED As Integer = &H8000              ' Function not implemented
    Const HEIE_VER_MISMATCH As Integer = &H8001                 ' Version passed to function is not correct for the library
    Const HEIE_UNSUPPORTED_TRANSPORT As Integer = &H8002        ' Supplied transport is not supported
    Const HEIE_INVALID_DEVICE As Integer = &H8003               ' Supplied device is not valid
    Const HEIE_BUFFER_TOO_SMALL As Integer = &H8004             ' Supplied buffer is too small
    Const HEIE_ZERO_BYTES_RECEIVED As Integer = &H8005          ' Zero packets returned in the packet
    Const HEIE_TIMEOUT As Integer = &H8006                      ' Timeout error
    Const HEIE_UNSUPPORTED_PROTOCOL As Integer = &H8007         ' Supplied protocol not supported
    Const HEIE_IP_ADDRESS_NOT_INITIALIZED As Integer = &H8008   ' The device's IP address has not been assigned
    Const HEIE_NULL_TRANSPORT As Integer = &H8009               ' No Transport specified
    Const HEIE_IPX_NOT_INITIALIZED As Integer = &H800A          ' IPX Transport not installed
    Const HEIE_IPX_OPEN_SOCKET As Integer = &H800B              ' Error opening IPX socket
    Const HEIE_NO_PACKET_DRIVER As Integer = &H800C             ' No packet driver found
    Const HEIE_CRC_MISMATCH As Integer = &H800D                 ' CRC did not match
    Const HEIE_ALLOCATION_ERROR As Integer = &H800E             ' Memory allocation failed
    Const HEIE_NO_IPX_CACHE As Integer = &H800F                 ' No cache has been allocated for IPX
    Const HEIE_INVALID_REQUEST As Integer = &H8010              ' Invalid CCM Request
    Const HEIE_NO_RESPONSE As Integer = &H8011                  ' No response was available/requested
    Const HEIE_INVALID_RESPONSE As Integer = &H8012             ' Invalid format response was received
    Const HEIE_DATA_TOO_LARGE As Integer = &H8013               ' Given data is too large
    Const HEIE_LOAD_PROC_ERROR As Integer = &H8014              ' Error loading procedures
    Const HEIE_NOT_LOADED As Integer = &H8015                   ' Attempted command before succesfull OpenTransport()
    Const HEIE_LOAD_ERROR As Integer = &H9000                   ' Error on loading

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' If PASCAL_HEIOpenTransport()fails for WinSock, it will return one of the following errors:
'
' &h8014    Error getting address from WinSock.DLL
' &h8100    System was out of memory, or executable file was corrupt, or sharing or network-protection error
' &h8101    Unused
' &h8102    file was not found
' &h8103    Path was not found
' &h8104    Unused
' &h8105    Attempt was made to dynamically link to a task, or there was a sharing or network-protection error
' &h8106    Library required separate data segments for each task
' &h8107    Unused
' &h8108    There was insufficient memory to start the application
' &h8109    Unused
' &h810A    Windows version was incorrect
' &h810B    Executable file was invalid, it's either not a Windows application or there was an error in the .EXE image.
' &h810C    Application was designed for a different operating system
' &h810D    Application was designed for MS-DOS 4.0
' &h810E    Type of executable was unknown
' &h810F    Attempt was made to load a real-mode application (developed for an earlier version of Windows )
' &h8110    Attempt was made to load a second instance of an application file containing multiple data segments that were not marked read-only
' &h8113    Attempt was made to load a compressed executable file. The file must be decompressed before it can be loaded
' &h8114    Dynamic-link library (DLL) file was invalid. One of the DLLs required to run this application was corrupt
' &h8115    Application requires Microsoft Windows 32-bit extensions
'
    
    Const HEIE_INVALID_SLOT_NUMBER   As Integer = 118
    Const HEIE_INVALID_DATA          As Integer = 119
    Const HEIE_CHANNEL_FAILURE       As Integer = 121   ' Analog I/O, broken transmitter alarm, for modules with
                                                        '  one error bit for all channels
    Const HEIE_UNUSED_CHANNELS_EXIST As Integer = 122   ' Analog I/O, module jumpers set to disable some channels
    Const HEIE_INVALID_BASE_NUMBER   As Integer = 135
    Const HEIE_INVALID_MODULE_TYPE   As Integer = 136
    Const HEIE_INVALID_OFFSET        As Integer = 137
    Const HEIE_BROKEN_TRANSMITTER    As Integer = 139
    Const HEIE_INVALID_ADDRESS       As Integer = 140
    Const HEIE_CHANNEL_FAILURE_MULTI As Integer = 142   ' Analog I/O, broken transmitter alarm, for modules with
                                                        '  an error bit for each channel, e.g. F2-04RTD
    Const HEIE_SERIAL_SETUP_ERROR    As Integer = 143
    Const HEIE_MODULE_ERROR          As Integer = 152
    Const HEIE_MODULE_NOT_RESPONDING As Integer = 153   ' T1H-EBC, Hot-Swap, module removed
    Const HEIE_BASE_CHANGED          As Integer = 154   ' T1H-EBC, Hot-Swap, module added
    Const HEIE_PARITY_ERROR          As Integer = 156
    Const HEIE_FRAMING_ERROR         As Integer = 157
    Const HEIE_OVER_RUN_ERROR        As Integer = 158
    Const HEIE_BUFFER_OVERFLOW       As Integer = 159
    Const HEIE_DRIVE_TRIP            As Integer = 162   ' HA-EDRV2, Drive has tripped
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Terminator Hot-Swap Defines, Used in HEIRescanBase()
'
    Const RESCAN_LEAVE_IMAGE_RAM = 0                ' Don't clear the image RAM
    Const RESCAN_CLEAR_IMAGE_RAM = 1                ' Clear the image RAM
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Warnings
'
    Const HEIW_FIRST_WARNING As Integer = &H4000    ' Number for First Warning
    Const HEIW_LAST_WARNING As Integer = &H4FFF     ' Number for Last Warning
    Const HEIW_RETRY As Integer = &H4000            ' One or More Retrys have occurred

' These are masks for values returned from HEIReadIO and/or HEIWriteIO and indicate that some
' error/warning/info/internal condition exists for some module in the base ( it could be an I/O
' module or it could be the ethernet module. The function HEIReadModuleStatus can then be used
' to retrieve the actual conditions. Note that more than one of the conditions can exist at any time.
'
    Const MASK_DEVICE_ERROR As Integer = &H1000
    Const MASK_DEVICE_WARNING As Integer = &H2000
    Const MASK_DEVICE_INFO As Integer = &H4000

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Data Types
'
    Const DT_IP_ADDRESS As Integer = &H10           ' 4-byte IP Address
    Const DT_SERIAL_SETTINGS As Integer = &H11      ' 8 Byte Serial Setup
    Const DT_RXWX_SETTINGS As Integer = &H15        ' 128 Byte setings for RXWX configuration
    Const DT_NODE_NAME As Integer = &H16            ' 256-byte Node Name
    Const DT_BASE_DEF As Integer = &H17             ' 512 Byte Base Definition (405 HEIWriteBaseDef)
    Const DT_NODE_NUMBER As Integer = &H20          ' 4-byte Node Number
    Const DT_MODULE_SETUP As Integer = &H24         ' 64-byte data from FLASH (see ModuleSetup structure)
    Const DT_DESCRIPTION As Integer = &H26          ' 256-byte Node Description
    Const DT_SUBNET_MASK As Integer = &H30          ' 4-byte Subnet Mask
    Const DT_TYPE_STRING As Integer = &H33          ' 32 byte string that contains the part number
    Const DT_LINK_MONITOR As Integer = &H8006       ' 256 Byte Link monitor setup

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Data Formats
'
    Const DF_BIT_IN As Byte = &H3
    Const DF_BIT_OUT As Byte = &H4
    Const DF_WORD_IN As Byte = &H5
    Const DF_WORD_OUT As Byte = &H6
    Const DF_DWORD_IN As Byte = &H8
    Const DF_DWORD_OUT As Byte = &H9
    Const DF_BYTE_IN As Byte = &H10
    Const DF_BYTE_OUT As Byte = &H11
    Const DF_DOUBLE_IN As Byte = &H12
    Const DF_DOUBLE_OUT As Byte = &H13
    Const DF_FLOAT_IN As Byte = &H14
    Const DF_FLOAT_OUT As Byte = &H15
    Const DF_CONFIG As Byte = &H16

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Module Types
'
    Const MT_EBC As Integer = 0                     ' Ethernet Base Controller
    Const MT_ECOM As Integer = 1                    ' Ethernet Communications Module
    Const MT_WPLC As Integer = 2                    ' WinPLC
    Const MT_DRIVE As Integer = 3                   ' Ethernet Drive Interface
    Const MT_ERMA As Integer = 4                    ' Ethernet Remote Master
    Const MT_CTRIO As Integer = 5                   ' Counter Interface
    Const MT_AVG_DISP As Integer = 6                ' AVG Display Adapter
    Const MT_PBC As Integer = 7                     ' Profibus Slave controller
    Const MT_PBCC As Integer = 8                    ' Profibus Slave Communications Module (PSCM)
    Const MT_UNK As Integer = &HFF                  ' Unknown
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Module Family defines for MT_EBC, MT_ECOM, MT_EDRV, MT_ERMA and MT_WPLC
'
    Const MF_005 As Integer = 0                     ' DL05 Series
    Const MF_205 As Integer = 2                     ' DL205 Series
    Const MF_305 As Integer = 3                     ' DL305 Series
    Const MF_405 As Integer = 4                     ' DL405 Series
    Const MF_TERM As Integer = 10                   ' Terminator I/O Series
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Module Family defines for MT_DRIVE
'
    Const MF_100_SERIES As Integer = 1              ' Hitachi L100 and SJ100
    Const MF_J300 As Integer = 2                    ' Hitachi J300
    Const MF_300_Series As Integer = 3              ' Hitachi SJ300
    Const MF_GS As Integer = 4                      ' AutomationDirect GSx
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Module Family defines for MT_AVG_DISP
'
    Const MF_EZ_TOUCH As Integer = 1                ' AVG EZ-Touch Ethernet Adapter
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Structure Definitions
'
    Private Type EthernetStats
        SizeOfEthernetStats As Integer
        MissedFrameCount As Long
        TransmitCollisionCount As Long
        DiscardedPackets As Long
        BadCRCCount As Long
        UnknownTypeCount As Long
        SendErrorCount As Long
    End Type
    
    Private Type SupportDef
        Version As Byte
        Bytes2Follow As Byte
        UnusedBytes(15) As Byte
        'bit fields in Byte 1
        'FUN_POLLING As Byte             ' Polling one base
        'FUN_READ_VER_INFO As Byte       ' Version Info
        'FUN_READ_SUPPORT_INFO As Byte   ' Support Info
        'FUN_READ_DEVICE_INFO As Byte    ' Device Info
        'FUN_POLLING_ALL As Byte         ' Polling All bases (returns ethernet address)
        'FUN_WRITE_IO As Byte            ' Write IO Base
        'FUN_READ_IO As Byte             ' Read IO Base
        '
        'bit fields in Byte 2
        'FUN_READ_BASE_DEF As Byte       ' Read Base Def
        'FUN_ENUM_SETUP_DATA As Byte     ' Emunerate the Setup Data
        'FUN_READ_SETUP_DATA As Byte     ' Read Setup Data
        'FUN_WRITE_SETUP_DATA As Byte    ' Write Setup Data
        'FUN_DELETE_SETUP_DATA As Byte   ' Delete Setup Data
        'FUN_READ_ETHERNET_STATS As Byte ' Read Ethernet Statistics
        'FUN_PET_LINK As Byte            ' Used to keep the link sense timer from firing in the absense of ReadIO or WriteIO messages
        'FUN_ADDRESSED_BROADCAST As Byte ' Used to broadcast to a particular ethernet address
        '
        'bit fields in Byte 3
        'FUN_READ_MODULE_STATUS As Byte  ' Read module status (short bytes)
        'FUN_EXTENDED As Byte            ' Extended function
        'FUN_QUERY_SETUP_DATA As Byte    ' Query for particular data type/value
        'FUN_INIT_BASE_DEF As Byte       ' Initialize base def from backplane
        'FUN_DATA_BROADCAST As Byte      ' Broadcast to a particular data type
        'FUN_CCM_REQUEST As Byte         ' Perform CCM Request
        'FUN_KSEQ_REQUEST As Byte        ' Perform a KSequence Request
        'FUN_BACKPLANE_REQUEST As Byte   ' Perform backplane request
    End Type
    
    Private Type SerialSetup
        BaudRate As Long
        ConfigData(2) As Byte
        'bit fields in Byte 1
        ' StopBits
        ' DataBits
        ' Parity
        ' Mode
        ' Reserved
    End Type
    
    Private Type VersionDef
        'MajorVersion As Byte
        'MinorVersion As Byte
        'BuildVersion As Integer
        VBuffer(3) As Byte
    End Type
    
    Private Type VersionInfoDef
        'SizeofVersionInfo As Byte
        'BootVersion As VersionDef
        'OSVersion As VersionDef
        'NumOSExtensions As Byte
        'OSExt(9) As VersionDef
        Version(51) As Byte
    End Type
    
    Private Type DeviceDef
        'PLCFamily As Byte               ' 1= HA, 2= 205, 3= 305, 4= 405, 10= Terminator
        'Unused1 As Byte
        'ModuleType As Byte              ' 0= EBC, 1= ECOM, &H80= Fiber, 3= Drive, 4= ERM, 6= AVG
        'StatusCode As Byte
        'EthernetAddress(5) As Byte      ' Hardware Ethernet Address
        'RamSize As Integer              ' in K-byte increments
        'FlashSize As Integer            ' in K-byte increments
        'DipSettings As Byte             ' setting of the 8 element dip switch
        'MediaType As Byte               ' 0= 10Base-T,1= 10Base-F
        'EPFCount As Long                ' Early Power Fail Count - 405 only
        'Status As Byte                  '  Status:1 = Run Relay Status
        '                                '  Status:2 = Battery Low Indicator
        '                                '  Status:6 = unused bits
        'BattRamSize As Integer          ' size (in K-bytes) of the battery-backed RAM
        'ExtraDIPs As Byte               ' extra DIP switches on Terminator I/O
        'ModelNumber As Byte             ' used by WinPLC
        'EtherSpeed As Byte              ' 0 = 10Mbit, 1 = 100Mbit
        'PLDRev(1) As Byte               ' PLD revision number
        'unused(14) As Byte
        Device(41) As Byte               ' 42-byte byte array (VB packs on 4-byte boundaries)
    End Type
    
    Private Type LinkMonitor
        'Timeout As Long                 ' 0= don't use Link Monitor
        'Mode As Byte                    ' 0= Clear Outputs
        '                                ' 1= Use pattern
        Data(255) As Byte                ' Pattern, same format as used for HEIWriteIO
    End Type
    
    Private Type MemoryTypeDef
        Type As Integer
        Size As Long
        unused(3) As Long
    End Type
    
    Private Type Encryption
        Algorithm As Byte               ' Algorithm to use for encryption: 0= No encryption, 1= private key encryption
        Unused1(2) As Byte              ' Reserved
        Key(59) As Byte                 ' Encryption key (null terminated)
    End Type
    
    Private Type EnetAddress
        'union
        '{
        '   ' Use this for HEIP_HOST protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_UNSPEC == 0
        '       char Nodenum[6];            ' Ethernet network address
        '       unsigned short LANNum;      ' Lana number
        '   }  AddressHost;
        '
        '   ' Use this for HEIP_IPX protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_IPX == 6
        '       char Netnum[4];             ' Network Number
        '       char Nodenum[6];            ' Ethernet network address
        '       unsigned short Socket;      ' Socket Number == 0x7070
        '   } AddressIPX;
        '
        '   ' Use this for HEIP_IP protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_INET == 2
        '       unsigned short Port;        ' Port number == 0x7070
        '       union
        '       {
        '           struct { unsigned char b1, b2, b3, b4; } bAddr;  ' Byte Addressing
        '           struct { unsigned short w1, w2; } wAddr;         ' Word addressing
        '           unsigned long lAddr;                             ' DWord addressing
        '       } AddressingType;
        '       char Zero[8];               ' initialize to zeros
        '   } AddressIP;
        '
        '   struct
        '   {
        '       Byte    Commport;
        '       Byte    ByteSize;
        '       Byte    Parity;
        '       Byte    StopBits;
        '       Long    Baud;
        '       Long    *hLocal;
        '   } AddressSerial;
        
        '   BYTE Raw[20];
        '}Address
        '
        Address(19) As Byte
    End Type
    
    
    Private Type HEITransport
        Transport As Integer
        Protocol As Integer
        Encrypt As Encryption
        SourceAddress As EnetAddress
        Reserved(47) As Byte
    End Type
    
    Private Type HEIDevice
        'union
        '{
        '   ' Use this for HEIP_HOST protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_UNSPEC == 0
        '       char Nodenum[6];            ' Ethernet network address
        '       unsigned short LANNum;      ' Lana number
        '   }  AddressHost;
        '
        '   ' Use this for HEIP_IPX protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_IPX == 6
        '       char Netnum[4];             ' Network Number
        '       char Nodenum[6];            ' Ethernet network address
        '       unsigned short Socket;      ' Socket Number == 0x7070
        '   } AddressIPX;
        '
        '   ' Use this for HEIP_IP protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_INET == 2
        '       unsigned short Port;        ' Port number == 0x7070
        '       union
        '       {
        '           struct { unsigned char b1, b2, b3, b4; } bAddr;  ' Byte Addressing
        '           struct { unsigned short w1, w2; } wAddr;         ' Word addressing
        '           unsigned long lAddr;                             ' DWord addressing
        '       } AddressingType;
        '       char Zero[8];               ' initialize to zeros
        '   } AddressIP;
        '
        '   struct
        '   {
        '       Byte    Commport;
        '       Byte    ByteSize;
        '       Byte    Parity;
        '       Byte    StopBits;
        '       Long    Baud;
        '       Long    *hLocal;
        '   } AddressSerial;
        
        '   BYTE Raw[20];
        '}Address
        '
        'wParam As Integer
        'dw_Param As Long
        'Timeout As Integer             ' Timeout value in ms
        'Retrys As Integer              ' Number of times to retry a transaction
        'EnetAddress(5) As Byte         ' Address placed here in HEIQueryDevice(s)
        'RetryCount As Integer          ' number of retrys that have occurred
        'BadCRCCount As Integer         ' number of packets received with a bad CRC
        'LatePacketCount As Integer     ' number of packets received after a timeout
        'ParallelPackets As Boolean     ' If set TRUE, (after HEIOpenDevice), will enable application
                                        ' to send multiple HEIReadIO, HEIWriteIO, HEICCMRequest or
                                        ' HEIKseqRequest transactions to different devices before waiting
                                        ' for any reponses. The application will then need to implement
                                        ' it's own timeout/retry mechanism while waiting on responses.
                                        ' Use HEIGetResponse() to see if responses have arrived.
                                        ' NOTE: do not send multiple requests to a single device.
        '
        'Internal Use Only -- Do Not Touch !!--
        'UseAddressedBroadcast As Boolean
        'UseBroadcast As Boolean
        'dwParam As Long
        'DataOffset As Integer
        'pTransport As Long
        'SizeOfData As Long
        'pData As Long
        'pBuffer As Long
        'LastAppVal As Integer
        'Byte UseProxy
        'Byte ProxyBase
        'Byte ProxySlot
        'Byte ProxyDevNum
        'Bytes Reserved(43)
        Address(125) As Byte             ' 126-byte byte array (VB packs on 4-byte boundaries)
    End Type
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Host Ethernet APIs
'
    Private Declare Function PASCAL_HEIOpen Lib "hei_pas" ( _
        ByVal HEIAPIVersion As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIClose Lib "hei_pas" ( _
    ) As Long
    
    Private Declare Function PASCAL_HEIOpenTransport Lib "hei_pas" ( _
        ByRef pTransport As HEITransport, _
        ByVal HEIAPIVersion As Integer, _
        ByVal EnetAdress As Long _
    ) As Long
    
    Private Declare Function PASCAL_HEICloseTransport Lib "hei_pas" ( _
        ByRef pTransport As HEITransport _
    ) As Long
    
    Private Declare Function PASCAL_HEIOpenDevice Lib "hei_pas" ( _
        ByRef pTransport As HEITransport, _
        ByRef pDevice As HEIDevice, _
        ByVal HEIAPIVersion As Integer, _
        ByVal Timeout As Integer, _
        ByVal Retrys As Integer, _
        ByVal UseAddressedBroadcast As Boolean _
    ) As Long
    
    Private Declare Function PASCAL_HEICloseDevice Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice _
    ) As Long
    
    Private Declare Function PASCAL_HEIQueryDevices Lib "hei_pas" ( _
        ByRef pTransport As HEITransport, _
        ByRef pDevice As HEIDevice, _
        ByRef pNumDevices As Long, _
        ByVal HEIAPIVersion As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIQueryDeviceData Lib "hei_pas" ( _
        ByRef pTransport As HEITransport, _
        ByRef pDevice As HEIDevice, _
        ByRef pNumDevices As Long, _
        ByVal HEIAPIVersion As Integer, _
        ByVal DataType As Integer, _
        ByRef pData As Byte, _
        ByVal SizeOFData As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIReadSetupData Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByVal SetupType As Integer, _
        ByRef pData As Byte, _
        ByRef pSizeOfData As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIWriteSetupData Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByVal SetupType As Integer, _
        ByRef pData As Byte, _
        ByVal SizeOFData As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIReadDeviceDef Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pModuleDefInfo As DeviceDef, _
        ByVal pSizeOfModuleDefInfo As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIReadVersionInfo Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pVersionInfo As VersionInfoDef, _
        ByRef pVersionInfoSize As Integer _
    ) As Long
        
    Private Declare Function PASCAL_HEIReadBaseDef Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pData As Byte, _
        ByRef pDataSize As Integer _
    ) As Long
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' EBC only
'
    Private Declare Function PASCAL_HEIReadIO Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pData As Byte, _
        ByRef pDataSize As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIWriteIO Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pData As Byte, _
        ByVal SizeOFData As Integer, _
        ByRef pReturnData As Byte, _
        ByRef pSizeOfReturnData As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIReadModuleStatus Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pData As Byte, _
        ByRef pSizeOfData As Integer, _
        ByVal Clear As Integer _
    ) As Long

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' H4-EBC only
'
    Private Declare Function PASCAL_HEIWriteBaseDef Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pData As Byte, _
        ByRef pDataSize As Integer _
    ) As Long
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Terminator I/O specific APIs
'
    ' This function will perform the power-on initilialization
    Private Declare Function PASCAL_HEIRescanBase Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByVal pRescanFlags As Integer, _
        ByRef pBaseDefInfo As Byte, _
        ByRef pDataSize As Integer _
    ) As Long
    
    ' This function is used to read the setup data from the T1F-08AD-2F (Fast Response)
    Private Declare Function PASCAL_HEIReadConfigData Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pData As Byte, _
        ByRef pDataSize As Integer _
    ) As Long

    ' This function is used to setup data from the T1F-08AD-2F (Fast Response)
    Private Declare Function PASCAL_HEIWriteConfigData Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pData As Byte, _
        ByVal DataSize As Integer, _
        ByRef pReturnData As Byte, _
        ByRef pReturnDataSize As Integer _
    ) As Long

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' ECOM Specific APIs
'
    Private Declare Function PASCAL_HEICCMRequest Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByVal bWrite As Integer, _
        ByVal DataType As Byte, _
        ByVal Address As Integer, _
        ByVal pDataLen As Integer, _
        ByRef pData As Byte _
    ) As Long
    
    Private Declare Function PASCAL_HEIKSEQRequest Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByVal DataLen As Integer, _
        ByRef pData As Byte, _
        ByRef pReturnDataLen As Integer _
    ) As Long
    
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Global variables
'
    ' return code from the SDK API calls
    Dim Rc As Long
        
    ' Ethernet protocol transport
    Dim TP As HEITransport
    
    ' true if the network interface can be initialized using the selected protocol
    Dim NetworkOK As Boolean
        
    ' maximum number of devices you want to allow
    Const MAXDEVICES As Integer = 100
    
    ' array of Host Ethernet devices
    Dim aDevices(MAXDEVICES) As HEIDevice
    
    ' number of Host Ethernet devices found on the network
    Dim DeviceCount As Long
    
    ' set to true if any Host Ethernet device is already open
    Dim DeviceOpen As Boolean
    
    ' this is the device the user selected from the list
    Dim tDevice As Integer
    
    ' this is the type of device the user selcted
    Dim tDeviceType As String
    
    ' detail line that gets displayed in the listbox
    Dim DetailLine As String
    

Private Sub CCM_CommandRead_Click()

    CCM_WriteFrame.Enabled = False
    CCM_WriteData.Enabled = False
    
End Sub


Private Sub CCM_CommandWrite_Click()

    CCM_WriteFrame.Enabled = True
    CCM_WriteData.Enabled = True

End Sub


Private Sub CCM_DataType31_Click()

    CCM_SizeFrame.Caption = "Size ( in Words )"
    CCM_SizeLabel.Caption = "(0 -> 64)"
    
    CCM_AddressLabel.Caption = "(0001 -> 42A0)"
    
End Sub

Private Sub CCM_DataType32_Click()

    CCM_SizeFrame.Caption = "Size ( in Bytes )"
    CCM_SizeLabel.Caption = "(0 -> 128)"
    
    CCM_AddressLabel.Caption = "(001 -> 200)"
    
End Sub

Private Sub CCM_DataType33_Click()

    CCM_SizeFrame.Caption = "Size ( in Bytes )"
    CCM_SizeLabel.Caption = "(0 -> 128)"

    CCM_AddressLabel.Caption = "(001 -> 340)"

End Sub

' Initialize Winsock using the selected protocol
'
Private Sub NetworkInit_Click()
    
    DisplayList.Clear
    
    ' if the network interface has already been opened, close it
    '
    If NetworkOK = True Then
        Rc = PASCAL_HEICloseTransport(TP)
        Rc = PASCAL_HEIClose()
    End If
    
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' Initialize the Ethernet Driver
    '
    Rc = PASCAL_HEIOpen(HEIAPIVersion)
    If Rc <> 0 Then
        DisplayList.AddItem "Error " + Hex(Rc) + " trying to initialize the Ethernet driver"
    
    Else
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' Initiaizize the Winsock protocol transport
        '
        TP.Transport = HEIT_WINSOCK
        
        If UseIP = True Then
            TP.Protocol = HEIP_IP
        Else
            TP.Protocol = HEIP_IPX
        End If
        
        Rc = PASCAL_HEIOpenTransport(TP, HEIAPIVersion, 0)
        If Rc <> 0 Then
            DisplayList.AddItem "Error " + Hex(Rc) + " trying to initialize the Winsock transport"
            
        Else
            If UseIP = True Then
                DisplayList.AddItem "Initialized Ok, using IP protocol"
            Else
                DisplayList.AddItem "Initialized Ok, using IPX protocol"
            End If
            
            NetworkOK = True
            ScanNetwork.Enabled = True
            If Connect.Enabled = True Then Connect.Enabled = False
                        
        End If
    
    End If

End Sub

Private Sub DisplayAllDevices_Click()

    Call ScanNetwork_Click
    
End Sub

Private Sub DisplayOnlyECOMs_Click()

    Call ScanNetwork_Click

End Sub

' Query the network for Host Ethernet Devices
'
' If you'd rather not query the network for Host Ethernet devices, you can manually place the
' the required Ethernet information in the HEIDevice structure then call PASCAL_HEIOpenDevice
' just as you would after a query operation. The key is getting the required information into
' the correct places in the structure. Refer to the following example:
'
' aDevices(X).Address(0) = 2         ' Family= AF_INET
' aDevices(X).Address(1) = 0
 
' aDevices(X).Address(2) = &H70      ' ECOMs use Port number 7070(Hex)
' aDevices(X).Address(3) = &H70
 
' aDevices(X).Address(4) = 192       ' IP Address of the ECOM is 192.168.0.1
' aDevices(X).Address(5) = 168
' aDevices(X).Address(6) = 26
' aDevices(X).Address(7) = 100

Private Sub ScanNetwork_Click()
    
    DisplayList.Clear
    DeviceCount = MAXDEVICES
    
    ' Do the Query
    '
    Rc = PASCAL_HEIQueryDevices(TP, aDevices(0), DeviceCount, HEIAPIVersion)
    If Rc <> 0 Then
        DisplayList.AddItem "Error " + Hex(Rc) + " trying to query network"
            
    Else
        ' If the PASCAL_HEIQuery call was successful, DeviceCount will contain the
        ' number of Host Ethernet Devices on the network
        '
        DisplayList.AddItem "Found" + Str(DeviceCount) + " devices"
        
        If DeviceCount > 0 Then
            DisplayList.AddItem "      Device        MAC Address            IP Address            ID"
    
            ' Error Flags
            '
            Dim DDError As Boolean, IPError As Boolean, IDError As Boolean
            DDError = False
            IPError = False
            IDError = False
            
            DetailLine = ""
                             
            ' Now lets display some relevant information about each device found
            '
            Dim X, y As Integer
            For X = 0 To DeviceCount - 1
                
                ' Open the device
                '
                Rc = PASCAL_HEIOpenDevice(TP, aDevices(X), HEIAPIVersion, LongDevTimeout, DefDevRetrys, False)
                If Rc <> 0 Then
                    DetailLine = "            " + " .... " + GetMACFromBuffer(aDevices(X).Address) + ".... " + "   .   .   .   " + " .... " + "       Error: " + Hex(Rc) + " " + ShowHEIErrorText(Rc)
                    DisplayList.AddItem DetailLine
                    DetailLine = ""
                                   
                Else
                    
                    
                    ' check to see if user wants to filter out non-ecom devices
                    '
                    If DisplayAllDevices = True Or (DisplayOnlyECOMs = True And DeviceIsECOM(aDevices(X)) = True) Then
                    
                        ' this is the list index number
                        '
                        DetailLine = Format(X, "@@@") + " "
                        
                        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
                        ' See if the device has DT_TYPE_STRING data. This is a relatively new feature
                        ' so devices with old firmware won't have this. You'll need to use the "old"
                        ' method of manually constructing the device name.
                        '
                        Dim dtBuffer(31) As Byte
                        Dim dtSize As Integer
                        
                        Erase dtBuffer
                        dtSize = 32
                         
                        Rc = PASCAL_HEIReadSetupData(aDevices(X), DT_TYPE_STRING, dtBuffer(0), dtSize)
                        If Rc = 0 Then
                            DetailLine = DetailLine + Format(UseTypeString(dtBuffer, dtSize), "@@@@@@@@@@") + " .... "
                             
                        Else
                            DetailLine = DetailLine + Format(BuildTypeString(aDevices(X), DDError), "@@@@@@@@@@") + " .... "
                            
                        End If
                             
                        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
                        ' Second
                        ' display the MAC address, it's in bytes 30 through 35 of the HEIDevice structure
                        '
                        DetailLine = DetailLine + GetMACFromBuffer(aDevices(X).Address)
                        
                        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
                        ' Third
                        ' Display the IP address (remove leading spaces)
                        '
                        Dim tBuffer(255) As Byte
                        Dim RSize As Integer
                        RSize = 4
                         
                        Rc = PASCAL_HEIReadSetupData(aDevices(X), DT_IP_ADDRESS, tBuffer(0), RSize)
                        If Rc <> 0 Then
                            IPError = True
                            DetailLine = DetailLine + ".... ???.???.???.??? "
                         
                        Else
                            DetailLine = DetailLine + ".... " + GetIPFromBuffer(tBuffer)
                             
                        End If
                         
                        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
                        ' Fourth
                        ' Display the Module ID
                        '
                        Erase tBuffer
                        RSize = 4
                         
                        Rc = PASCAL_HEIReadSetupData(aDevices(X), DT_NODE_NUMBER, tBuffer(0), RSize)
                        If Rc <> 0 Then
                            IDError = True
                            DetailLine = DetailLine + ".... ???"
                         
                        Else
                            DetailLine = DetailLine + ".... " + Format(GetNodeNumberFromBuffer(tBuffer), "@@@@@")
                            
                        End If
                        
                        ' alert me if any errors occurred trying to read from the device
                        '
                        If DDError = True Or IPError = True Or IDError = True Then
                           DetailLine = DetailLine + "   ! Error(s) occurred while reading device(s)"
                           DDError = False
                           IPError = False
                           IDError = False
                            
                        End If
                         
                    End If
                        
                    ' display device details
                    '
                    DisplayList.AddItem DetailLine
                    DetailLine = ""
                    
                    ' close this device
                    '
                    Rc = PASCAL_HEICloseDevice(aDevices(X))
                    If Rc <> 0 Then
                        DisplayList.AddItem "Error " + Hex(Rc) + " trying to close this device"
                    End If
                
                End If
            
            Next X
                
            ' Automatically select the first device found and give the Listbox focus
            '
            DisplayList.ListIndex = 2
            DisplayList.SetFocus
            Connect.Enabled = True
                  
        End If
    
    End If
    
End Sub


Private Sub Connect_Click()

    ' this is the device the user has selected
    '
    tDevice = DisplayList.ListIndex - 2
    
    DisplayList.Clear
    DeviceOpen = False
    Disconnect = False
  
    DisplayList.AddItem "Connect to device #" + Format(tDevice, "@@")
    
    
    ' Query the network for Host Ethernet Devices
    '
    ' If you'd rather not query the network for Host Ethernet devices, you can manually place the
    ' the required Ethernet information in the HEIDevice structure then call PASCAL_HEIOpenDevice
    ' just as you would after a query operation. The key is getting the required information into
    ' the correct places in the structure. Refer to the following example:
    '
    ' aDevices(tDevice).Address(0) = 2      ' Family= AF_INET
    ' aDevices(tDevice).Address(1) = 0
     
    ' aDevices(tDevice).Address(2) = &H70   ' ECOMs use Port number 7070(Hex)
    ' aDevices(tDevice).Address(3) = &H70
     
    ' aDevices(tDevice).Address(4) = 192    ' IP Address of the ECOM is 192.168.26.14
    ' aDevices(tDevice).Address(5) = 168
    ' aDevices(tDevice).Address(6) = 26
    ' aDevices(tDevice).Address(7) = 14
     
    
    ' Open the device
    '
    Rc = PASCAL_HEIOpenDevice(TP, aDevices(tDevice), HEIAPIVersion, DefDevTimeout, DefDevRetrys, False)
    If Rc <> 0 Then
        DisplayList.AddItem "Error " + Hex(Rc) + " trying to open the device"
    
    Else
        DeviceOpen = True
        
        NetworkInit.Enabled = False
        ScanNetwork.Enabled = False
        Disconnect.Enabled = True
        Connect.Enabled = False
        
        UseIP.Enabled = False
        UseIPX.Enabled = False
        ProtocolFrame.Enabled = False
        
        DisplayDevicesFrame.Enabled = False
        DisplayOnlyECOMs.Enabled = False
        DisplayAllDevices.Enabled = False
        
        CCM_CommandFrame.Enabled = True
        CCM_CommandRead.Enabled = True
        CCM_CommandWrite.Enabled = True
        CCM_CommandRead = True

        CCM_DataTypeFrame.Enabled = True
        CCM_DataType31.Enabled = True
        CCM_DataType32.Enabled = True
        CCM_DataType33.Enabled = True
        CCM_DataType31 = True
        
        CCM_SizeFrame.Enabled = True
        CCM_SizeData.Enabled = True
        CCM_SizeLabel.Enabled = True
        CCM_SizeData.Text = 1
        
        CCM_AddressFrame.Enabled = True
        CCM_AddressData.Enabled = True
        CCM_AddressLabel.Enabled = True
        CCM_AddressData.Text = 401
        
        CCM_WriteFrame.Enabled = False
        CCM_WriteData.Enabled = False
        CCM_WriteData.Text = "0000"
        
        CCM_ProcessCommand.Enabled = True
        
        
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' Display the Device Type
        '
        Dim RSDBuffer(31) As Byte
        Dim RSDSize As Integer
        Dim RSDError As Boolean

        Erase RSDBuffer
        RSDSize = 32

        Rc = PASCAL_HEIReadSetupData(aDevices(tDevice), DT_TYPE_STRING, RSDBuffer(0), RSDSize)
        If Rc = 0 Then
            DisplayList.AddItem "Device :" + Format(UseTypeString(RSDBuffer, RSDSize), "@@@@@@@@")

        Else
            RSDError = False
            tDeviceType = BuildTypeString(aDevices(tDevice), RSDError)
            If RSDError = False Then
                DisplayList.AddItem "Device :" + Format(tDevice, "@@@@@@@@")
            End If
        End If

        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' Display the boot loader version and the firmware version
        '
        Dim VIBuffer As VersionInfoDef
        Dim VISize As Integer
        VISize = 50

        Rc = PASCAL_HEIReadVersionInfo(aDevices(tDevice), VIBuffer, VISize)
        If Rc <> 0 Then
            DisplayList.AddItem "Error " + Hex(Rc) + " trying to read the version information"
        Else
            If VIBuffer.Version(0) <> 0 Then
                DisplayList.AddItem "Booter : " + Format(VIBuffer.Version(1), "@") + "." + Format(VIBuffer.Version(2), "@") + "." + Format((VIBuffer.Version(4) * 256) + (VIBuffer.Version(3)), "@@@")
                DisplayList.AddItem "OS     : " + Format(VIBuffer.Version(5), "@") + "." + Format(VIBuffer.Version(6), "@") + "." + Format((VIBuffer.Version(8) * 256) + (VIBuffer.Version(7)), "@@@")
            End If
        End If

        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' Display the Module ID (Node Number)
        '
        Dim tBuffer(255) As Byte
        Dim RSize As Integer
        Dim tString As String

        Erase tBuffer
        RSize = 4

        Rc = PASCAL_HEIReadSetupData(aDevices(tDevice), DT_NODE_NUMBER, tBuffer(0), RSize)
        If Rc <> 0 Then
            DisplayList.AddItem "Error reading Module ID:"

        Else
            tString = GetNodeNumberFromBuffer(tBuffer)
            DisplayList.AddItem "ID     : " + tString

        End If

        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' Display the Node Name
        '
        Erase tBuffer
        RSize = 256

        Rc = PASCAL_HEIReadSetupData(aDevices(tDevice), DT_NODE_NAME, tBuffer(0), RSize)
        If Rc <> 0 Then
            DisplayList.AddItem "Error reading Module Name"

        Else
            tString = GetNodeNameFromBuffer(tBuffer, RSize)
            DisplayList.AddItem "Name   : " + tString

        End If

        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' Display the Module Description
        '
        Erase tBuffer
        RSize = 256

        Rc = PASCAL_HEIReadSetupData(aDevices(tDevice), DT_DESCRIPTION, tBuffer(0), RSize)
        If Rc <> 0 Then
            DisplayList.AddItem "Error reading Module Description"

        Else
            tString = GetNodeDescFromBuffer(tBuffer, RSize)
            DisplayList.AddItem "Desc   : " + tString

        End If
            
        DisplayList.AddItem "--------------------------------------------------------"
        
    End If
    
End Sub


Private Sub Disconnect_Click()
        
    ' Close the open device
    '
    Rc = PASCAL_HEICloseDevice(aDevices(tDevice))
    If Rc <> 0 Then
        DisplayList.AddItem "Error " + Hex(Rc) + " trying to close device" + Str(tDevice)
    
    Else
        ' reset the screen
        '
        DeviceOpen = False
        
        NetworkInit.Enabled = True
        ScanNetwork.Enabled = True
        Connect.Enabled = False
        Disconnect.Enabled = False
        
      
        NetworkOK = False
        UseIP.Enabled = True
        NetworkOK = False
        UseIPX.Enabled = True
        ProtocolFrame.Enabled = True
        
        DisplayDevicesFrame.Enabled = True
        DisplayOnlyECOMs.Enabled = True
        DisplayAllDevices.Enabled = True
                
        CCM_CommandFrame.Enabled = False
        CCM_CommandRead.Enabled = False
        CCM_CommandWrite.Enabled = False

        CCM_DataTypeFrame.Enabled = False
        CCM_DataType31.Enabled = False
        CCM_DataType32.Enabled = False
        CCM_DataType33.Enabled = False
        
        CCM_SizeFrame.Enabled = False
        CCM_SizeData.Enabled = False
        CCM_SizeLabel.Enabled = False
        
        CCM_AddressFrame.Enabled = False
        CCM_AddressData.Enabled = False
        CCM_AddressLabel.Enabled = False
        
        CCM_WriteFrame.Enabled = False
        CCM_WriteData.Enabled = False
        
        CCM_ProcessCommand.Enabled = False
        
        
        tDeviceType = ""
        tDevice = 0
        
        DisplayList.Clear
        DisplayList.AddItem "Disconnected"
    
    End If

End Sub


Private Sub UseIP_Click()

    DisplayList.Clear
    
    If ScanNetwork.Enabled = True Then ScanNetwork.Enabled = False
    If Connect.Enabled = True Then Connect.Enabled = False
    
End Sub


Private Sub UseIPX_Click()

    DisplayList.Clear
    
    If ScanNetwork.Enabled = True Then ScanNetwork.Enabled = False
    If Connect.Enabled = True Then Connect.Enabled = False
    
End Sub


Private Sub CCM_ProcessCommand_Click()

    Dim DataType As Byte
    If CCM_DataType31 = True Then DataType = &H31
    If CCM_DataType32 = True Then DataType = &H32
    If CCM_DataType33 = True Then DataType = &H33
    
    
    Dim DataAddress As Integer
    DataAddress = StringToHexInt(CCM_AddressData)
    
    
    Dim DataLength As Integer
    If CCM_DataType31 = True Then
        DataLength = CCM_SizeData * 2
    Else
        DataLength = CCM_SizeData
    End If
    
    Dim bWrite As Long
    bWrite = False
   
    Dim ByteBuffer(255) As Byte
    Erase ByteBuffer
    
    If CCM_CommandWrite = True Then
        
        bWrite = True
        
        Rc = StringToByteArray(CCM_WriteData, ByteBuffer)
        
        If CCM_DataType31 = True Then
            DataLength = HexConvert(ByteBuffer, CCM_SizeData * 2)
            Rc = ByteSwap(ByteBuffer, CCM_SizeData * 2)
        
        Else
            DataLength = HexConvert(ByteBuffer, CCM_SizeData)
            If CCM_SizeData > 1 Then Rc = ByteSwap(ByteBuffer, CCM_SizeData)
        
        End If
    
    End If
    
    Rc = PASCAL_HEICCMRequest(aDevices(tDevice), bWrite, DataType, DataAddress, DataLength, ByteBuffer(0))
    If Rc <> 0 Then
        DisplayList.AddItem "Error " + Hex(Rc) + " (" + ShowHEIErrorText(Rc) + ") performing CCM Request"
    
    Else
        Dim i, k As Integer
        DetailLine = ""
        Dim l As String
        
        
        If CCM_CommandRead = True Then
            
            If CCM_DataType31 = True Or (CCM_DataType31 = False And CCM_SizeData > 1) Then
                Rc = ByteSwap(ByteBuffer, CCM_SizeData * 2)
            End If
            
            k = 0
            For i = 0 To DataLength - 1
                If CCM_DataType31 = True Then

                    l = Hex(ByteBuffer(i))
                    If Len(l) = 1 Then
                        DetailLine = DetailLine + "0"
                    End If
                    DetailLine = DetailLine + l
                    
                    k = k + 1
                    If k = 2 Then
                        DetailLine = DetailLine + " "
                        k = 0
                    End If
                Else
                    Dim One As String
                    One = Hex(ByteBuffer(i))
                    If Len(One) = 1 Then
                        DetailLine = DetailLine + "0" + One + " "
                    Else
                        DetailLine = DetailLine + Hex(ByteBuffer(i)) + " "
'                        DetailLine = DetailLine + Format(Hex(ByteBuffer(i)), "00") + " "
                    End If
                End If
            Next
            
            DisplayList.AddItem DetailLine
        
        Else
            If CCM_DataType31 = True Then
                DisplayList.AddItem "Successfully wrote" + Str(CCM_SizeData) + " WORD(s) of data"
            Else
                DisplayList.AddItem "Successfully wrote" + Str(CCM_SizeData) + " BYTE(s) of data"
            End If
            
        End If
    
    End If
    
End Sub


Private Sub Form_Load()
    
    ' set the default protocol to UDP/IP
    '
    UseIP = True
    DisplayOnlyECOMs = True
    
    ' set the initial button states
    '
    NetworkInit.Enabled = True
    ScanNetwork.Enabled = False
    Connect.Enabled = False
    Disconnect.Enabled = False
    
    CCM_CommandFrame.Enabled = False
    CCM_CommandRead.Enabled = False
    CCM_CommandWrite.Enabled = False

    CCM_DataTypeFrame.Enabled = False
    CCM_DataType31.Enabled = False
    CCM_DataType32.Enabled = False
    CCM_DataType33.Enabled = False
    
    CCM_SizeFrame.Enabled = False
    CCM_SizeData.Enabled = False
    CCM_SizeLabel.Enabled = False
    
    CCM_AddressFrame.Enabled = False
    CCM_AddressData.Enabled = False
    CCM_AddressLabel.Enabled = False
    
    CCM_WriteFrame.Enabled = False
    CCM_WriteData.Enabled = False
    
    CCM_SizeData.Text = 1
    CCM_WriteData.Text = "0000"
    
    CCM_ProcessCommand.Enabled = False
    
    DisplayList.Clear
        
End Sub

Private Sub ClearDisplay_Click()

    DisplayList.Clear
    
End Sub

Private Sub Exit_Click()
        
    Rc = PASCAL_HEICloseTransport(TP)
    Rc = PASCAL_HEIClose()
        
    Unload HostEthernetCCM
    
End Sub

' Determines if the selected device is a Terminator I/O EBC (T1H-EBC)
'
Private Function DeviceIsECOM(ByRef Device As HEIDevice) As Boolean

    Dim DDBuffer As DeviceDef
    Dim DDSize As Long
    DDSize = 42
    Dim eRc As Long
        
    eRc = PASCAL_HEIReadDeviceDef(Device, DDBuffer, DDSize)
    If eRc = 0 And DDBuffer.Device(2) = MT_ECOM Then 'And DDBuffer.Device(0) = MF_TERM Then
        DeviceIsECOM = True
    
    Else
        DeviceIsECOM = False
                
    End If

End Function

Private Function BuildTypeString(ByRef Device As HEIDevice, ByRef DDError As Boolean) As String
    
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' First
    ' Read the Device Definition Data
    '
    Dim DDBuffer As DeviceDef
    Dim DDSize As Long
    Dim t
    Dim eRc As Long

     
    DDSize = 42
     
    eRc = PASCAL_HEIReadDeviceDef(Device, DDBuffer, DDSize)
    If eRc <> 0 Then
        DDError = True
         
    Else
        ' device byte 0 determines the Module Family
        '
        ' device byte 2 determines the Module Type, MSB determines media type
        '
        Select Case DDBuffer.Device(2)
            Case MT_EBC
                Select Case DDBuffer.Device(0)
                    Case MF_005
                        t = "H0-"
                    Case MF_205
                        t = "H2-"
                    Case MF_305
                        t = "H3-"
                    Case MF_405
                        t = "H4-"
                    Case MF_TERM
                        t = "T1H-"
                End Select
                
                If (DDBuffer.Device(2) And &H80&) = &H80& Then
                    t = t + "EBC-F"
                Else
                    t = t + "EBC"
                End If
             
            Case MT_ECOM
                Select Case DDBuffer.Device(0)
                    Case MF_005
                        t = "H0-"
                    Case MF_205
                        t = "H2-"
                    Case MF_305
                        t = "H3-"
                    Case MF_405
                        t = "H4-"
                End Select
                
                If (DDBuffer.Device(2) And &H81&) = &H81& Then
                    t = t + "ECOM-F"
                Else
                    t = t + "ECOM"
                End If
             
            Case MT_WPLC
                Select Case DDBuffer.Device(0)
                    Case MF_005
                        t = "H0-"
                    Case MF_205
                        t = "H2-"
                    Case MF_305
                        t = "H3-"
                    Case MF_405
                        t = "H4-"
                End Select
                    
                t = t + "WPLC"
             
            Case MT_DRIVE
                Select Case DDBuffer.Device(0)
                    Case MF_100_SERIES
                        t = "HA-EDRV2"
                    Case MF_J300
                        t = "HA-EDRV3"
                    Case MF_300_Series
                        t = "HA-EDRV"
                    Case MF_GS
                        t = "GS-EDRV"
                End Select
            
            Case MT_ERMA
                Select Case DDBuffer.Device(0)
                    Case MF_005
                        t = "H0-"
                    Case MF_205
                        t = "H2-"
                    Case MF_305
                        t = "H3-"
                    Case MF_405
                        t = "H4-"
                End Select
                
                If (DDBuffer.Device(2) And &H84&) = &H84& Then
                    t = t + "ERM-F"
                Else
                    t = t + "ERM"
                End If
             
            Case MT_CTRIO
                    t = t + "CTRIO"
             
            Case MT_AVG_DISP
                    t = t + "EZTOUCH"
            
            Case MT_PBC
                    t = t + "PBC"
             
            Case MT_PBCC
                    t = t + "PBCC"
             
            Case MT_UNK
                    t = t + "UNKNOWN"
        End Select
             
    End If
                        
    If DDError = True Then
        BuildTypeString = " ??????????? "
    Else
        BuildTypeString = t
    End If

End Function

Private Function UseTypeString(ByRef Buffer() As Byte, Size As Integer) As String
    Dim i, t
    
    ' convert each byte to a printable character,
    For i = 0 To Size - 1
        If Buffer(i) > 0 Then
            t = t + Chr(Buffer(i))
        End If
    Next
    
    UseTypeString = t

End Function

' This function will extract and format the Ethernet (MAC) address from the HEIDevice buffer
'
Private Function GetMACFromBuffer(ByRef Buffer() As Byte) As String

    Dim y, t
    
    For y = 30 To 35
        If Buffer(y) = 0 Then
            t = t + "00 "
        Else
            'make sure each piece of the address has two digits by adding a leading 0 to
            'single digit values
            If Buffer(y) < 16 Then
                t = t + "0" + Hex(Buffer(y)) + " "
            Else
                t = t + Hex(Buffer(y)) + " "
            End If
        End If
    Next y
                    
    GetMACFromBuffer = t
    
End Function

' This function will format the IP address retrieved from DT_IP_ADDRESS
'
Private Function GetIPFromBuffer(ByRef Buffer() As Byte) As String
    
    Dim y, t
    
    For y = 0 To 3
         
        'make a printable version of each octet, add leading zeros to make all the octest three digits in length
        t = t + Format(StrConv(Buffer(y), 1, Len(Buffer(y))), "000")
         
        ' place a decimal point between the octets
        If y < 3 Then
            t = t + "."
        Else
            t = t + " "
        End If
         
    Next y

    GetIPFromBuffer = t
    
End Function

' This function will format the Node Number retrieved from DT_NODE_NUMBER
'
Private Function GetNodeNumberFromBuffer(ByRef Buffer() As Byte) As Long
    
    Dim tNN As Long
    
    ' the Node Number can be a 32bit number ( 4 bytes)
    '
    tNN = Buffer(0) + (Buffer(1) * 256&) + (Buffer(2) * 65536#) + (Buffer(3) * 16777216#)

    GetNodeNumberFromBuffer = tNN
    
End Function

' This function will format the Node Name retrieved from DT_NODE_NAME
'
Private Function GetNodeNameFromBuffer(ByRef Buffer() As Byte, Size As Integer) As String

    Dim i
    Dim NameText
    
    For i = 0 To Size - 1
        NameText = NameText + Chr(Buffer(i))
    Next

    GetNodeNameFromBuffer = NameText
    
End Function

' This function will format the Node Description retrieved from DT_NODE_DESCRIPTION
'
Private Function GetNodeDescFromBuffer(ByRef Buffer() As Byte, Size As Integer) As String

    Dim i
    Dim DescText
    
    For i = 0 To Size - 1
        DescText = DescText + Chr(Buffer(i))
    Next

    GetNodeDescFromBuffer = DescText

End Function
    
' This function will display some text for a given error code
'
Private Function ShowHEIErrorText(ErrorCode As Long) As String

    Select Case ErrorCode
        Case 32769:
            ShowHEIErrorText = "HEI Version Mismatch"
        
        Case 32771:
            ShowHEIErrorText = "Invalid Device"
        
        Case 32772:
            ShowHEIErrorText = "Data Buffer Too Small"
        
        Case 32774:
            ShowHEIErrorText = "Timeout Error"
        
        Case 32775:
            ShowHEIErrorText = "Unsupported Protocol"
        
        Case 32776:
            ShowHEIErrorText = "IP Address not Initialized"
            
        Case 32778:
            ShowHEIErrorText = "IPX Transport Not Initialized"
        
        Case 32779:
            ShowHEIErrorText = "Error Opening IPX Socket"
        
        Case 32784:
            ShowHEIErrorText = "Invalid Request"
        
        Case 32787:
            ShowHEIErrorText = "Data Too Large"
        
        Case 41079:
            ShowHEIErrorText = "Invalid Data"
        
        Case Else
            ShowHEIErrorText = "unknown"
    
    End Select
        
End Function
'***********************************************************************
' Since the PASCAL_HEIxxxx calls require a byte buffer, convert the user
' entered strings to byte arrays
'
Function StringToByteArray(ByVal inString As String, ByRef Buffer() As Byte) As Integer
Dim i
Dim u() As Byte
    
    'Make sure all alpha characters are uppercase
    u = StrConv(inString, vbUpperCase)
    
    'skip over the Unicode byte
    For i = 0 To (Len(inString) - 1)
        Buffer(i) = u(i * 2)
    Next i
            
    StringToByteArray = i
    
End Function

'***********************************************************************
' Swap successive entries in a byte array
'
Function ByteSwap(ByRef Buffer() As Byte, Count As Integer) As Integer
Dim i
Dim Temp As Byte

    For i = 0 To Count - 1 Step 2
        Temp = Buffer(i)
        Buffer(i) = Buffer(i + 1)
        Buffer(i + 1) = Temp
    Next i
                                    
    ByteSwap = i
    
End Function

'************************************************************************
' Convert a byte array of character codes to a packed array of characters
'
Function HexConvert(ByRef Buffer() As Byte, Count As Integer) As Integer
Dim i
                                
    'convert each character code
    For i = 0 To (Count * 2) - 1
        
        'have to manually process HEX character digits
        If (Buffer(i) > 64) And (Buffer(i) < 71) Then
            Select Case Buffer(i)
                Case 65 'A
                    Buffer(i) = 10
                Case 66 'B
                    Buffer(i) = 11
                Case 67 'C
                    Buffer(i) = 12
                Case 68 'D
                    Buffer(i) = 13
                Case 69 'E
                    Buffer(i) = 14
                Case 70 'F
                    Buffer(i) = 15
            End Select
        
        Else
            'numeric digits are much easier
            Buffer(i) = Chr(Buffer(i))
        
        End If
    
    Next i
    
    'Now pack two HEX characters into a byte
    Dim Z
    Z = 0
    For i = 0 To (Count * 2) - 1 Step 2
        Buffer(Z) = (Buffer(i) * 16) + Buffer(i + 1)
        Z = Z + 1
    Next i
    
    'Now clear the remainder of the byte array - just to be neat and complete
    For i = Z To (Count * 2) - 1
        Buffer(i) = 0
    Next i
    
    HexConvert = Z
    
End Function

'***********************************************************************
' Brute force method of converting a 4 character string to a HEX number
'
Function StringToHexInt(inData As String) As Integer
    
    Dim i
    Dim t(4) As Byte
    
    i = StringToByteArray(inData, t)
    
    'convert each character code
    For i = 0 To (Len(inData) - 1)
        
        'have to manually process HEX characters digits
        If (t(i) > 64) And (t(i) < 71) Then
            Select Case t(i)
                Case 65 'A
                    t(i) = 10
                Case 66 'B
                    t(i) = 11
                Case 67 'C
                    t(i) = 12
                Case 68 'D
                    t(i) = 13
                Case 69 'E
                    t(i) = 14
                Case 70 'F
                    t(i) = 15
            End Select
        
        Else
            'numeric digits are much easier
            t(i) = Chr(t(i))
        
        End If
    Next i
    
    Select Case Len(inData)
        Case 0
            StringToHexInt = 0
        Case 1
            StringToHexInt = t(0)
        Case 2
            StringToHexInt = (t(0) * 16) + t(1)
        Case 3
            StringToHexInt = (t(0) * 256) + (t(1) * 16) + t(2)
        Case 4
            StringToHexInt = (t(0) * 4096) + (t(1) * 256) + (t(2) * 16) + t(3)
    End Select

End Function
