VERSION 5.00
Begin VB.Form HostEthernetIO 
   Caption         =   "Host Ethernet I/O"
   ClientHeight    =   8145
   ClientLeft      =   60
   ClientTop       =   420
   ClientWidth     =   12420
   LinkTopic       =   "Form1"
   ScaleHeight     =   8145
   ScaleWidth      =   12420
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame T1HEBC_AO_PolarityFrame 
      Caption         =   "Setup Terminator I/O Analog Outputs"
      Height          =   735
      Left            =   4680
      TabIndex        =   57
      Top             =   2280
      Width           =   7575
      Begin VB.TextBox T1HEBC_AO_Slot 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   1680
         TabIndex        =   66
         Text            =   "1"
         Top             =   300
         Width           =   495
      End
      Begin VB.Frame T1HEBC_AO_RangeFrame 
         Height          =   735
         Left            =   4200
         TabIndex        =   60
         Top             =   0
         Width           =   3375
         Begin VB.CommandButton T1HEBC_AO_WriteSetup 
            Caption         =   "Write Setup Data"
            Height          =   375
            Left            =   1800
            TabIndex        =   64
            Top             =   240
            Width           =   1455
         End
         Begin VB.OptionButton T1HEBC_AO_5V 
            Caption         =   "5V"
            Height          =   255
            Left            =   840
            TabIndex        =   62
            Top             =   180
            Width           =   495
         End
         Begin VB.OptionButton T1HEBC_AO_10V 
            Caption         =   "10V"
            Height          =   255
            Left            =   840
            TabIndex        =   61
            Top             =   410
            Width           =   615
         End
         Begin VB.Label T1HEBC_AO_RangeLabel 
            Alignment       =   1  'Right Justify
            Caption         =   "Range:"
            Height          =   255
            Left            =   120
            TabIndex        =   63
            Top             =   300
            Width           =   615
         End
      End
      Begin VB.OptionButton T1HEBC_AO_BI 
         Caption         =   "Bipolar"
         Height          =   255
         Left            =   3120
         TabIndex        =   59
         Top             =   410
         Width           =   975
      End
      Begin VB.OptionButton T1HEBC_AO_UNI 
         Caption         =   "Unipolar"
         Height          =   255
         Left            =   3120
         TabIndex        =   58
         Top             =   180
         Width           =   975
      End
      Begin VB.Label T1HEBC_AO_Slot_Label 
         Alignment       =   1  'Right Justify
         Caption         =   "Slot number (1 - 16)"
         Height          =   255
         Left            =   120
         TabIndex        =   67
         Top             =   300
         Width           =   1455
      End
      Begin VB.Label T1HEBC_AO_PolarityLabel 
         Alignment       =   1  'Right Justify
         Caption         =   "Polarity:"
         Height          =   255
         Left            =   2400
         TabIndex        =   65
         Top             =   300
         Width           =   615
      End
   End
   Begin VB.Frame FRA_Setup_Frame 
      Caption         =   "Setup Fast Response Analog (T1F-08AD-2F)"
      Height          =   735
      Left            =   4680
      TabIndex        =   44
      Top             =   3120
      Width           =   7575
      Begin VB.TextBox FRA_Slot 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   1680
         TabIndex        =   47
         Text            =   "1"
         Top             =   285
         Width           =   495
      End
      Begin VB.TextBox FRA_Channels 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   5160
         TabIndex        =   46
         Text            =   "8"
         Top             =   285
         Width           =   495
      End
      Begin VB.CommandButton FRA_WriteSetup 
         Caption         =   "Write Setup Data"
         Height          =   375
         Left            =   6000
         TabIndex        =   45
         Top             =   240
         Width           =   1455
      End
      Begin VB.Label FRA_Slot_Label 
         Alignment       =   1  'Right Justify
         Caption         =   "Slot number (1 - 16)"
         Height          =   255
         Left            =   120
         TabIndex        =   49
         Top             =   300
         Width           =   1455
      End
      Begin VB.Label FRA_Channels_Label 
         Alignment       =   1  'Right Justify
         Caption         =   "Number of Channels to Enable (1 - 8)"
         Height          =   255
         Left            =   2400
         TabIndex        =   48
         Top             =   300
         Width           =   2655
      End
   End
   Begin VB.Frame DisplayDevicesFrame 
      Caption         =   "Devices"
      Height          =   855
      Left            =   120
      TabIndex        =   41
      Top             =   1080
      Width           =   1335
      Begin VB.OptionButton DisplayOnlyEbcs 
         Caption         =   "Only EBCs"
         Height          =   255
         Left            =   120
         TabIndex        =   43
         Top             =   240
         Width           =   1095
      End
      Begin VB.OptionButton DisplayAllDevices 
         Caption         =   "All Devices"
         Height          =   255
         Left            =   120
         TabIndex        =   42
         Top             =   480
         Width           =   1095
      End
   End
   Begin VB.CommandButton NetworkInit 
      Caption         =   "Init Network"
      Height          =   375
      Left            =   1560
      TabIndex        =   40
      Top             =   120
      Width           =   1215
   End
   Begin VB.Timer ReadIO_Loop_Timer 
      Enabled         =   0   'False
      Interval        =   250
      Left            =   120
      Top             =   2040
   End
   Begin VB.CommandButton WriteIO 
      Caption         =   "Write I/O Data"
      Height          =   375
      Left            =   4800
      TabIndex        =   11
      Top             =   1680
      Width           =   1695
   End
   Begin VB.Frame WIO_Frame 
      Caption         =   "Write I/O Setup"
      Height          =   2055
      Left            =   4680
      TabIndex        =   14
      Top             =   120
      Width           =   7575
      Begin VB.OptionButton WIO_2Analog 
         Caption         =   "  2 Ch Analog"
         Height          =   255
         Left            =   2040
         TabIndex        =   56
         ToolTipText     =   "Select a 2 channel analog output module"
         Top             =   960
         Width           =   1335
      End
      Begin VB.OptionButton WIO_8Discrete 
         Caption         =   "  8 pt Discrete"
         Height          =   285
         Left            =   2040
         TabIndex        =   55
         Top             =   240
         Width           =   1335
      End
      Begin VB.OptionButton WIO_8Analog 
         Caption         =   "  8 Ch Analog"
         Height          =   255
         Left            =   4680
         TabIndex        =   54
         ToolTipText     =   "Select an 8 channel analog output module"
         Top             =   960
         Width           =   1335
      End
      Begin VB.OptionButton WIO_32Discrete 
         Caption         =   "32 pt Discrete"
         Height          =   285
         Left            =   2040
         TabIndex        =   53
         Top             =   480
         Width           =   1335
      End
      Begin VB.TextBox WIO_64DiscreteData 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   5880
         TabIndex        =   52
         Text            =   "8765432187654321"
         Top             =   480
         Width           =   1575
      End
      Begin VB.OptionButton WIO_64Discrete 
         Caption         =   "64 pt Discrete"
         Height          =   255
         Left            =   4560
         TabIndex        =   51
         Top             =   495
         Width           =   1335
      End
      Begin VB.TextBox WIO_32DiscreteData 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   3480
         TabIndex        =   50
         Text            =   "87654321"
         Top             =   480
         Width           =   855
      End
      Begin VB.TextBox WIO_Analog_Ch16 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   6240
         MaxLength       =   5
         TabIndex        =   39
         Text            =   "0"
         ToolTipText     =   "12-bit (0-4095) or 16-bit (0-65535) value"
         Top             =   1680
         Width           =   495
      End
      Begin VB.TextBox WIO_Analog_Ch15 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   5640
         MaxLength       =   5
         TabIndex        =   38
         Text            =   "0"
         ToolTipText     =   "12-bit (0-4095) or 16-bit (0-65535) value"
         Top             =   1680
         Width           =   495
      End
      Begin VB.TextBox WIO_Analog_Ch14 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   5040
         MaxLength       =   5
         TabIndex        =   37
         Text            =   "0"
         ToolTipText     =   "12-bit (0-4095) or 16-bit (0-65535) value"
         Top             =   1680
         Width           =   495
      End
      Begin VB.TextBox WIO_Analog_Ch13 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   4440
         MaxLength       =   5
         TabIndex        =   36
         Text            =   "0"
         ToolTipText     =   "12-bit (0-4095) or 16-bit (0-65535) value"
         Top             =   1680
         Width           =   495
      End
      Begin VB.TextBox WIO_Analog_Ch12 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   3840
         MaxLength       =   5
         TabIndex        =   35
         Text            =   "0"
         ToolTipText     =   "12-bit (0-4095) or 16-bit (0-65535) value"
         Top             =   1680
         Width           =   495
      End
      Begin VB.TextBox WIO_Analog_Ch11 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   3240
         MaxLength       =   5
         TabIndex        =   34
         Text            =   "0"
         ToolTipText     =   "12-bit (0-4095) or 16-bit (0-65535) value"
         Top             =   1680
         Width           =   495
      End
      Begin VB.TextBox WIO_Analog_Ch10 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   2640
         MaxLength       =   5
         TabIndex        =   33
         Text            =   "0"
         ToolTipText     =   "12-bit (0-4095) or 16-bit (0-65535) value"
         Top             =   1680
         Width           =   495
      End
      Begin VB.TextBox WIO_Analog_Ch9 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   2040
         MaxLength       =   5
         TabIndex        =   32
         Text            =   "0"
         ToolTipText     =   "12-bit (0-4095) or 16-bit (0-65535) value"
         Top             =   1680
         Width           =   495
      End
      Begin VB.OptionButton WIO_16Analog 
         Caption         =   "16 Ch Analog"
         Height          =   255
         Left            =   6120
         TabIndex        =   23
         Top             =   960
         Width           =   1335
      End
      Begin VB.TextBox WIO_Analog_Ch7 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   5640
         MaxLength       =   5
         TabIndex        =   30
         Text            =   "0"
         ToolTipText     =   "12-bit (0-4095) or 16-bit (0-65535) value"
         Top             =   1320
         Width           =   495
      End
      Begin VB.TextBox WIO_Analog_Ch6 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   5040
         MaxLength       =   5
         TabIndex        =   29
         Text            =   "0"
         ToolTipText     =   "12-bit (0-4095) or 16-bit (0-65535) value"
         Top             =   1320
         Width           =   495
      End
      Begin VB.OptionButton WIO_4Analog 
         Caption         =   "  4 Ch Analog"
         Height          =   255
         Left            =   3360
         TabIndex        =   22
         ToolTipText     =   "Select a 4 channel analog output module"
         Top             =   960
         Width           =   1335
      End
      Begin VB.TextBox WIO_Analog_Ch8 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   6240
         MaxLength       =   5
         TabIndex        =   31
         Text            =   "0"
         ToolTipText     =   "12-bit (0-4095) or 16-bit (0-65535) value"
         Top             =   1320
         Width           =   495
      End
      Begin VB.TextBox WIO_Analog_Ch5 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   4440
         MaxLength       =   5
         TabIndex        =   28
         Text            =   "0"
         ToolTipText     =   "12-bit (0-4095) or 16-bit (0-65535) value"
         Top             =   1320
         Width           =   495
      End
      Begin VB.TextBox WIO_Analog_Ch4 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   3840
         MaxLength       =   5
         TabIndex        =   27
         Text            =   "0"
         ToolTipText     =   "12-bit (0-4095) or 16-bit (0-65535) value"
         Top             =   1320
         Width           =   495
      End
      Begin VB.TextBox WIO_Analog_Ch3 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   3240
         MaxLength       =   5
         TabIndex        =   26
         Text            =   "0"
         ToolTipText     =   "12-bit (0-4095) or 16-bit (0-65535) value"
         Top             =   1320
         Width           =   495
      End
      Begin VB.TextBox WIO_8DiscreteData 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   3480
         MaxLength       =   2
         TabIndex        =   21
         Text            =   "21"
         Top             =   240
         Width           =   375
      End
      Begin VB.TextBox WIO_Analog_Ch1 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   2040
         MaxLength       =   5
         TabIndex        =   24
         Text            =   "0"
         ToolTipText     =   "12-bit (0-4095) or 16-bit (0-65535) value"
         Top             =   1320
         Width           =   495
      End
      Begin VB.TextBox WIO_Analog_Ch2 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   2640
         MaxLength       =   5
         TabIndex        =   25
         Text            =   "0"
         ToolTipText     =   "12-bit (0-4095) or 16-bit (0-65535) value"
         Top             =   1320
         Width           =   495
      End
      Begin VB.TextBox WIO_16DiscreteData 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   5880
         TabIndex        =   19
         Text            =   "4321"
         Top             =   240
         Width           =   495
      End
      Begin VB.TextBox WIO_Slot 
         Alignment       =   2  'Center
         Height          =   285
         Left            =   600
         MaxLength       =   2
         TabIndex        =   16
         Text            =   "0"
         Top             =   480
         Width           =   495
      End
      Begin VB.TextBox WIO_Base 
         Alignment       =   2  'Center
         BeginProperty DataFormat 
            Type            =   0
            Format          =   "0"
            HaveTrueFalseNull=   0
            FirstDayOfWeek  =   0
            FirstWeekOfYear =   0
            LCID            =   1033
            SubFormatType   =   0
         EndProperty
         Height          =   285
         Left            =   600
         MaxLength       =   1
         TabIndex        =   15
         Text            =   "0"
         Top             =   240
         Width           =   495
      End
      Begin VB.OptionButton WIO_16Discrete 
         Caption         =   "16 pt Discrete"
         Height          =   285
         Left            =   4560
         TabIndex        =   18
         Top             =   240
         Width           =   1335
      End
      Begin VB.Line Line1 
         X1              =   2040
         X2              =   7440
         Y1              =   840
         Y2              =   840
      End
      Begin VB.Label WIO_Slot_Label 
         Alignment       =   1  'Right Justify
         Caption         =   "Slot"
         Height          =   255
         Left            =   120
         TabIndex        =   20
         Top             =   495
         Width           =   375
      End
      Begin VB.Label WIO_Base_Label 
         Alignment       =   1  'Right Justify
         Caption         =   "Base"
         Height          =   255
         Left            =   120
         TabIndex        =   17
         Top             =   255
         Width           =   375
      End
   End
   Begin VB.CommandButton TIOBaseInit 
      Caption         =   "Reinitialize Base"
      Height          =   375
      Left            =   2880
      TabIndex        =   13
      Top             =   1560
      Width           =   1695
   End
   Begin VB.CommandButton ReadIOLoop 
      Caption         =   "Read I/O Continuous"
      Height          =   375
      Left            =   2880
      TabIndex        =   12
      Top             =   1080
      Width           =   1695
   End
   Begin VB.CommandButton ReadIO 
      Caption         =   "Read I/O Once"
      Height          =   375
      Left            =   2880
      TabIndex        =   10
      Top             =   600
      Width           =   1695
   End
   Begin VB.CommandButton Disconnect 
      Caption         =   "Disconnect"
      Height          =   375
      Left            =   1560
      TabIndex        =   9
      Top             =   1560
      Width           =   1215
   End
   Begin VB.CommandButton Exit 
      Caption         =   "Exit"
      Height          =   375
      Left            =   2400
      TabIndex        =   8
      Top             =   3480
      Width           =   2175
   End
   Begin VB.Frame ProtocolFrame 
      Caption         =   "Protocol"
      Height          =   855
      Left            =   120
      TabIndex        =   5
      Top             =   120
      Width           =   1335
      Begin VB.OptionButton UseIP 
         Caption         =   "UDP/IP"
         Height          =   255
         Left            =   120
         TabIndex        =   7
         Top             =   240
         Width           =   975
      End
      Begin VB.OptionButton UseIPX 
         Caption         =   "IPX"
         Height          =   255
         Left            =   120
         TabIndex        =   6
         Top             =   480
         Width           =   975
      End
   End
   Begin VB.CommandButton ShowBaseConfig 
      Caption         =   "Show Base Config"
      Height          =   375
      Left            =   2880
      TabIndex        =   4
      Top             =   120
      Width           =   1695
   End
   Begin VB.CommandButton Connect 
      Caption         =   "Connect"
      Height          =   375
      Left            =   1560
      TabIndex        =   3
      Top             =   1080
      Width           =   1215
   End
   Begin VB.CommandButton ClearDisplay 
      Caption         =   "Clear Display"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   3480
      Width           =   2175
   End
   Begin VB.ListBox DisplayList 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4110
      Left            =   120
      TabIndex        =   1
      Top             =   3960
      Width           =   12135
   End
   Begin VB.CommandButton ScanNetwork 
      Caption         =   "Scan Network"
      Height          =   375
      Left            =   1560
      TabIndex        =   0
      Top             =   600
      Width           =   1215
   End
End
Attribute VB_Name = "HostEthernetIO"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit                 ' Must explicitly declare variable types

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' HEI API Defines
'
    Const HEIAPIVersion As Byte = 3
    Const HEIAPIVersionString As String = "3"
    Const HEIP_HOST As Integer = 1
    Const HEIP_IPX As Integer = 2
    Const HEIP_IP As Integer = 3
    Const HEIT_HOST As Integer = 1
    Const HEIT_IPX As Integer = 2
    Const HEIT_WINSOCK As Integer = 4
    
    Const DefDevTimeout As Integer = 50                        ' value in milliseconds
    Const LongDevTimeout As Integer = DefDevTimeout + 200      ' value in milliseconds
    Const DefDevRetrys As Byte = 3
    Const DefDevUseAddressedBroadcast As Boolean = False

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Error Messages
'
    Const HEIE_NULL As Integer = 0                              ' No error
    Const HEIE_FIRST_ERROR As Integer = &H8000                  ' Number for first error
    Const HEIE_LAST_ERROR As Integer = &HFFFF                   ' Number for last error
    Const HEIE_NOT_IMPLEMENTED As Integer = &H8000              ' Function not implemented
    Const HEIE_VER_MISMATCH As Integer = &H8001                 ' Version passed to function is not correct for the library
    Const HEIE_UNSUPPORTED_TRANSPORT As Integer = &H8002        ' Supplied transport is not supported
    Const HEIE_INVALID_DEVICE As Integer = &H8003               ' Supplied device is not valid
    Const HEIE_BUFFER_TOO_SMALL As Integer = &H8004             ' Supplied buffer is too small
    Const HEIE_ZERO_BYTES_RECEIVED As Integer = &H8005          ' Zero packets returned in the packet
    Const HEIE_TIMEOUT As Integer = &H8006                      ' Timeout error
    Const HEIE_UNSUPPORTED_PROTOCOL As Integer = &H8007         ' Supplied protocol not supported
    Const HEIE_IP_ADDRESS_NOT_INITIALIZED As Integer = &H8008   ' The device's IP address has not been assigned
    Const HEIE_NULL_TRANSPORT As Integer = &H8009               ' No Transport specified
    Const HEIE_IPX_NOT_INITIALIZED As Integer = &H800A          ' IPX Transport not installed
    Const HEIE_IPX_OPEN_SOCKET As Integer = &H800B              ' Error opening IPX socket
    Const HEIE_NO_PACKET_DRIVER As Integer = &H800C             ' No packet driver found
    Const HEIE_CRC_MISMATCH As Integer = &H800D                 ' CRC did not match
    Const HEIE_ALLOCATION_ERROR As Integer = &H800E             ' Memory allocation failed
    Const HEIE_NO_IPX_CACHE As Integer = &H800F                 ' No cache has been allocated for IPX
    Const HEIE_INVALID_REQUEST As Integer = &H8010              ' Invalid CCM Request
    Const HEIE_NO_RESPONSE As Integer = &H8011                  ' No response was available/requested
    Const HEIE_INVALID_RESPONSE As Integer = &H8012             ' Invalid format response was received
    Const HEIE_DATA_TOO_LARGE As Integer = &H8013               ' Given data is too large
    Const HEIE_LOAD_PROC_ERROR As Integer = &H8014              ' Error loading procedures
    Const HEIE_NOT_LOADED As Integer = &H8015                   ' Attempted command before succesfull OpenTransport()
    Const HEIE_LOAD_ERROR As Integer = &H9000                   ' Error on loading

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' If PASCAL_HEIOpenTransport()fails for WinSock, it will return one of the following errors:
'
' &h8014    Error getting address from WinSock.DLL
' &h8100    System was out of memory, or executable file was corrupt, or sharing or network-protection error
' &h8101    Unused
' &h8102    file was not found
' &h8103    Path was not found
' &h8104    Unused
' &h8105    Attempt was made to dynamically link to a task, or there was a sharing or network-protection error
' &h8106    Library required separate data segments for each task
' &h8107    Unused
' &h8108    There was insufficient memory to start the application
' &h8109    Unused
' &h810A    Windows version was incorrect
' &h810B    Executable file was invalid, it's either not a Windows application or there was an error in the .EXE image.
' &h810C    Application was designed for a different operating system
' &h810D    Application was designed for MS-DOS 4.0
' &h810E    Type of executable was unknown
' &h810F    Attempt was made to load a real-mode application (developed for an earlier version of Windows )
' &h8110    Attempt was made to load a second instance of an application file containing multiple data segments that were not marked read-only
' &h8113    Attempt was made to load a compressed executable file. The file must be decompressed before it can be loaded
' &h8114    Dynamic-link library (DLL) file was invalid. One of the DLLs required to run this application was corrupt
' &h8115    Application requires Microsoft Windows 32-bit extensions
'
    
    Const HEIE_INVALID_SLOT_NUMBER   As Integer = 118
    Const HEIE_INVALID_DATA          As Integer = 119
    Const HEIE_CHANNEL_FAILURE       As Integer = 121   ' Analog I/O, broken transmitter alarm, for modules with
                                                        '  one error bit for all channels
    Const HEIE_UNUSED_CHANNELS_EXIST As Integer = 122   ' Analog I/O, module jumpers set to disable some channels
    Const HEIE_INVALID_BASE_NUMBER   As Integer = 135
    Const HEIE_INVALID_MODULE_TYPE   As Integer = 136
    Const HEIE_INVALID_OFFSET        As Integer = 137
    Const HEIE_BROKEN_TRANSMITTER    As Integer = 139
    Const HEIE_INVALID_ADDRESS       As Integer = 140
    Const HEIE_CHANNEL_FAILURE_MULTI As Integer = 142   ' Analog I/O, broken transmitter alarm, for modules with
                                                        '  an error bit for each channel, e.g. F2-04RTD
    Const HEIE_SERIAL_SETUP_ERROR    As Integer = 143
    Const HEIE_MODULE_ERROR          As Integer = 152
    Const HEIE_MODULE_NOT_RESPONDING As Integer = 153   ' T1H-EBC, Hot-Swap, module removed
    Const HEIE_BASE_CHANGED          As Integer = 154   ' T1H-EBC, Hot-Swap, module added
    Const HEIE_MODULE_FAILURE        As Integer = 155
    Const HEIE_PARITY_ERROR          As Integer = 156
    Const HEIE_FRAMING_ERROR         As Integer = 157
    Const HEIE_OVER_RUN_ERROR        As Integer = 158
    Const HEIE_BUFFER_OVERFLOW       As Integer = 159
    Const HEIE_DRIVE_TRIP            As Integer = 162   ' HA-EDRV2, Drive has tripped
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Terminator Hot-Swap Defines, Used in HEIRescanBase()
'
    Const RESCAN_LEAVE_IMAGE_RAM = 0                    ' Don't clear the output image RAM after BaseInit
    Const RESCAN_CLEAR_IMAGE_RAM = 1                    ' Clear the output image RAM after BaseInit
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Warnings
'
    Const HEIW_FIRST_WARNING As Integer = &H4000        ' Number for First Warning
    Const HEIW_LAST_WARNING As Integer = &H4FFF         ' Number for Last Warning
    Const HEIW_RETRY As Integer = &H4000                ' One or More Retrys have occurred

' These are masks for values returned from HEIReadIO and/or HEIWriteIO and indicate that some
' error/warning/info/internal condition exists for some module in the base ( it could be an I/O
' module or it could be the ethernet module. The function HEIReadModuleStatus can then be used
' to retrieve the actual conditions. Note that more than one of the conditions can exist at any time.
'
    Const MASK_DEVICE_ERROR As Integer = &H1000
    Const MASK_DEVICE_WARNING As Integer = &H2000
    Const MASK_DEVICE_INFO As Integer = &H4000

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Data Types
'
    Const DT_IP_ADDRESS As Integer = &H10               ' 4-byte IP Address
    Const DT_SERIAL_SETTINGS As Integer = &H11          ' 8 Byte Serial Setup
    Const DT_RXWX_SETTINGS As Integer = &H15            ' 128 Byte setings for RXWX configuration
    Const DT_NODE_NAME As Integer = &H16                ' 256-byte Node Name
    Const DT_BASE_DEF As Integer = &H17                 ' 512 Byte Base Definition (405 HEIWriteBaseDef)
    Const DT_NODE_NUMBER As Integer = &H20              ' 4-byte Node Number
    Const DT_MODULE_SETUP As Integer = &H24             ' 64-byte data from FLASH (see ModuleSetup structure)
    Const DT_DESCRIPTION As Integer = &H26              ' 256-byte Node Description
    Const DT_SUBNET_MASK As Integer = &H30              ' 4-byte Subnet Mask
    Const DT_TYPE_STRING As Integer = &H33              ' 32 byte string that contains the part number
    Const DT_LINK_MONITOR As Integer = &H8006           ' 256 Byte Link monitor setup

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Data Formats
'
    Const DF_BIT_IN As Byte = &H3
    Const DF_BIT_OUT As Byte = &H4
    Const DF_WORD_IN As Byte = &H5
    Const DF_WORD_OUT As Byte = &H6
    Const DF_DWORD_IN As Byte = &H8
    Const DF_DWORD_OUT As Byte = &H9
    Const DF_BYTE_IN As Byte = &H10
    Const DF_BYTE_OUT As Byte = &H11
    Const DF_DOUBLE_IN As Byte = &H12
    Const DF_DOUBLE_OUT As Byte = &H13
    Const DF_FLOAT_IN As Byte = &H14
    Const DF_FLOAT_OUT As Byte = &H15
    Const DF_CONFIG As Byte = &H16

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Module Types
'
    Const MT_EBC As Integer = 0                         ' Ethernet Base Controller
    Const MT_ECOM As Integer = 1                        ' Ethernet Communications Module
    Const MT_WPLC As Integer = 2                        ' WinPLC
    Const MT_DRIVE As Integer = 3                       ' Ethernet Drive Interface
    Const MT_ERMA As Integer = 4                        ' Ethernet Remote Master
    Const MT_CTRIO As Integer = 5                       ' Counter Interface
    Const MT_AVG_DISP As Integer = 6                    ' AVG Display Adapter
    Const MT_PBC As Integer = 7                         ' Profibus Slave controller
    Const MT_PBCC As Integer = 8                        ' Profibus Slave Communications Module (PSCM)
    Const MT_UNK As Integer = &HFF                      ' Unknown
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Module Family defines for MT_EBC, MT_ECOM, MT_EDRV, MT_ERMA and MT_WPLC
'
    Const MF_005 As Integer = 0                         ' DL05 Series
    Const MF_205 As Integer = 2                         ' DL205 Series
    Const MF_305 As Integer = 3                         ' DL305 Series
    Const MF_405 As Integer = 4                         ' DL405 Series
    Const MF_TERM As Integer = 10                       ' Terminator I/O Series
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Module Family defines for MT_DRIVE
'
    Const MF_100_SERIES As Integer = 1                  ' Hitachi L100 and SJ100
    Const MF_J300 As Integer = 2                        ' Hitachi J300
    Const MF_300_Series As Integer = 3                  ' Hitachi SJ300
    Const MF_GS As Integer = 4                          ' AutomationDirect GSx
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Module Family defines for MT_AVG_DISP
'
    Const MF_EZ_TOUCH As Integer = 1                    ' AVG EZ-Touch Ethernet Adapter
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Structure Definitions
'
    Private Type EthernetStats
        SizeOfEthernetStats As Integer
        MissedFrameCount As Long
        TransmitCollisionCount As Long
        DiscardedPackets As Long
        BadCRCCount As Long
        UnknownTypeCount As Long
        SendErrorCount As Long
    End Type
    
    Private Type SupportDef
        Version As Byte
        Bytes2Follow As Byte
        UnusedBytes(15) As Byte
        'bit fields in Byte 1
        'FUN_POLLING As Byte             ' Polling one base
        'FUN_READ_VER_INFO As Byte       ' Version Info
        'FUN_READ_SUPPORT_INFO As Byte   ' Support Info
        'FUN_READ_DEVICE_INFO As Byte    ' Device Info
        'FUN_POLLING_ALL As Byte         ' Polling All bases (returns ethernet address)
        'FUN_WRITE_IO As Byte            ' Write IO Base
        'FUN_READ_IO As Byte             ' Read IO Base
        '
        'bit fields in Byte 2
        'FUN_READ_BASE_DEF As Byte       ' Read Base Def
        'FUN_ENUM_SETUP_DATA As Byte     ' Emunerate the Setup Data
        'FUN_READ_SETUP_DATA As Byte     ' Read Setup Data
        'FUN_WRITE_SETUP_DATA As Byte    ' Write Setup Data
        'FUN_DELETE_SETUP_DATA As Byte   ' Delete Setup Data
        'FUN_READ_ETHERNET_STATS As Byte ' Read Ethernet Statistics
        'FUN_PET_LINK As Byte            ' Used to keep the link sense timer from firing in the absense of ReadIO or WriteIO messages
        'FUN_ADDRESSED_BROADCAST As Byte ' Used to broadcast to a particular ethernet address
        '
        'bit fields in Byte 3
        'FUN_READ_MODULE_STATUS As Byte  ' Read module status (short bytes)
        'FUN_EXTENDED As Byte            ' Extended function
        'FUN_QUERY_SETUP_DATA As Byte    ' Query for particular data type/value
        'FUN_INIT_BASE_DEF As Byte       ' Initialize base def from backplane
        'FUN_DATA_BROADCAST As Byte      ' Broadcast to a particular data type
        'FUN_CCM_REQUEST As Byte         ' Perform CCM Request
        'FUN_KSEQ_REQUEST As Byte        ' Perform a KSequence Request
        'FUN_BACKPLANE_REQUEST As Byte   ' Perform backplane request
    End Type
    
    Private Type SerialSetup
        BaudRate As Long
        ConfigData(2) As Byte
        'bit fields in Byte 1
        ' StopBits
        ' DataBits
        ' Parity
        ' Mode
        ' Reserved
    End Type
    
    Private Type VersionDef
        'MajorVersion As Byte
        'MinorVersion As Byte
        'BuildVersion As Integer
        VBuffer(3) As Byte
    End Type
    
    Private Type VersionInfoDef
        'SizeofVersionInfo As Byte
        'BootVersion As VersionDef
        'OSVersion As VersionDef
        'NumOSExtensions As Byte
        'OSExt(9) As VersionDef
        Version(51) As Byte
    End Type
    
    Private Type DeviceDef
        'PLCFamily As Byte               ' See MF_XXX (Family) defines
        'Unused1 As Byte
        'ModuleType As Byte              ' See MT_XXX (Type) Defines
        'StatusCode As Byte
        'EthernetAddress(5) As Byte      ' Hardware Ethernet Address
        'RamSize As Integer              ' in K-byte increments
        'FlashSize As Integer            ' in K-byte increments
        'DipSettings As Byte             ' setting of the 8 element dip switch
        'MediaType As Byte               ' 0= 10Base-T,1= 10Base-F
        'EPFCount As Long                ' Early Power Fail Count - 405 only
        'Status As Byte                  '   Status:1 = Run Relay Status
        '                                '   Status:2 = Battery Low Indicator
        '                                '   Status:6 = unused bits
        'BattRamSize As Integer          ' size (in K-bytes) of the battery-backed RAM
        'ExtraDIPs As Byte               ' extra DIP switches on Terminator I/O
        'ModelNumber As Byte             ' used by WinPLC
        'EtherSpeed As Byte              ' 0 = 10Mbit, 1 = 100Mbit
        'PLDRev(1) As Byte               ' PLD revision number
        'unused(14) As Byte
        Device(41) As Byte               ' 42-byte byte array (VB packs on 4-byte boundaries)
    End Type
    
    Private Type LinkMonitor
        'Timeout As Long                 ' 0= don't use Link Monitor
        'Mode As Byte                    ' 0= Clear Outputs
        '                                ' 1= Use pattern
        Data(255) As Byte                ' Pattern, same format as used for HEIWriteIO
    End Type
    
    Private Type MemoryTypeDef
        Type As Integer
        Size As Long
        unused(3) As Long
    End Type
    
    Private Type Encryption
        'Algorithm As Byte               ' Algorithm to use for encryption:
        '                                '   0= No encryption
        '                                '   1= private key encryption
        'Unused1(2) As Byte              ' Reserved
        'Key(59) As Byte                 ' Encryption key (null terminated)
        Data(63) As Byte
    End Type
    
    Private Type EnetAddress
        'union
        '{
        '   ' Use this for HEIP_HOST protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_UNSPEC == 0
        '       char Nodenum[6];            ' Ethernet network address
        '       unsigned short LANNum;      ' Lana number
        '   }  AddressHost;
        '
        '   ' Use this for HEIP_IPX protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_IPX == 6
        '       char Netnum[4];             ' Network Number
        '       char Nodenum[6];            ' Ethernet network address
        '       unsigned short Socket;      ' Socket Number == 0x7070
        '   } AddressIPX;
        '
        '   ' Use this for HEIP_IP protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_INET == 2
        '       unsigned short Port;        ' Port number == 0x7070
        '       union
        '       {
        '           struct { unsigned char b1, b2, b3, b4; } bAddr;  ' Byte Addressing
        '           struct { unsigned short w1, w2; } wAddr;         ' Word addressing
        '           unsigned long lAddr;                             ' DWord addressing
        '       } AddressingType;
        '       char Zero[8];               ' initialize to zeros
        '   } AddressIP;
        '
        '   struct
        '   {
        '       Byte    Commport;
        '       Byte    ByteSize;
        '       Byte    Parity;
        '       Byte    StopBits;
        '       Long    Baud;
        '       Long    *hLocal;
        '   } AddressSerial;
        '
        '   BYTE Raw[20];
        '
        '}Address
        '
        Address(19) As Byte
    End Type
    
    
    Private Type HEITransport
        'Transport As Integer           = 2 bytes
        'Protocol As Integer            = 2 bytes
        'Encrypt As Encryption          = 64 bytes
        'SourceAddress As EnetAddress   = 20 bytes
        'Reserved(47) As Byte           = 48 bytes
        Data(135) As Byte
    End Type
    
    Private Type HEIDevice
        'union
        '{
        '   ' Use this for HEIP_HOST protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_UNSPEC == 0
        '       char Nodenum[6];            ' Ethernet network address
        '       unsigned short LANNum;      ' Lana number
        '   }  AddressHost;
        '
        '   ' Use this for HEIP_IPX protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_IPX == 6
        '       char Netnum[4];             ' Network Number
        '       char Nodenum[6];            ' Ethernet network address
        '       unsigned short Socket;      ' Socket Number == 0x7070
        '   } AddressIPX;
        '
        '   ' Use this for HEIP_IP protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_INET == 2
        '       unsigned short Port;        ' Port number == 0x7070
        '       union
        '       {
        '           struct { unsigned char b1, b2, b3, b4; } bAddr;  ' Byte Addressing
        '           struct { unsigned short w1, w2; } wAddr;         ' Word addressing
        '           unsigned long lAddr;                             ' DWord addressing
        '       } AddressingType;
        '       char Zero[8];               ' initialize to zeros
        '   } AddressIP;
        '
        '   struct
        '   {
        '       Byte    Commport;
        '       Byte    ByteSize;
        '       Byte    Parity;
        '       Byte    StopBits;
        '       Long    Baud;
        '       Long    *hLocal;
        '   } AddressSerial;
        
        '   BYTE Raw[20];
        '}Address
        '
        'wParam As Integer
        'dw_Param As Long
        'Timeout As Integer             ' Timeout value in ms
        'Retrys As Integer              ' Number of times to retry a transaction
        'EnetAddress(5) As Byte         ' Address placed here in HEIQueryDevice(s)
        'RetryCount As Integer          ' number of retrys that have occurred
        'BadCRCCount As Integer         ' number of packets received with a bad CRC
        'LatePacketCount As Integer     ' number of packets received after a timeout
        'ParallelPackets As Boolean     ' If set TRUE, (after HEIOpenDevice), will enable application
                                        ' to send multiple HEIReadIO, HEIWriteIO, HEICCMRequest or
                                        ' HEIKseqRequest transactions to different devices before waiting
                                        ' for any reponses. The application will then need to implement
                                        ' it's own timeout/retry mechanism while waiting on responses.
                                        ' Use HEIGetResponse() to see if responses have arrived.
                                        ' NOTE: do not send multiple requests to a single device.
        '
        'Internal Use Only -- Do Not Touch !!--
        'UseAddressedBroadcast As Boolean
        'UseBroadcast As Boolean
        'dwParam As Long
        'DataOffset As Integer
        'pTransport As Long
        'SizeOfData As Long
        'pData As Long
        'pBuffer As Long
        'LastAppVal As Integer
        'Byte UseProxy
        'Byte ProxyBase
        'Byte ProxySlot
        'Byte ProxyDevNum
        'Bytes Reserved(44)
        Address(125) As Byte             ' 126-byte byte array (VB packs on 4-byte boundaries)
    End Type
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Host Ethernet APIs
'
    Private Declare Function PASCAL_HEIOpen Lib "hei_pas" ( _
        ByVal HEIAPIVersion As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIClose Lib "hei_pas" ( _
    ) As Long
   
    Private Declare Function PASCAL_HEIOpenTransport Lib "hei_pas" ( _
        ByRef pTransport As HEITransport, _
        ByVal HEIAPIVersion As Integer, _
        ByRef SrcAddress As EnetAddress _
    ) As Long

'    Private Declare Function PASCAL_HEIOpenTransport Lib "hei_pas" ( _
'        ByRef pTransport As HEITransport, _
'        ByVal HEIAPIVersion As Integer, _
'        ByVal SourceAddress As Long _
'    ) As Long
    
    Private Declare Function PASCAL_HEICloseTransport Lib "hei_pas" ( _
        ByRef pTransport As HEITransport _
    ) As Long
    
    Private Declare Function PASCAL_HEIOpenDevice Lib "hei_pas" ( _
        ByRef pTransport As HEITransport, _
        ByRef pDevice As HEIDevice, _
        ByVal HEIAPIVersion As Integer, _
        ByVal Timeout As Integer, _
        ByVal Retrys As Integer, _
        ByVal UseAddressedBroadcast As Boolean _
    ) As Long
    
    Private Declare Function PASCAL_HEICloseDevice Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice _
    ) As Long
    
    Private Declare Function PASCAL_HEIGetQueryTimeout Lib "hei_pas" ( _
    ) As Long
    
    Private Declare Function PASCAL_HEISetQueryTimeout Lib "hei_pas" ( _
        ByVal NewTimeout As Long _
    ) As Long
    
    Private Declare Function PASCAL_HEIQueryDevices Lib "hei_pas" ( _
        ByRef pTransport As HEITransport, _
        ByRef pDevice As HEIDevice, _
        ByRef pNumDevices As Long, _
        ByVal HEIAPIVersion As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIQueryDeviceData Lib "hei_pas" ( _
        ByRef pTransport As HEITransport, _
        ByRef pDevice As HEIDevice, _
        ByRef pNumDevices As Long, _
        ByVal HEIAPIVersion As Integer, _
        ByVal DataType As Integer, _
        ByRef pData As Byte, _
        ByVal SizeOFData As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIReadSetupData Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByVal SetupType As Integer, _
        ByRef pData As Byte, _
        ByRef pSizeOfData As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIWriteSetupData Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByVal SetupType As Integer, _
        ByRef pData As Byte, _
        ByVal SizeOFData As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIReadDeviceDef Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pModuleDefInfo As DeviceDef, _
        ByVal pSizeOfModuleDefInfo As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIReadVersionInfo Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pVersionInfo As VersionInfoDef, _
        ByRef pVersionInfoSize As Integer _
    ) As Long
        
    Private Declare Function PASCAL_HEIReadBaseDef Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pData As Byte, _
        ByRef pDataSize As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIReadIO Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pData As Byte, _
        ByRef pDataSize As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIWriteIO Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pData As Byte, _
        ByVal SizeOFData As Integer, _
        ByRef pReturnData As Byte, _
        ByRef pSizeOfReturnData As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIReadModuleStatus Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pData As Byte, _
        ByRef pSizeOfData As Integer, _
        ByVal Clear As Integer _
    ) As Long

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' H4-EBC only
' This is used to write the Analog I/O configuration to the EBC because the DL405
' architecture does not distinguish between analog and discrete I/O modules.
'
    Private Declare Function PASCAL_HEIWriteBaseDef Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pData As Byte, _
        ByRef pDataSize As Integer _
    ) As Long
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Terminator I/O specific APIs
'
    ' This function will perform the power-on initilialization
    Private Declare Function PASCAL_HEIRescanBase Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByVal pRescanFlags As Integer, _
        ByRef pBaseDefInfo As Byte, _
        ByRef pDataSize As Integer _
    ) As Long
    
    ' This function is used to read the setup data from the T1F-08AD-2F (Fast Response)
    Private Declare Function PASCAL_HEIReadConfigData Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pData As Byte, _
        ByRef pDataSize As Integer _
    ) As Long

    ' This function is used to setup data from the T1F-08AD-2F (Fast Response)
    Private Declare Function PASCAL_HEIWriteConfigData Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pData As Byte, _
        ByVal DataSize As Integer, _
        ByRef pReturnData As Byte, _
        ByRef pReturnDataSize As Integer _
    ) As Long

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' ECOM Specific APIs
'
    Private Declare Function PASCAL_HEICCMRequest Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByVal bWrite As Integer, _
        ByVal DataType As Byte, _
        ByVal Address As Integer, _
        ByVal pDataLen As Integer, _
        ByRef pData As Byte _
    ) As Long
    
    Private Declare Function PASCAL_HEIKSEQRequest Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByVal DataLen As Integer, _
        ByRef pData As Byte, _
        ByRef pReturnDataLen As Integer _
    ) As Long
    
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Global variables
'
    ' return code from the SDK API calls
    Dim Rc As Long
        
    ' Ethernet protocol transport
    Dim TP As HEITransport
    
    ' true if the network interface can be initialized using the selected protocol
    Dim NetworkOK
    
    ' maximum number of devices you want to allow
    Const MAXDEVICES As Integer = 100
    
    ' array of Host Ethernet devices
    Dim aDevices(MAXDEVICES) As HEIDevice
    
    ' number of Host Ethernet devices found on the network
    Dim DeviceCount As Long
    
    ' set to true if any Host Ethernet device is already open
    Dim DeviceOpen As Boolean
    
    ' this is the device the user selected from the list
    Dim tDevice As Integer
    
    ' this is the type of device the user selcted
    Dim tDeviceType As String
    
    ' detail line that gets displayed in the listbox
    Dim DetailLine As String
    
'    Dim SourceAddress As Long
    Dim SourceAddress As EnetAddress
    
' Initialize Winsock using the selected protocol
'
Private Sub NetworkInit_Click()
    
    DisplayList.Clear
    
    ' if the network interface has already been opened, close it
    '
    If NetworkOK = True Then
        Rc = PASCAL_HEICloseTransport(TP)
        Rc = PASCAL_HEIClose()
    End If
    
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' Initialize the Ethernet Driver
    '
    Rc = PASCAL_HEIOpen(HEIAPIVersion)
    If Rc <> 0 Then
        DisplayList.AddItem "Error " + Hex(Rc) + " trying to initialize the Ethernet driver"
    
    Else
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' Initiaizize the Winsock protocol transport
        '
        TP.Data(0) = HEIT_WINSOCK
        
        If UseIP = True Then
            TP.Data(2) = HEIP_IP
        Else
            TP.Data(2) = HEIP_IPX
        End If

        '   ' Use this for HEIP_IPX protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_IPX == 6
        '       char Netnum[4];             ' Network Number
        '       char Nodenum[6];            ' Ethernet network address
        '       unsigned short Socket;      ' Socket Number == 0x7070
        '   } AddressIPX;
        '
        SourceAddress.Address(0) = 6 'AF_IPX
        
        SourceAddress.Address(6) = &H0
        SourceAddress.Address(7) = &HE0
        SourceAddress.Address(8) = &H18
        SourceAddress.Address(9) = &HFE
        SourceAddress.Address(10) = &H4A
        SourceAddress.Address(11) = &H6D
        
        SourceAddress.Address(12) = &H70
        SourceAddress.Address(13) = &H70
           
        '   ' Use this for HEIP_IP protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_INET == 2
        '       unsigned short Port;        ' Port number == 0x7070
        '       union
        '       {
        '           struct { unsigned char b1, b2, b3, b4; } bAddr;  ' Byte Addressing
        '           struct { unsigned short w1, w2; } wAddr;         ' Word addressing
        '           unsigned long lAddr;                             ' DWord addressing
        '       } AddressingType;
        '       char Zero[8];               ' initialize to zeros
        '   } AddressIP;
      
        Rc = PASCAL_HEIOpenTransport(TP, HEIAPIVersion, SourceAddress)
        If Rc <> 0 Then
            DisplayList.AddItem "Error " + Hex(Rc) + " trying to initialize the Winsock transport"
            
        Else
'*****************************************************************************************************
' ToDo:
'  I'm not sure why these three locations get a value but prevents the Transport from being functional.
'  So if I zero these three registers before continuing, all is ok.
'
            TP.Data(68) = 0
            TP.Data(69) = 0
            TP.Data(70) = 0
'*****************************************************************************************************

            If UseIP = True Then
                DisplayList.AddItem "Initialized Ok, using IP protocol"
            Else
                DisplayList.AddItem "Initialized Ok, using IPX protocol"
            End If
            
            NetworkOK = True
            
            ScanNetwork.Enabled = True
            
            If Connect.Enabled = True Then Connect.Enabled = False
                        
        End If
    
    End If

End Sub

' Query the network for Host Ethernet Devices
'
Private Sub ScanNetwork_Click()
    
    DisplayList.Clear
    DeviceCount = MAXDEVICES
    
    ' The default timeout value for the Query functions is 600ms. You can call
    ' PASCAL_HEISetQueryTimeout() with a new Timeout value (in ms) to extend
    ' the timeout period.
    '
    'Dim OldQueryTimeout As Long
    'OldQueryTimeout = PASCAL_HEISetQueryTimeout(2000)
 
    ' Do the Query
    '
    Rc = PASCAL_HEIQueryDevices(TP, aDevices(0), DeviceCount, HEIAPIVersion)
    If Rc <> 0 Then
        DisplayList.AddItem "Error " + Hex(Rc) + "(" + Str(Rc) + ")" + " trying to query network"
            
    Else
     'OldQueryTimeout = PASCAL_HEISetQueryTimeout(600)
     
     DisplayList.AddItem "Found" + Str(DeviceCount) + " devices"
        
        If DeviceCount > 0 Then
            DisplayList.AddItem "    Device          MAC Address            IP Address            ID"
    
            ' DeviceCount will contain the number of Host Ethernet Devices on the network
            ' if any were found, dislplay their configuration data
            '
            Dim x, Y
            
            ' Error Flags
            '
            Dim DDError As Boolean, IPError As Boolean, IDError As Boolean
            DDError = False
            IPError = False
            IDError = False
            
            DetailLine = ""
                             
            For x = 0 To DeviceCount - 1
                
                ' Now lets display some relevant information about each device found
                '
                ' Open the device
                '
                Rc = PASCAL_HEIOpenDevice(TP, aDevices(x), HEIAPIVersion, LongDevTimeout, DefDevRetrys, False)
                If Rc <> 0 Then
                    DetailLine = Format(x, "@@@") + " " + "          " + " .... " + GetMACFromBuffer(aDevices(x).Address) + ".... " + "   .   .   .   " + " .... " + "       Error: " + Hex(Rc) + " " + ShowHEIErrorText(Rc)
                    DisplayList.AddItem DetailLine
                    DetailLine = ""
                                   
                Else
                    ' this is the list index number
                    '
                    DetailLine = Format(x, "@@@") + " "
                    
                    ' check to see if user wants to filter out non-ebc devices
                    '
                    If DisplayAllDevices = True Or (DisplayOnlyEbcs = True And DeviceIsEBC(aDevices(x)) = True) Then
                    
                        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
                        ' First: the Module Type
                        ' See if the device has DT_TYPE_STRING data. This is a relatively new feature
                        ' so devices with old firmware won't have this. You'll need to use the "old"
                        ' method of manually constructing the device name.
                        '
                        Dim dtBuffer(31) As Byte
                        Dim dtSize As Integer
                        
                        Erase dtBuffer
                        dtSize = 32
                         
                        Rc = PASCAL_HEIReadSetupData(aDevices(x), DT_TYPE_STRING, dtBuffer(0), dtSize)
                        If Rc = 0 Then
                            DetailLine = DetailLine + Format(UseTypeString(dtBuffer, dtSize), "@@@@@@@@@@") + " .... "
                             
                        Else
                            DetailLine = DetailLine + Format(BuildTypeString(aDevices(x), DDError), "@@@@@@@@@@") + " .... "
                            
                        End If
                             
                        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
                        ' Second: the MAC address
                        ' it's in bytes 30 through 35 of the HEIDevice structure
                        '
                        DetailLine = DetailLine + GetMACFromBuffer(aDevices(x).Address)
                        
                        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
                        ' Third: the IP address
                        ' (remove leading spaces)
                        '
                        Dim tBuffer(255) As Byte
                        Dim RSize As Integer
                        RSize = 4
                         
                        Rc = PASCAL_HEIReadSetupData(aDevices(x), DT_IP_ADDRESS, tBuffer(0), RSize)
                        If Rc <> 0 Then
                            IPError = True
                            DetailLine = DetailLine + ".... ???.???.???.??? "
                         
                        Else
                            DetailLine = DetailLine + ".... " + GetIPFromBuffer(tBuffer)
                             
                        End If
                         
                        ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
                        ' Fourth: the Module ID
                        '
                        Erase tBuffer
                        RSize = 4
                         
                        Rc = PASCAL_HEIReadSetupData(aDevices(x), DT_NODE_NUMBER, tBuffer(0), RSize)
                        If Rc <> 0 Then
                            IDError = True
                            DetailLine = DetailLine + ".... ???"
                         
                        Else
                            DetailLine = DetailLine + ".... " + Format(GetNodeNumberFromBuffer(tBuffer), "@@@@@")
                            
                        End If
                        
                        ' alert me if any errors occurred trying to read from the device
                        '
                        If DDError = True Or IPError = True Or IDError = True Then
                           DetailLine = DetailLine + "   ! Error(s) occurred while reading device(s)"
                           DDError = False
                           IPError = False
                           IDError = False
                            
                        End If
                         
                    End If
                        
                    ' display device details
                    '
                    DisplayList.AddItem DetailLine
                    DetailLine = ""
                    
                    ' close this device
                    '
                    Rc = PASCAL_HEICloseDevice(aDevices(x))
                    If Rc <> 0 Then
                        DisplayList.AddItem "Error " + Hex(Rc) + " trying to close this device"
                    End If
                
                End If
            
            Next x
                
            ' Automatically select the first device found and give the Listbox focus
            '
            DisplayList.ListIndex = 2
            DisplayList.SetFocus
            Connect.Enabled = True
                  
        End If
    
    End If
    
End Sub

Private Sub DisplayAllDevices_Click()

    Call ScanNetwork_Click
    
End Sub

Private Sub DisplayOnlyEbcs_Click()

    Call ScanNetwork_Click

End Sub

Private Sub Connect_Click()

    ' this is the device the user has selected
    '
    tDevice = DisplayList.ListIndex - 2
    
    DisplayList.Clear
    DeviceOpen = False
    
    Disconnect = False
    ShowBaseConfig.Enabled = False
    ReadIO.Enabled = False
    ReadIOLoop.Enabled = False
    WriteIO.Enabled = False
  
    DisplayList.AddItem "Connecting to device #" + Format(tDevice, "@@")
    
    ' Open the device
    '
'    Rc = PASCAL_HEIOpenDevice(TP, aDevices(tDevice), HEIAPIVersion, LongDevTimeout, DefDevRetrys, False)
    Rc = PASCAL_HEIOpenDevice(TP, aDevices(tDevice), HEIAPIVersion, DefDevTimeout, DefDevRetrys, False)
    If Rc <> 0 Then
        DisplayList.AddItem "Error " + Hex(Rc) + " trying to open the device"
    
    Else
        DisplayList.AddItem "Ok"
        DeviceOpen = True
        
        NetworkInit.Enabled = False
        ScanNetwork.Enabled = False
        Disconnect.Enabled = True
        Connect.Enabled = False
        ShowBaseConfig.Enabled = True
        ReadIO.Enabled = True
        ReadIOLoop.Enabled = True
        TIOBaseInit.Enabled = False
        
        WriteIO.Enabled = True
        WIO_Frame.Enabled = True
        
        WIO_Base.Enabled = True
        WIO_Base_Label.Enabled = True
        WIO_Slot.Enabled = True
        WIO_Slot_Label.Enabled = True
        
        WIO_8Discrete.Enabled = True
        If WIO_8Discrete = True Then WIO_8DiscreteData.Enabled = True
        
        WIO_16Discrete.Enabled = True
        If WIO_16Discrete = True Then WIO_16DiscreteData.Enabled = True
        
        WIO_32Discrete.Enabled = True
        If WIO_32Discrete = True Then WIO_32DiscreteData.Enabled = True
        
        WIO_64Discrete.Enabled = True
        If WIO_64Discrete = True Then WIO_64DiscreteData.Enabled = True
        
        WIO_2Analog.Enabled = True
        WIO_4Analog.Enabled = True
        WIO_8Analog.Enabled = True
        WIO_16Analog.Enabled = True
        
        If WIO_2Analog = True Then
            WIO_Analog_Ch1.Enabled = True
            WIO_Analog_Ch2.Enabled = True
        End If
        
        If WIO_4Analog = True Then
            WIO_Analog_Ch1.Enabled = True
            WIO_Analog_Ch2.Enabled = True
            WIO_Analog_Ch3.Enabled = True
            WIO_Analog_Ch4.Enabled = True
        End If
        
        If WIO_8Analog = True Then
            WIO_Analog_Ch1.Enabled = True
            WIO_Analog_Ch2.Enabled = True
            WIO_Analog_Ch3.Enabled = True
            WIO_Analog_Ch4.Enabled = True
            WIO_Analog_Ch5.Enabled = True
            WIO_Analog_Ch6.Enabled = True
            WIO_Analog_Ch7.Enabled = True
            WIO_Analog_Ch8.Enabled = True
        End If
        
        If WIO_16Analog = True Then
            WIO_Analog_Ch1.Enabled = True
            WIO_Analog_Ch2.Enabled = True
            WIO_Analog_Ch3.Enabled = True
            WIO_Analog_Ch4.Enabled = True
            WIO_Analog_Ch5.Enabled = True
            WIO_Analog_Ch6.Enabled = True
            WIO_Analog_Ch7.Enabled = True
            WIO_Analog_Ch8.Enabled = True
            WIO_Analog_Ch9.Enabled = True
            WIO_Analog_Ch10.Enabled = True
            WIO_Analog_Ch11.Enabled = True
            WIO_Analog_Ch12.Enabled = True
            WIO_Analog_Ch13.Enabled = True
            WIO_Analog_Ch14.Enabled = True
            WIO_Analog_Ch15.Enabled = True
            WIO_Analog_Ch16.Enabled = True
        End If
        
        UseIP.Enabled = False
        UseIPX.Enabled = False
        ProtocolFrame.Enabled = False
        
        DisplayDevicesFrame.Enabled = False
        DisplayOnlyEbcs.Enabled = False
        DisplayAllDevices.Enabled = False
        
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' Display the Device Type
        '
        Dim RSDBuffer(31) As Byte
        Dim RSDSize As Integer
        Dim RSDError As Boolean

        Erase RSDBuffer
        RSDSize = 32

        Rc = PASCAL_HEIReadSetupData(aDevices(tDevice), DT_TYPE_STRING, RSDBuffer(0), RSDSize)
        If Rc = 0 Then
            DisplayList.AddItem "Device  : " + Format(UseTypeString(RSDBuffer, RSDSize), "@@@@@@@@")

        Else
            RSDError = False
            tDeviceType = BuildTypeString(aDevices(tDevice), RSDError)
            If RSDError = False Then
                DisplayList.AddItem "Device  : " + Format(tDevice, "@@@@@@@@")
            End If
        End If

        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' Display the boot loader version and the firmware version
        '
        Dim VIBuffer As VersionInfoDef
        Dim VISize As Integer
        VISize = 50

        Rc = PASCAL_HEIReadVersionInfo(aDevices(tDevice), VIBuffer, VISize)
        If Rc <> 0 Then
            DisplayList.AddItem "Error " + Hex(Rc) + " trying to read the version information"
        Else
            If VIBuffer.Version(0) <> 0 Then
                DisplayList.AddItem "Booter  : " + Format(VIBuffer.Version(1), "@") + "." _
                                                + Format(VIBuffer.Version(2), "@") + "." _
                                                + Format((VIBuffer.Version(4) * 256) _
                                                + (VIBuffer.Version(3)), "@@@")
                                                
                DisplayList.AddItem "Firmware: " + Format(VIBuffer.Version(5), "@") + "." _
                                                + Format(VIBuffer.Version(6), "@") + "." _
                                                + Format((VIBuffer.Version(8) * 256) _
                                                + (VIBuffer.Version(7)), "@@@")
            End If
        End If

        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' Display the Module ID (Node Number)
        '
        Dim tBuffer(255) As Byte
        Dim RSize As Integer
        Dim tString As String

        Erase tBuffer
        RSize = 4

        Rc = PASCAL_HEIReadSetupData(aDevices(tDevice), DT_NODE_NUMBER, tBuffer(0), RSize)
        If Rc <> 0 Then
            DisplayList.AddItem "Error reading Module ID:"

        Else
            tString = GetNodeNumberFromBuffer(tBuffer)
            DisplayList.AddItem "ID      : " + tString

        End If

        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' Display the Node Name
        '
        Erase tBuffer
        RSize = 256

        Rc = PASCAL_HEIReadSetupData(aDevices(tDevice), DT_NODE_NAME, tBuffer(0), RSize)
        If Rc <> 0 Then
            DisplayList.AddItem "Error reading Module Name"

        Else
            tString = GetNodeNameFromBuffer(tBuffer, RSize)
            DisplayList.AddItem "Name    : " + tString

        End If

        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' Display the Module Description
        '
        Erase tBuffer
        RSize = 256

        Rc = PASCAL_HEIReadSetupData(aDevices(tDevice), DT_DESCRIPTION, tBuffer(0), RSize)
        If Rc <> 0 Then
            DisplayList.AddItem "Error reading Module Description"

        Else
            tString = GetNodeDescFromBuffer(tBuffer, RSize)
            DisplayList.AddItem "Desc    : " + tString

        End If
        
        
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        ' Terminator I/O EBCs start slot numbering at 1, the others start numbering slots at 0
        '
        If DeviceIsTerminatorEBC(aDevices(tDevice)) = True Then
            WIO_Slot.Text = 1
            
            T1HEBC_AO_WriteSetup.Enabled = True
            T1HEBC_AO_PolarityFrame.Enabled = True
            T1HEBC_AO_PolarityLabel.Enabled = True
            T1HEBC_AO_RangeFrame.Enabled = True
            T1HEBC_AO_RangeLabel.Enabled = True
            T1HEBC_AO_Slot_Label.Enabled = True
            T1HEBC_AO_Slot.Enabled = True
            T1HEBC_AO_UNI.Enabled = True
            T1HEBC_AO_UNI = True
            T1HEBC_AO_BI.Enabled = True
            T1HEBC_AO_5V.Enabled = True
            T1HEBC_AO_5V = True
            T1HEBC_AO_10V.Enabled = True
            
            FRA_Setup_Frame.Enabled = True
            FRA_Slot_Label.Enabled = True
            FRA_Slot.Enabled = True
            FRA_Channels_Label.Enabled = True
            FRA_Channels.Enabled = True
            FRA_WriteSetup.Enabled = True
            
        Else
            WIO_Slot.Text = 0
        End If
        
    End If
    
End Sub


Private Sub Disconnect_Click()
        
    ' Close the open device
    '
    Rc = PASCAL_HEICloseDevice(aDevices(tDevice))
    If Rc <> 0 Then
        DisplayList.AddItem "Error " + Hex(Rc) + " trying to close device" + Str(tDevice)
    
    Else
        ' reset the screen
        '
        DeviceOpen = False
        
        NetworkInit.Enabled = True
        ScanNetwork.Enabled = True
        Connect.Enabled = False
        Disconnect.Enabled = False
        
        ShowBaseConfig.Enabled = False
        ReadIO.Enabled = False
        ReadIOLoop.Enabled = False
        
        TIOBaseInit.Enabled = False
        
        WriteIO.Enabled = False
        WIO_Frame.Enabled = False
        WIO_Base.Enabled = False
        WIO_Base_Label.Enabled = False
        WIO_Slot.Enabled = False
        WIO_Slot_Label.Enabled = False
        
        WIO_8Discrete.Enabled = False
        WIO_8DiscreteData.Enabled = False
        
        WIO_16Discrete.Enabled = False
        WIO_16DiscreteData.Enabled = False
        
        WIO_32Discrete.Enabled = False
        WIO_32DiscreteData.Enabled = False
        
        WIO_64Discrete.Enabled = False
        WIO_64DiscreteData.Enabled = False
        
        WIO_2Analog.Enabled = False
        WIO_4Analog.Enabled = False
        WIO_8Analog.Enabled = False
        WIO_16Analog.Enabled = False
        
        WIO_Analog_Ch1.Enabled = False
        WIO_Analog_Ch2.Enabled = False
        WIO_Analog_Ch3.Enabled = False
        WIO_Analog_Ch4.Enabled = False
        WIO_Analog_Ch5.Enabled = False
        WIO_Analog_Ch6.Enabled = False
        WIO_Analog_Ch7.Enabled = False
        WIO_Analog_Ch8.Enabled = False
        WIO_Analog_Ch9.Enabled = False
        WIO_Analog_Ch10.Enabled = False
        WIO_Analog_Ch11.Enabled = False
        WIO_Analog_Ch12.Enabled = False
        WIO_Analog_Ch13.Enabled = False
        WIO_Analog_Ch14.Enabled = False
        WIO_Analog_Ch15.Enabled = False
        WIO_Analog_Ch16.Enabled = False
        
        T1HEBC_AO_WriteSetup.Enabled = False
        T1HEBC_AO_PolarityFrame.Enabled = False
        T1HEBC_AO_PolarityLabel.Enabled = False
        T1HEBC_AO_RangeFrame.Enabled = False
        T1HEBC_AO_RangeLabel.Enabled = False
        T1HEBC_AO_Slot_Label.Enabled = False
        T1HEBC_AO_Slot.Enabled = False
        T1HEBC_AO_UNI.Enabled = False
        T1HEBC_AO_BI.Enabled = False
        T1HEBC_AO_5V.Enabled = False
        T1HEBC_AO_10V.Enabled = False
        
        FRA_Setup_Frame.Enabled = False
        FRA_Slot_Label.Enabled = False
        FRA_Slot.Enabled = False
        FRA_Channels_Label.Enabled = False
        FRA_Channels.Enabled = False
        FRA_WriteSetup.Enabled = False
        
        NetworkOK = False
        UseIP.Enabled = True
        NetworkOK = False
        UseIPX.Enabled = True
        ProtocolFrame.Enabled = True
        
        DisplayDevicesFrame.Enabled = True
        DisplayOnlyEbcs.Enabled = True
        DisplayAllDevices.Enabled = True
        
        If ReadIOLoop.Caption = "Stop Read I/O" Then ReadIOLoop.Caption = "Read I/O Continuous"

        tDeviceType = ""
        tDevice = 0
        
        DisplayList.Clear
        DisplayList.AddItem "Disconnected"
    
    End If

End Sub

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Read the Base Description to display a list of the I/O modules
'
Private Sub ShowBaseConfig_Click()

    DisplayList.Clear
    DisplayList.AddItem "Display Base Configuration for device number" + Str(tDevice)

    Dim BDData(1200) As Byte
    Erase BDData
    
    Dim BDSize As Integer
    BDSize = 1200
    
    ' Request a Type 2 packet
    '
    BDData(0) = &HB1&
    BDData(1) = 0
    
    Rc = PASCAL_HEIReadBaseDef(aDevices(tDevice), BDData(0), BDSize)
    If Rc <> 0 Then
        DisplayList.AddItem "Error " + Hex(Rc) + "( " + ShowHEIErrorText(Rc) + " ) " + "reading the base configuration"
    
    Else
        ' only process Type 2 packets
        '
        If (BDData(0) <> &HB1&) Then
            DisplayList.AddItem "Invalid Base Definition"
        
        Else
            Rc = ParseBaseDefinition(BDData)
            
        End If
        
    End If
    
End Sub

Private Function ParseBaseDefinition(ByRef BaseDefData() As Byte)
    
    Dim i, i2
    i = 0
    i2 = 0
    
    Dim Ptr As Byte
    Ptr = BaseDefData(0)
    
    Dim ModuleType As Byte
    ModuleType = 0
    
    Dim ModuleID As Byte
    ModuleID = 0
    
    Dim Base As Byte
    Base = 0
    
    Dim Slot As Byte
    Slot = 0
    
    Dim OptionType As Byte
    Dim OptionFamily As Byte
    
    Dim AddBaseSpace As Boolean
    AddBaseSpace = False
    
    Dim NumTypes, NumElements(4), DataFormat(4), x, DataSize
    
    
    ' loop until the termination character (FF)
    '
    While Ptr <> 255
                    
        Select Case Ptr
            ' New_Slot function code
            '
            Case 0
                ' next byte is the slot number
                '
                Slot = BaseDefData(i + 1)
                
                ' start a new detail line
                '
                If AddBaseSpace = True Then
                    DetailLine = "  Slot:" + Format(Slot, " @@ ")
                
                Else
                    DetailLine = "Slot:" + Format(Slot, " @@ ")
                
                End If
                
                ' go to next byte
                '
                i = i + 2
                Ptr = BaseDefData(i)
            
            
            ' 1 = new_module function code
            '
            Case 1
                ' get the number of type specific bytes of data for this slot
                '
                i = i + 1
                DataSize = BaseDefData(i)
                
                ' get the module type
                '
                i = i + 1
                ModuleType = BaseDefData(i)
                
                ' if no I/O data, you're done
                '
                If ((DataSize = 0) And (ModuleType = 0)) Then
                    DetailLine = DetailLine + "  Empty Slot"
                    
                    i = i + 2
                    Ptr = BaseDefData(i)
                
                Else
                    ' add module ID to the detail line
                    '
                    i = i + 1
                    ModuleID = BaseDefData(i)
                    DetailLine = DetailLine + "  ID: " + Format(Hex(ModuleID), "@@   ")
                    
                    ' Some modules have no I/O data, H2-SERIO is an example
                    '
                    If (ModuleType = 255) Then
                        DetailLine = DetailLine + " Module Has No I/O"
                    
                        i = i + DataSize + 1
                        Ptr = BaseDefData(i)
                    
                    Else
                        Select Case ModuleType
                            ' DL205 and DL405 I/O Generic I/O
                            '
                            Case 1
                                ' iterate each data type
                                '
                                i = i + 1
                                DetailLine = DetailLine + "  DI:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + "  DO:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + "  WI:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + "  WO:" + Format(BaseDefData(i), " @@ ")
                                    
                                i = i + 1
                                Ptr = BaseDefData(i)
                        
                            ' DL205 and DL405 I/O Intelligent I/O
                            '
                            Case 3
                                ' iterate each data type
                                '
                                i = i + 1
                                DetailLine = DetailLine + "  DI:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + "  DO:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + " DWI:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + " DWO:" + Format(BaseDefData(i), " @@ ")
                                    
                                i = i + 1
                                Ptr = BaseDefData(i)
                        
                            ' HA-EDRV2
                            '
                            Case 4
                                i = i + 1
                                DetailLine = DetailLine + "   DI:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + "   DO:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + "   WI:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + "   WO:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + "  DWI:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + "  DWO:" + Format(BaseDefData(i), " @@ ")
                            
                                i = i + 1
                                Ptr = BaseDefData(i)
                        
                            ' H2-CTRIO Modules
                            '
                            Case 5
                                i = i + 1
                                DetailLine = DetailLine + "  DI:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + "  DO:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + "  WI:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + "  WO:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + " DWI:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + " DWO:" + Format(BaseDefData(i), " @@ ")
                                
                                DisplayList.AddItem DetailLine
                                DetailLine = Space(20)

                                i = i + 1
                                DetailLine = DetailLine + "  BI:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + "  BO:" + Format(BaseDefData(i), " @@ ")
                                    
                                i = i + 1
                                DetailLine = DetailLine + " FLI:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + " FLO:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + " DBI:" + Format(BaseDefData(i), " @@ ")
                                
                                i = i + 1
                                DetailLine = DetailLine + " DBO:" + Format(BaseDefData(i), " @@")
                                
                                i = i + 1
                                Ptr = BaseDefData(i)
                            
                            ' all Terminator I/O modules are type 7
                            '
                            Case 7
                                ' start reording number of bytes incremented toward DataSize
                                '
                                i2 = 1
                        
                                ' the next byte contains the number of different data types for this module
                                '
                                i = i + 1
                                NumTypes = BaseDefData(i)
                                             
                                ' iterate each data type
                                '
                                For x = 1 To NumTypes
                                    i = i + 1
                                    i2 = i2 + 1
                                    
                                    ' add type to the detail line
                                    '
                                    Select Case BaseDefData(i)
                                        Case 3
                                            DetailLine = DetailLine + "  DI:"
                                        Case 4
                                            DetailLine = DetailLine + "  DO:"
                                        Case 5
                                            DetailLine = DetailLine + "  WI:"
                                        Case 6
                                            DetailLine = DetailLine + "  WO:"
                                        Case 8
                                            DetailLine = DetailLine + " DWI:"
                                        Case 9
                                            DetailLine = DetailLine + " DWO:"
                                    End Select
                                    
                                    i = i + 1
                                    i2 = i2 + 1
                                    
                                    ' add point count to the detail line
                                    '
                                    DetailLine = DetailLine + Format(BaseDefData(i), " @@ ")
                                    
                                Next x
                                
                                OptionType = BaseDefData(i + 1)
                                OptionFamily = BaseDefData(i + 2)
                                
                                    
                                ' go to next slot
                                '
                                i = i + (DataSize - i2) + 1
                                Ptr = BaseDefData(i)
                                                              
                        End Select
                    
                    End If
                                                    
                End If
                    
                DisplayList.AddItem DetailLine
                DetailLine = ""
                
            
            ' New_Base function code
            '
            Case 7
                Base = (BaseDefData(i + 1) And &HF&)
                DisplayList.AddItem "Base:" + Format(Base, " @@ ")
                
                AddBaseSpace = True
                
                ' reset slot to 0
                Slot = 0
                
                i = i + 2
                Ptr = BaseDefData(i)
            
            
            ' B1 00 = start of new style packet, skip ahead two bytes
            '
            Case 177
                i = i + 2
                Ptr = BaseDefData(i)


            ' you should never get here, if you do, set exit flag and bail out
            '
            Case Else
                Ptr = 255
                
        End Select
        
    Wend
    
End Function

Private Sub ReadIO_Click()
    
    Dim tBuffer(1199) As Byte
    Erase tBuffer
    
    Dim tBuffersize As Integer
    tBuffersize = 1200
    
    Dim Ptr As Byte, ModuleType As Byte
    Dim IntPtr As Long
    Dim DblPtr As Double
    
    Dim AddBaseSpace As Boolean
    AddBaseSpace = False

    Dim SplitDetail As Boolean
    SplitDetail = False
                        
    Dim EWI_Exist As Boolean
    EWI_Exist = False
    
    Dim Base, Slot, i, x, length
    Base = 0
    Slot = 0
    i = 0
    x = 0
    length = 0
    
    Dim Status
    Status = 0
    
    
    DisplayList.Clear
    
    ' request a Type 2 packet
    '
    tBuffer(0) = &HB1&
    tBuffer(1) = 0
    
    Rc = PASCAL_HEIReadIO(aDevices(tDevice), tBuffer(0), tBuffersize)
    If Rc <> 0 Then
        Status = (Rc And &HFFF&)
    End If
    
    ' if the lower three nibbles are zero, the data is good
    '
    If Status <> 0 Then
        DisplayList.AddItem "Error 0x" + Hex(Rc) + "( " + ShowHEIErrorText(Rc) + " ) " + "reading the I/O data"
        
    Else
        
        ' process the read I/O data packet
        '
        Ptr = tBuffer(i)
        
        ' loop through the returned data buffer
        '
        While Ptr <> 255
            ModuleType = Ptr
            
            Select Case ModuleType
                ' New_Slot function code
                '
                Case 0
                    Slot = tBuffer(i + 1)
                    
                    i = i + 2
                    Ptr = tBuffer(i)
                    
                ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
                ' 3 = Discrete Input Module
                ' 4 = Discrete Output Module
                '
                Case 3, 4
                    ' get length of data
                    '
                    length = tBuffer(i + 1)
                    
                    ' start a new detail line
                    '
                    If ModuleType = 3 Then
                        If AddBaseSpace = True Then
                            DetailLine = "  Slot: " + Format(Slot, "@@ ") + " (DI): "
                        Else
                            DetailLine = "Slot: " + Format(Slot, "@@ ") + " (DI): "
                        End If
                        
                    Else
                        If AddBaseSpace = True Then
                            DetailLine = "  Slot: " + Format(Slot, "@@ ") + " (DO): "
                        Else
                            DetailLine = "Slot: " + Format(Slot, "@@ ") + " (DO): "
                        End If
                    
                    End If
                    
                    ' increment to first data byte
                    '
                    i = i + 2
                    
                    ' iterate each data element
                    '
                    For x = 0 To length - 1
                        DetailLine = DetailLine + Format(Hex(tBuffer(i)), "@@@@@@ ")
                        
                        i = i + 1
                        Ptr = tBuffer(i)
                    
                    Next x
                    
                    DisplayList.AddItem DetailLine
                    
                ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
                ' 5 = WORD Input Module
                ' 6 = WORD Output Module
                '
                Case 5, 6
                    ' get length of data
                    '
                    length = tBuffer(i + 1)
                    
                    If ModuleType = 5 Then
                        If AddBaseSpace = True Then
                            DetailLine = "  Slot: " + Format(Slot, "@@ ") + " (WI): "
                        Else
                            DetailLine = "Slot: " + Format(Slot, "@@ ") + " (WI): "
                        End If
                        
                    Else
                        If AddBaseSpace = True Then
                            DetailLine = "  Slot: " + Format(Slot, "@@ ") + " (WO): "
                        Else
                            DetailLine = "Slot: " + Format(Slot, "@@ ") + " (WO): "
                        End If
                    End If
                    
                    ' increment to first data byte
                    '
                    i = i + 2
                    
                    ' iterate each data element
                    '
                    For x = 0 To length - 1 Step 2
                        ' combine the next two bytes into a WORD
                        ' they are in reverse order
                        
                        ' the value may also be negative - apply some 2's complement math to make it useable
                        '
                        If DeviceIsTerminatorEBC(aDevices(tDevice)) And ((tBuffer(i + 3) And &H80&) = &H80&) Then
                            IntPtr = -1 * (65536# - ((tBuffer(i + 1) * 256&) + tBuffer(i)) + 1)
                        
                        Else
                            IntPtr = (tBuffer(i + 1) * 256&) + tBuffer(i)
                
                        End If
                        
                        DetailLine = DetailLine + Format(IntPtr, "@@@@@@ ")
                        
                        ' increment to next WORD (2 bytes)
                        '
                        i = i + 2
                        Ptr = tBuffer(i)
                        
                        ' to make the display narrower, split long detail lines into two pieces
                        '
                        If Len(DetailLine) > 70 Then
                            DisplayList.AddItem DetailLine
                            
                            DetailLine = Space(18)
                            
                            SplitDetail = True
                        End If
                    
                    Next x
                    
                    ' display the completed detail line
                    '
                    If SplitDetail = False Then DisplayList.AddItem DetailLine
                    
        
                ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
                ' New Base Definition
                '
                Case 7
                    Base = (tBuffer(i + 1) And &HF&)
                    DisplayList.AddItem "Base:" + Format(Base, " @@")
                    
                    AddBaseSpace = True
                    
                    ' reset slot to 0
                    Slot = 0
                    
                    i = i + 2
                    Ptr = tBuffer(i)
                
                ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
                ' 8 = DWORD Input Module
                ' 9 = DWORD Output Module
                '
                Case 8, 9
                    ' get length of data
                    '
                    length = tBuffer(i + 1)
                    
                    If ModuleType = 8 Then
                        If AddBaseSpace = True Then
                            DetailLine = "  Slot: " + Format(Slot, "@@ ") + "(DWI): "
                        Else
                            DetailLine = "Slot: " + Format(Slot, "@@ ") + "(DWI): "
                        End If
                        
                    Else
                        ' There's one special case you may need to be aware of, the D4-HSC.
                        ' This module reports itself as having 7 DWIs and 4 DWOs. The DWOs
                        ' are not really outputs, they're in/outs. As such, the 'output'
                        ' data is contained in the DWI section. It's layed out as follows:
                        ' DWI(0)= Current Count
                        ' DWI(1)= Offset
                        ' DWI(2)= Preset
                        ' DWI(3)= Deceleration
                        ' DWI(4)= Latched count
                        ' DWI(5)= Time Base
                        ' DWI(6)= Sampled Count
        
                        If AddBaseSpace = True Then
                            DetailLine = "  Slot: " + Format(Slot, "@@ ") + "(DWO): "
                        Else
                            DetailLine = "Slot: " + Format(Slot, "@@ ") + "(DWO): "
                        End If
                    End If
                    
                    ' increment to first data byte
                    '
                    i = i + 2
                    
                    ' iterate each data element
                    '
                    For x = 0 To length - 1 Step 4
                        ' combine the next four bytes into a DWORD
                        ' they are in reverse order
                        ' the value may also be negative - apply some 2's complement math to make it useable
                        '
                        If DeviceIsTerminatorEBC(aDevices(tDevice)) Then
                            DblPtr = (tBuffer(i + 1) * 256&) + tBuffer(i)
                            
                            If (tBuffer(i + 3) And &H80&) = &H80& Then
                                DblPtr = -1 * (65536# - DblPtr)
                                
                                DetailLine = DetailLine + Format(DblPtr, "@@@@@@ ")
                            
                            Else
                                DetailLine = DetailLine + Format(DblPtr, "@@@@@@ ")
        
                            End If
                            
                        Else
                        
                            DblPtr = (tBuffer(i + 3) * 16777216#) + (tBuffer(i + 2) * 65536#) + (tBuffer(i + 1) * 256&) + tBuffer(i)
                            
                            If (tBuffer(i + 3) And &H80&) = &H80& Then
                                DblPtr = DblPtr * -1
                            End If
                                
                            DetailLine = DetailLine + Format(DblPtr, "@@@@@@ ")
                        
                        End If
                        
                        
                        ' increment to next DWORD (4 bytes)
                        '
                        i = i + 4
                        Ptr = tBuffer(i)
                        
                        ' to make the display narrower, split long detail lines into two pieces
                        '
                        If Len(DetailLine) > 70 Then
                            DisplayList.AddItem DetailLine
                            
                            DetailLine = Space(16)
                            
                            SplitDetail = True
                        End If
                    Next x
                    
                    ' display the completed detail line
                    '
                    If SplitDetail = False Then DisplayList.AddItem DetailLine
                
                ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
                ' Start of Type 2 Packet (B1 00)
                '
                Case 177
                    i = i + 2
                    Ptr = tBuffer(i)
            
            End Select
            
            SplitDetail = False
        
        Wend
        
        ' check the ReadIO return code for Errors, Warnings, and/or Info reported by the modules
        '
        DisplayList.AddItem ""
        
        Status = (Rc And MASK_DEVICE_ERROR)
        If Status = MASK_DEVICE_ERROR Then
            DisplayList.AddItem "Device Errors Exist"
            EWI_Exist = True
        End If
        
        Status = (Rc And MASK_DEVICE_WARNING)
        If Status = MASK_DEVICE_WARNING Then
            DisplayList.AddItem "Device Warnings Exist"
            EWI_Exist = True
        End If
        
        Status = (Rc And MASK_DEVICE_INFO)
        If Status = MASK_DEVICE_INFO Then
            DisplayList.AddItem "Device Information Exists"
            EWI_Exist = True
        End If
        
        ' now process the individual module status data
        '
        If EWI_Exist = True Then
            Erase tBuffer
            tBuffersize = 1023
        
            tBuffer(0) = &HB1&
            tBuffer(1) = 0
            
            Rc = PASCAL_HEIReadModuleStatus(aDevices(tDevice), tBuffer(0), tBuffersize, 1)
'            Rc = PASCAL_HEIReadModuleStatus(aDevices(tDevice), tBuffer(0), tBuffersize, 2)
            If (Rc And &HFFF) <> 0 Then
                DisplayList.AddItem "Error " + Hex(Rc) + " trying to read module status"

            Else
                Rc = ParseModuleStatus(tBuffer)
                
                ' if you're talking to a Terminator I/O EBC and it's reporting a hot swap error
                ' enable the InitBaseDef button
                '
                If Rc = 153 Or Rc = 154 Then
                    TIOBaseInit.Enabled = True
                End If
                
            End If

        End If
        
    End If

End Sub


Private Function ParseModuleStatus(ByRef ModuleStatusData() As Byte)

Dim Ptr As Byte, ErrorFlags As Byte
Dim i, x, Base, Slot, length, Ch
Dim BasePresent As Boolean
Dim TIO_Base_Error

    Base = 0
    Slot = 0
    i = 0
    Ptr = ModuleStatusData(i)
    BasePresent = False
    TIO_Base_Error = 0
    
    While Ptr <> 255
        Select Case Ptr
            ' New_Slot function code
            '
            Case 0
                Slot = ModuleStatusData(i + 1)
                
                i = i + 2
                Ptr = ModuleStatusData(i)
                
             ' Module Status Information
             '
            Case 2
                ' get the length of the status data
                '
                length = ModuleStatusData(i + 1)
                
                ' increment to first byte of the status information
                '
                i = i + 2
                Ptr = ModuleStatusData(i)
                
                For x = 0 To length - 1
                    Select Case x
                        ' process the flag byte
                        '
                        Case 0
                            If Ptr <> 0 Then
                                ' insert a blank line between each slot's status
                                '
                                DisplayList.AddItem ""
                                
                                If BasePresent = True Then
                                    DisplayList.AddItem " Base:" + Format(Base, " @@@@")
                                End If
                                
                                DisplayList.AddItem " Slot:" + Format(Slot, " @@@@")
                                
                                DetailLine = "Class:" + Format(Ptr, " @@@@")

                                If (Ptr And &H1&) = 1 Then DetailLine = DetailLine + " (module error)"
                                If (Ptr And &H2&) = 2 Then DetailLine = DetailLine + " (module warning)"
                                If (Ptr And &H4&) = 4 Then DetailLine = DetailLine + " (module info)"
                                If (Ptr And &H8&) = 8 Then DetailLine = DetailLine + " (internal error)"
                                If (Ptr And &H10&) = &H10& Then DetailLine = DetailLine + " (extended error)"

                                DisplayList.AddItem DetailLine
                            End If
                            
                        ' process the Error byte
                        '
                        Case 1
                            If Ptr <> 0 Then
                                Select Case Ptr
                                    ' broken transmitter errors
                                    '
                                    Case 121, 142
                                        DisplayList.AddItem " Code:" + Format(Ptr, " @@@@ (channel failure)")
                                    
                                    ' Terminator I/O Hot-Swap module removed error
                                    '
                                    Case 153
                                        DisplayList.AddItem " Code:" + Format(Ptr, " @@@@ (module removed)")
                                        TIO_Base_Error = Ptr
                                        
                                    ' Terminator I/O Hot-Swap module added error
                                    '
                                    Case 154
                                        DisplayList.AddItem " Code:" + Format(Ptr, " @@@@ (module added)")
                                        TIO_Base_Error = Ptr
                                        
                                    ' all the other errors
                                    '
                                    Case Else
                                        DisplayList.AddItem " Code:" + Format(Ptr, " @@@@")
                                
                                End Select
                            End If
                            
                        ' process the Warning byte
                        '
                        Case 2
                            If Ptr <> 0 Then
                                DisplayList.AddItem " Warn:" + Format(Ptr, " @@@@")
                            
                            End If
                            
                        ' process the information byte
                        '
                        Case 3
                            If Ptr <> 0 Then
                                DisplayList.AddItem " Info:" + Format(Ptr, " @@@@")
                            
                            End If
                            
                        ' process the Internal Error byte
                        ' if the module supports 'broken transmitter' detection, the channel(s)
                        ' that failed are listed here. The value is module specific. Some modules
                        ' have bit per channel, others have a 3-bit value (0-7).
                        '
                        Case 4
                            ' this code works for 2, 4 and 8 pt modules that have an error bit per channel
                            '
                            If Ptr <> 0 Then
                                Dim elmo
                                DetailLine = Space(12) + "(BT bits): "
                                
                                If (Ptr And &H1&) = &H1 Then DetailLine = DetailLine + "1 "
                                If (Ptr And &H2&) = &H2 Then DetailLine = DetailLine + "2 "
                                If (Ptr And &H4&) = &H4 Then DetailLine = DetailLine + "3 "
                                If (Ptr And &H8&) = &H8 Then DetailLine = DetailLine + "4 "
                                If (Ptr And &H10&) = &H10 Then DetailLine = DetailLine + "5 "
                                If (Ptr And &H20&) = &H20 Then DetailLine = DetailLine + "6 "
                                If (Ptr And &H40&) = &H40 Then DetailLine = DetailLine + "7 "
                                If (Ptr And &H80&) = &H80 Then DetailLine = DetailLine + "8 "
                                
                                DisplayList.AddItem DetailLine
                              
                            End If
                            
                            
                        ' process the extended error type
                        '
                        Case 5
                            ' Analog Byte/channel errors, set channel number to 0
                            ' each channel's error data to follow
                            '
                            If Ptr = 1 Then Ch = 0
                                
                        ' process extended error bytes
                        '
                        Case Is > 5
                            If (Ptr And &H1&) = 1 Then
                                DetailLine = "  channel:" + Format(Ch, " @@ BT")
                                DisplayList.AddItem DetailLine
                            End If
                            
                            Ch = Ch + 1
                        
                        End Select
                        
                        i = i + 1
                        Ptr = ModuleStatusData(i)
                        
                    Next x
            
            Case 7
                ' New_Base function code
                '
                Base = (ModuleStatusData(i + 1) And &HF&)
                BasePresent = True
                
                ' reset slot to 0
                '
                Slot = 0
                
                i = i + 2
                Ptr = ModuleStatusData(i)
            
            Case 177
                ' Beginning of Type 2 packet
                '
                i = i + 2
                Ptr = ModuleStatusData(i)
            
            Case Else
                ' you should never get here, but just in case, set exit condition
                '
                DetailLine = "unknown code"
                Ptr = 255
                
        End Select
        
    Wend
    
    If TIO_Base_Error <> 0 Then
        ParseModuleStatus = TIO_Base_Error
    
    Else
        ParseModuleStatus = 0
    
    End If
    
End Function

Private Sub ReadIO_Loop_Timer_Timer()

    Call ReadIO_Click

End Sub

Private Sub ReadIOLoop_Click()

    ' used to setup the Watchdog Timer
    '
    Dim LM As LinkMonitor
    Dim LMSize As Integer
    
    ' basically disable everything except the 'Stop ReadI/O' button
    '
    If ReadIOLoop.Caption = "Read I/O Continuous" Then
    
        ' turn on the EBC's watchdog timer (LinkMonitor)
        '
        If DeviceIsEBC(aDevices(tDevice)) Then
            
            ' Timeout:
            '   4 BYTE value
            '   5 seconds = 5000ms = 1388(hex)
            '
            LM.Data(0) = 88
            LM.Data(1) = 13
    
            ' Mode:
            '   1 BYTE
            '   0 = Force Outputs OFF
            '
            LM.Data(4) = 0
            
            ' Termination character
            '
            LM.Data(5) = &HFF
            
            LMSize = 255

            Rc = PASCAL_HEIWriteSetupData(aDevices(tDevice), DT_LINK_MONITOR, LM.Data(0), LMSize)
            If Rc <> 0 Then
                DisplayList.AddItem "Error " + Hex(Rc) + " writing setup data ... " + ShowHEIErrorText(Rc)
            
            Else
                
                ' change the button caption
                '
                ReadIOLoop.Caption = "Stop Read I/O"
                
                ' setup the remaining buttons
                '
                ReadIO.Enabled = False
                WriteIO.Enabled = False
                Disconnect.Enabled = False
                ShowBaseConfig.Enabled = False
                
                WIO_Frame.Enabled = False
                WIO_Base.Enabled = False
                WIO_Base_Label.Enabled = False
                WIO_Slot.Enabled = False
                WIO_Slot_Label.Enabled = False
                
                WIO_8Discrete.Enabled = False
                WIO_8DiscreteData.Enabled = False
                
                WIO_16Discrete.Enabled = False
                WIO_16DiscreteData.Enabled = False
                
                WIO_32Discrete.Enabled = False
                WIO_32DiscreteData.Enabled = False
                
                WIO_64Discrete.Enabled = False
                WIO_64DiscreteData.Enabled = False
                
                WIO_2Analog.Enabled = False
                WIO_4Analog.Enabled = False
                WIO_8Analog.Enabled = False
                WIO_16Analog.Enabled = False
                
                WIO_Analog_Ch1.Enabled = False
                WIO_Analog_Ch2.Enabled = False
                WIO_Analog_Ch3.Enabled = False
                WIO_Analog_Ch4.Enabled = False
                WIO_Analog_Ch5.Enabled = False
                WIO_Analog_Ch6.Enabled = False
                WIO_Analog_Ch7.Enabled = False
                WIO_Analog_Ch8.Enabled = False
                WIO_Analog_Ch9.Enabled = False
                WIO_Analog_Ch10.Enabled = False
                WIO_Analog_Ch11.Enabled = False
                WIO_Analog_Ch12.Enabled = False
                WIO_Analog_Ch13.Enabled = False
                WIO_Analog_Ch14.Enabled = False
                WIO_Analog_Ch15.Enabled = False
                WIO_Analog_Ch16.Enabled = False
            
                If DeviceIsTerminatorEBC(aDevices(tDevice)) Then
                    T1HEBC_AO_WriteSetup.Enabled = False
                    T1HEBC_AO_PolarityFrame.Enabled = False
                    T1HEBC_AO_PolarityLabel.Enabled = False
                    T1HEBC_AO_RangeFrame.Enabled = False
                    T1HEBC_AO_RangeLabel.Enabled = False
                    T1HEBC_AO_Slot_Label.Enabled = False
                    T1HEBC_AO_Slot.Enabled = False
                    T1HEBC_AO_UNI.Enabled = False
                    T1HEBC_AO_BI.Enabled = False
                    T1HEBC_AO_5V.Enabled = False
                    T1HEBC_AO_10V.Enabled = False
                    
                    FRA_Setup_Frame.Enabled = False
                    FRA_Slot_Label.Enabled = False
                    FRA_Slot.Enabled = False
                    FRA_Channels_Label.Enabled = False
                    FRA_Channels.Enabled = False
                    FRA_WriteSetup.Enabled = False
                End If
                
                ' start the loop control timer
                '
                ReadIO_Loop_Timer.Enabled = True
            
            End If
            
        Else
            DisplayList.AddItem "Device is not an EBC"
        
        End If
        
    Else
        
        DisplayList.Clear
        
        ' turn off the watchdog timer
        '
        If DeviceIsEBC(aDevices(tDevice)) Then
            ' Timeout = 0 to disable the watchdog timer
            '
            LM.Data(0) = 0
            LM.Data(1) = 0
            
            Rc = PASCAL_HEIWriteSetupData(aDevices(tDevice), DT_LINK_MONITOR, LM.Data(0), LMSize)
            If Rc <> 0 Then
                DisplayList.AddItem "Error " + Hex(Rc) + " writing setup data ... " + ShowHEIErrorText(Rc)
            End If
        End If
        
        ' stop the loop control timer
        '
        ReadIO_Loop_Timer.Enabled = False
        
        ' change the button caption
        '
        ReadIOLoop.Caption = "Read I/O Continuous"
        
        ' setup the remaining buttons
        '
        ReadIO.Enabled = True
        WriteIO.Enabled = True
        Disconnect.Enabled = True
        ShowBaseConfig.Enabled = True
    
        WIO_Frame.Enabled = True
        WIO_Base.Enabled = True
        WIO_Base_Label.Enabled = True
        WIO_Slot.Enabled = True
        WIO_Slot_Label.Enabled = True
        
        WIO_2Analog.Enabled = True
        WIO_4Analog.Enabled = True
        WIO_8Analog.Enabled = True
        WIO_16Analog.Enabled = True
        
        If WIO_2Analog = True Then
            WIO_Analog_Ch1.Enabled = True
            WIO_Analog_Ch2.Enabled = True
        End If
        
        If WIO_4Analog = True Then
            WIO_Analog_Ch1.Enabled = True
            WIO_Analog_Ch2.Enabled = True
            WIO_Analog_Ch3.Enabled = True
            WIO_Analog_Ch4.Enabled = True
        End If
        
        If WIO_8Analog = True Then
            WIO_Analog_Ch1.Enabled = True
            WIO_Analog_Ch2.Enabled = True
            WIO_Analog_Ch3.Enabled = True
            WIO_Analog_Ch4.Enabled = True
            WIO_Analog_Ch5.Enabled = True
            WIO_Analog_Ch6.Enabled = True
            WIO_Analog_Ch7.Enabled = True
            WIO_Analog_Ch8.Enabled = True
        End If
            
        If WIO_16Analog = True Then
            WIO_Analog_Ch1.Enabled = True
            WIO_Analog_Ch2.Enabled = True
            WIO_Analog_Ch3.Enabled = True
            WIO_Analog_Ch4.Enabled = True
            WIO_Analog_Ch5.Enabled = True
            WIO_Analog_Ch6.Enabled = True
            WIO_Analog_Ch7.Enabled = True
            WIO_Analog_Ch8.Enabled = True
            WIO_Analog_Ch9.Enabled = True
            WIO_Analog_Ch10.Enabled = True
            WIO_Analog_Ch11.Enabled = True
            WIO_Analog_Ch12.Enabled = True
            WIO_Analog_Ch13.Enabled = True
            WIO_Analog_Ch14.Enabled = True
            WIO_Analog_Ch15.Enabled = True
            WIO_Analog_Ch16.Enabled = True
        End If
        
        WIO_8Discrete.Enabled = True
        WIO_16Discrete.Enabled = True
        WIO_32Discrete.Enabled = True
        WIO_64Discrete.Enabled = True
                
        If WIO_8Discrete = True Then
            WIO_8DiscreteData.Enabled = True
        End If
    
        If WIO_16Discrete = True Then
            WIO_16DiscreteData.Enabled = True
        End If
        
        If WIO_32Discrete = True Then
            WIO_32DiscreteData.Enabled = True
        End If
        
        If WIO_64Discrete = True Then
            WIO_64DiscreteData.Enabled = True
        End If
        
        If DeviceIsTerminatorEBC(aDevices(tDevice)) Then
            T1HEBC_AO_WriteSetup.Enabled = True
            T1HEBC_AO_PolarityFrame.Enabled = True
            T1HEBC_AO_PolarityLabel.Enabled = True
            T1HEBC_AO_RangeFrame.Enabled = True
            T1HEBC_AO_RangeLabel.Enabled = True
            T1HEBC_AO_Slot_Label.Enabled = True
            T1HEBC_AO_Slot.Enabled = True
            T1HEBC_AO_UNI.Enabled = True
            T1HEBC_AO_BI.Enabled = True
            T1HEBC_AO_5V.Enabled = True
            T1HEBC_AO_10V.Enabled = True
            
            FRA_Setup_Frame.Enabled = True
            FRA_Slot_Label.Enabled = True
            FRA_Slot.Enabled = True
            FRA_Channels_Label.Enabled = True
            FRA_Channels.Enabled = True
            FRA_WriteSetup.Enabled = True
        End If
    End If

End Sub

Private Sub TIOBaseInit_Click()

    ' This API is used to facilitate the Hot-Swap feature of Terminator I/O. This API causes each
    ' I/O module to essentially go through the power-on-reset process. During this process, each
    ' module gets assigned a slot number, thereby, getting logged into the system. Since this API
    ' has the ability to assign/reassign slot numbers, it could have potentially harmful effects
    ' on the system.
    '                         USE THIS API CALL WITH EXTREME CAUTION
    '
    ' The return buffer, BDData, contains the same data as a call to PASCAL_HEIReadBaseDef(), if you
    ' want to parse the data, you can. If you had previously stored the base configuration, this would
    ' allow you to compare the before and after versions and see if the same type module that was removed
    ' was replaced or if a different module was put back in the base.
    '
    
    ' after initializing the base, you can optionally clear the EBC's internal copy of the discrete
    ' output data. The discrete outputs are NOT forced off during a reinitialization, so for most
    ' applications you'll want to leave the image register alone so that after the reinitialization
    ' the image register's contents will match the actual discrete outputs.
    '
    Dim tFlags As Integer
    'tFlags = RESCAN_LEAVE_IMAGE_RAM
    tFlags = RESCAN_CLEAR_IMAGE_RAM
    
    Dim BDData(1200) As Byte
    Erase BDData
    
    Dim BDSize
    BDSize = 1200
    
    DisplayList.Clear
    DisplayList.AddItem "Initializing device #" + Str(tDevice)
    
    ' Depending on how many I/O modules you have, this API call takes a comparatively long time to
    ' complete, so to avoid getting a timeout error (32774), you might need to temporarily increase
    ' the device timeout value to something like 250ms. There's a built-in 200ms wait, and you'll
    ' need to allow about 2 ms per module for the reinitialization to complete, so we recommend that
    ' add 200ms to your standard timeout value.
    '
    aDevices(tDevice).Address(26) = (200 + DefDevTimeout)
    
    Rc = PASCAL_HEIRescanBase(aDevices(tDevice), tFlags, BDData(0), BDSize)
    If (Rc <> 0 And Rc <> 32774) Then
        DisplayList.AddItem "Error " + Hex(Rc) + " trying to initialize the base"
    
    Else
        DisplayList.AddItem "Base Initialized"
        
        TIOBaseInit.Enabled = False
        
        ' display the new base configuration
        '
        Rc = ParseBaseDefinition(BDData)
    
        ' set the device timeout back to it's normal value
        '
        aDevices(tDevice).Address(26) = DefDevTimeout
        
    End If

End Sub

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' This function call will construct the buffer that contains the data for the discrete
' and analog output modules.
'
Private Sub WriteIO_Click()

    DisplayList.Clear
    
    Dim Status As Integer
    Dim i, x As Integer
    Dim t As String
    Dim Temp(16) As Byte
    Dim EWI_Exist As Boolean
    
    ' this buffer is the one you fill in to describe the write operation
    '
    Dim tBuffer(1200) As Byte
    Dim tBuffersize
    Erase tBuffer
    
    ' this buffer contains the I/O status after the write has been performed, this
    ' gives you the current I/O state without having to call ReadIO again (cool stuff)
    '
    Dim tReturnBuffer(1200) As Byte
    Dim tReturnBufferSize As Integer
    tReturnBufferSize = 1200
    
    ' Type 2 packets always begin with 'B1 00'
    '
    i = 0
    tBuffer(i) = &HB1&
    i = i + 1
    tBuffer(i) = 0
    
    ' add the New_Base function code if needed, at present, valid base numbers are 0, 1, 2 & 3
    '
    If WIO_Base <> 0 Then
        i = i + 1
        tBuffer(i) = 7
        i = i + 1
        tBuffer(i) = (WIO_Base And &H3)
    End If
    
    ' add the New_Slot function code and the slot number
    '
    i = i + 1
    tBuffer(i) = 0
    i = i + 1
    tBuffer(i) = WIO_Slot
    
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' add the data for the 8 point Discrete output
    '
    If WIO_8Discrete Then
        i = i + 1
        tBuffer(i) = 4                  ' Digital Output function code
        
        i = i + 1
        tBuffer(i) = 1                  ' one byte of output data
    
        Rc = StringToByteArray(WIO_8DiscreteData, Temp)
        Rc = HexConvert(Temp, Len(WIO_8DiscreteData) - 1)
        
        i = i + 1
        tBuffer(i) = Temp(0)    ' low byte
        
    End If
    
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' add the data for the 16 point Discrete output
    '
    If WIO_16Discrete = True Then
        i = i + 1
        tBuffer(i) = 4                  ' Digital Output function code
        
        i = i + 1
        tBuffer(i) = 2                  ' two bytes of output data
    
        Rc = StringToByteArray(WIO_16DiscreteData, Temp)
        Rc = HexConvert(Temp, Len(WIO_16DiscreteData) - 1)
        Rc = ByteSwap(Temp, Len(WIO_16DiscreteData) - 1)
        
        i = i + 1
        tBuffer(i) = Temp(0)    ' low byte
        
        i = i + 1
        tBuffer(i) = Temp(1)    ' high byte
    
    End If
   
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' add the data for the 32 point Discrete output
    '
    If WIO_32Discrete = True Then
        i = i + 1
        tBuffer(i) = 4                  ' Digital Output function code
        
        i = i + 1
        tBuffer(i) = 4                  ' four bytes of output data
    
        Rc = StringToByteArray(WIO_32DiscreteData, Temp)
        Rc = HexConvert(Temp, Len(WIO_32DiscreteData) - 1)
        Rc = ByteSwap(Temp, Len(WIO_32DiscreteData) - 1)
        
        i = i + 1
        tBuffer(i) = Temp(0)    ' low byte
        
        i = i + 1
        tBuffer(i) = Temp(1)    ' high byte
    
        i = i + 1
        tBuffer(i) = Temp(2)    ' low byte
        
        i = i + 1
        tBuffer(i) = Temp(3)    ' high byte
    
    End If
    
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' add the data for the 64 point Discrete output
    '
    If WIO_64Discrete = True Then
        i = i + 1
        tBuffer(i) = 4                  ' Digital Output function code
        
        i = i + 1
        tBuffer(i) = 8                  ' eight bytes of output data
    
        Rc = StringToByteArray(WIO_64DiscreteData, Temp)
        Rc = HexConvert(Temp, Len(WIO_64DiscreteData) - 1)
        Rc = ByteSwap(Temp, Len(WIO_64DiscreteData) - 1)
        
        i = i + 1
        tBuffer(i) = Temp(0)    ' low byte
        
        i = i + 1
        tBuffer(i) = Temp(1)    ' high byte
    
        i = i + 1
        tBuffer(i) = Temp(2)    ' low byte
        
        i = i + 1
        tBuffer(i) = Temp(3)    ' high byte
    
        i = i + 1
        tBuffer(i) = Temp(4)    ' low byte
        
        i = i + 1
        tBuffer(i) = Temp(5)    ' high byte
    
        i = i + 1
        tBuffer(i) = Temp(6)    ' low byte
        
        i = i + 1
        tBuffer(i) = Temp(7)    ' high byte
    
    End If
    
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' add the data for the 2 Channel analog output
    '
    If WIO_2Analog = True Then
        i = i + 1
        tBuffer(i) = 6              ' WORD output function code
        i = i + 1
        tBuffer(i) = 4              ' 2 WORDS = 4 bytes
        
        For x = 1 To 2
            Select Case x
                Case 1
                    t = Hex(WIO_Analog_Ch1)
                Case 2
                    t = Hex(WIO_Analog_Ch2)
            End Select
            
            Select Case Len(t)
                Case 1
                    t = "000" + t
                Case 2
                    t = "00" + t
                Case 3
                    t = "0" + t
            End Select
            
            Rc = StringToByteArray(t, Temp)
            Rc = HexConvert(Temp, Len(t) - 1)
            Rc = ByteSwap(Temp, Len(t) - 1)
            
            i = i + 1
            tBuffer(i) = Temp(0)    ' low byte
            
            i = i + 1
            tBuffer(i) = Temp(1)    ' high byte
        
            Erase Temp
            t = ""
        
        Next x
            
    
    End If
    
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' add the data for the 4 Channel analog output
    '
    If WIO_4Analog = True Then
        If DeviceIsTerminatorEBC(aDevices(tDevice)) Then
            i = i + 1
            tBuffer(i) = 9              ' DWORD output function code
            i = i + 1
            tBuffer(i) = 16             ' 4 DWORDS = 16 bytes
        Else
            i = i + 1
            tBuffer(i) = 6              ' WORD output function code
            i = i + 1
            tBuffer(i) = 8              ' 4 WORDS = 8 bytes
        End If
        
        For x = 1 To 4
            Select Case x
                Case 1
                    t = Hex(WIO_Analog_Ch1)
                Case 2
                    t = Hex(WIO_Analog_Ch2)
                Case 3
                    t = Hex(WIO_Analog_Ch3)
                Case 4
                    t = Hex(WIO_Analog_Ch4)
            End Select
            
            Select Case Len(t)
                Case 1
                    t = "000" + t
                Case 2
                    t = "00" + t
                Case 3
                    t = "0" + t
            End Select
            
            Rc = StringToByteArray(t, Temp)
            Rc = HexConvert(Temp, Len(t) - 1)
            Rc = ByteSwap(Temp, Len(t) - 1)
            
            i = i + 1
            tBuffer(i) = Temp(0)    ' low byte
            
            i = i + 1
            tBuffer(i) = Temp(1)    ' high byte
        
            If DeviceIsTerminatorEBC(aDevices(tDevice)) Then
                i = i + 2
            End If
            
            Erase Temp
            t = ""
        
        Next x
            
    End If
    
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' add the data for the 8 Channel analog output
    '
    If WIO_8Analog = True Then
        If DeviceIsTerminatorEBC(aDevices(tDevice)) Then
            i = i + 1
            tBuffer(i) = 9              ' DWORD output function code
            i = i + 1
            tBuffer(i) = 32             ' 8 DWORDS = 32 bytes
        Else
            i = i + 1
            tBuffer(i) = 6              ' WORD output function code
            i = i + 1
            tBuffer(i) = 16             ' 8 WORDS = 16 bytes
        
        End If
        
        For x = 1 To 8
            Select Case x
                Case 1
                    t = Hex(WIO_Analog_Ch1)
                Case 2
                    t = Hex(WIO_Analog_Ch2)
                Case 3
                    t = Hex(WIO_Analog_Ch3)
                Case 4
                    t = Hex(WIO_Analog_Ch4)
                Case 5
                    t = Hex(WIO_Analog_Ch5)
                Case 6
                    t = Hex(WIO_Analog_Ch6)
                Case 7
                    t = Hex(WIO_Analog_Ch7)
                Case 8
                    t = Hex(WIO_Analog_Ch8)
            End Select
            
            Select Case Len(t)
                Case 1
                    t = "000" + t
                Case 2
                    t = "00" + t
                Case 3
                    t = "0" + t
            End Select
            
            Rc = StringToByteArray(t, Temp)
            Rc = HexConvert(Temp, Len(t) - 1)
            Rc = ByteSwap(Temp, Len(t) - 1)
            
            i = i + 1
            tBuffer(i) = Temp(0)    ' low byte
            
            i = i + 1
            tBuffer(i) = Temp(1)    ' high byte
        
            If DeviceIsTerminatorEBC(aDevices(tDevice)) Then
                i = i + 2
            End If
            
            Erase Temp
            t = ""
        
        Next x
            
    End If
        
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' add the data for the 16 Channel analog output
    '
    If WIO_16Analog = True Then
        If DeviceIsTerminatorEBC(aDevices(tDevice)) Then
            i = i + 1
            tBuffer(i) = 9              ' DWORD output function code
            i = i + 1
            tBuffer(i) = 64             ' 16 DWORDS = 64 bytes
        Else
            i = i + 1
            tBuffer(i) = 6              ' WORD output function code
            i = i + 1
            tBuffer(i) = 32             ' 16 WORDS = 32 bytes
        
        End If
        
        For x = 1 To 16
            Select Case x
                Case 1
                    t = Hex(WIO_Analog_Ch1)
                Case 2
                    t = Hex(WIO_Analog_Ch2)
                Case 3
                    t = Hex(WIO_Analog_Ch3)
                Case 4
                    t = Hex(WIO_Analog_Ch4)
                Case 5
                    t = Hex(WIO_Analog_Ch5)
                Case 6
                    t = Hex(WIO_Analog_Ch6)
                Case 7
                    t = Hex(WIO_Analog_Ch7)
                Case 8
                    t = Hex(WIO_Analog_Ch8)
                Case 9
                    t = Hex(WIO_Analog_Ch9)
                Case 10
                    t = Hex(WIO_Analog_Ch10)
                Case 11
                    t = Hex(WIO_Analog_Ch11)
                Case 12
                    t = Hex(WIO_Analog_Ch12)
                Case 13
                    t = Hex(WIO_Analog_Ch13)
                Case 14
                    t = Hex(WIO_Analog_Ch14)
                Case 15
                    t = Hex(WIO_Analog_Ch15)
                Case 16
                    t = Hex(WIO_Analog_Ch16)
            End Select
            
            Select Case Len(t)
                Case 1
                    t = "000" + t
                Case 2
                    t = "00" + t
                Case 3
                    t = "0" + t
            End Select
            
            Rc = StringToByteArray(t, Temp)
            Rc = HexConvert(Temp, Len(t) - 1)
            Rc = ByteSwap(Temp, Len(t) - 1)
            
            i = i + 1
            tBuffer(i) = Temp(0)    ' low byte
            
            i = i + 1
            tBuffer(i) = Temp(1)    ' high byte
        
            If DeviceIsTerminatorEBC(aDevices(tDevice)) Then
                i = i + 2
            End If
            
            Erase Temp
            t = ""
        
        Next x
            
    End If

    ' If the Device is a Terminator EBC and the Output Device is an analog module
    ' add an 8DO module with the same slot, and set it the low bit to enable the outputs.
    '
    'If DeviceIsTerminatorEBC(aDevices(tDevice)) And (WIO_4Analog = True Or WIO_8Analog = True Or WIO_16Analog = True) Then
    '   i = i + 1
    '   tBuffer(i) = 0
    '   i = i + 1
    '   tBuffer(i) = WIO_Slot
    '   i = i + 1
    '   tBuffer(i) = 4                  ' Digital Output function code
    '   i = i + 1
    '   tBuffer(i) = 1                  ' one byte of output data
    '   i = i + 1
    '   tBuffer(i) = &H1&               ' enable all outputs
    'End If
    
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' add the termination character (FF)
    '
    i = i + 1
    tBuffer(i) = &HFF&
    
    
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' set the size if the input data (in bytes)
    '
    tBuffersize = i + 1
    
    
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' perform the WriteI/O operation
    '
    Rc = PASCAL_HEIWriteIO(aDevices(tDevice), tBuffer(0), tBuffersize, tReturnBuffer(0), tReturnBufferSize)
    If Rc <> 0 Then
        Status = (Rc And &HFFF&)
        If Status <> 0 Then
            DisplayList.AddItem "Error " + Hex(Rc) + "( " + ShowHEIErrorText(Rc) + " ) " + "writing the I/O data"
        Else
            
            ' check the return code for Errors, Warnings, and/or Info reported by the modules
            '
            EWI_Exist = False
            
            Status = (Rc And MASK_DEVICE_ERROR)
            If Status = MASK_DEVICE_ERROR Then
                DisplayList.AddItem "Device Errors Exist"
                EWI_Exist = True
            End If
            
            Status = (Rc And MASK_DEVICE_WARNING)
            If Status = MASK_DEVICE_WARNING Then
                DisplayList.AddItem "Device Warnings Exist"
                EWI_Exist = True
            End If
            
            Status = (Rc And MASK_DEVICE_INFO)
            If Status = MASK_DEVICE_INFO Then
                DisplayList.AddItem "Device Information Exists"
                EWI_Exist = True
            End If
        
        End If
        
        
        ' If modules are reporting errors, read the module status, and display the results
        '
        If EWI_Exist = True Then
            Erase tBuffer
            tBuffersize = 1200
        
            tBuffer(0) = &HB1&
            tBuffer(1) = 0
            
            ' The last parameter (Clear) has three options
            '   0   =   Don't clear error codes in the EBC after reading the module status data
            '   1   =   Clear error codes in the EBC after reading the module status data
            '   2   =   Try to clear error codes in the EBC after reading the module status data
            '           This code is used with the T1F-14THM and T1F-16RTD because it takes those
            '           modules a relatively long time to accurately refresh their Burn-Out bits
            '           after a PASCAL_ReadModuleStatus(,,,True)

'            Rc = PASCAL_HEIReadModuleStatus(aDevices(tDevice), tBuffer(0), tBuffersize, True)
            Rc = PASCAL_HEIReadModuleStatus(aDevices(tDevice), tBuffer(0), tBuffersize, False)
            If (Rc And &HFFF) <> 0 Then
                DisplayList.AddItem "Error " + Hex(Rc) + " trying to read module status"
    
            Else
                Rc = ParseModuleStatus(tBuffer)
                
                ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
                ' if you're talking to a Terminator I/O EBC and it's reporting a hot swap error
                ' enable the InitBaseDef button
                '
                If Rc = 153 Or Rc = 154 Then
                    TIOBaseInit.Enabled = True
                End If
                
            End If
        End If
        
    End If
    
End Sub

' The Terminator I/O Analog Ouptut modules do not have jumpers to configure their outputs. So,
' you must write a 'module control byte' to each of the analog output modules before you use
' them. And because this module control byte is in the analog module's RAM, the module control
' byte must be written each time the system is powered on.
'
Private Sub T1HEBC_AO_WriteSetup_Click()
    
    DisplayList.Clear
    
    Dim i, Status As Integer
    Dim ConfigByte As Byte
    
    ' this buffer is the one you fill in to describe the write operation
    '
    Dim tBuffer(1200) As Byte
    Dim tBuffersize
    Erase tBuffer
    
    ' this buffer contains the I/O status after the write has been performed, this
    ' gives you the current I/O state without having to call ReadIO again (cool stuff)
    '
    Dim tReturnBuffer(1200) As Byte
    Dim tReturnBufferSize As Integer
    tReturnBufferSize = 1200
    
    ' Type 2 packets always begin with 'B1 00'
    '
    i = 0
    tBuffer(i) = &HB1&
    i = i + 1
    tBuffer(i) = 0
    
    ' add the New_Slot function code and the slot number
    '
    i = i + 1
    tBuffer(i) = 0
    i = i + 1
    tBuffer(i) = T1HEBC_AO_Slot
    
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' the module control byte
    '
    ' bit 0:    0 = all OFF     1 = all enabled
    ' bit 1:    0 = unipolar    1 = bipolar
    ' bit 2:    0 = 0->5v,      1 = 0->10v          (voltage output module only)
    ' bit 3:    0 = 0-20mA      1 = 4-20mA          (current output module only)
    
    i = i + 1
    tBuffer(i) = 4                  ' Digital Output function code
    i = i + 1
    tBuffer(i) = 1                  ' one byte of output data
    i = i + 1
    
    If T1HEBC_AO_UNI = True And T1HEBC_AO_5V = True Then ConfigByte = &H1&
    
    If T1HEBC_AO_UNI = True And T1HEBC_AO_10V = True Then ConfigByte = &H5&
    
    
    If T1HEBC_AO_BI = True And T1HEBC_AO_5V = True Then ConfigByte = &H3&
    
    If T1HEBC_AO_BI = True And T1HEBC_AO_10V = True Then ConfigByte = &H7&
    
    
    tBuffer(i) = ConfigByte


    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' add the termination character (FF)
    '
    i = i + 1
    tBuffer(i) = &HFF&
    
    
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' set the size if the input data (in bytes)
    '
    tBuffersize = i + 1
    
    
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' perform the WriteI/O operation
    '
    Rc = PASCAL_HEIWriteIO(aDevices(tDevice), tBuffer(0), tBuffersize, tReturnBuffer(0), tReturnBufferSize)
    If Rc <> 0 Then
        Status = (Rc And &HFFF&)
        If Status <> 0 Then
            DisplayList.AddItem "Error " + Hex(Rc) + "( " + ShowHEIErrorText(Rc) + " ) " + "writing the I/O data"
        Else
            DisplayList.AddItem "Successfully wrote configuration data"
        End If
    Else
        DisplayList.AddItem "Successfully wrote configuration data"
    End If

End Sub


' This function will write the required setup data to configure a T1F-08AD-2F
' for fast response mode. There's one BYTE of data that contains the configuration.
' The BTYE is layed out as follows ( Bit7 -> Bit 0 ):
'
'   Bit 7:      0 = Normal Response
'               1 = Fast Response
'   Bit 6:      Reserved
'   Bit 5:      Reserved
'   Bit 4 - 0:  0 =     All Channels Enabled
'               1 =     Ch1 Enabled
'               2 =     Ch1, Ch2 Enabled
'               3 =     Ch1, Ch2, Ch3 Enabled
'               4 =     Ch1, Ch2, Ch3, Ch4 Enabled
'               5 =     Ch1, Ch2, Ch3, Ch4, Ch5 Enabled
'               ....
'               16=     Ch1, Ch2, ... Ch16 Enabled
'               17 - 31=All Channels Enabled
'
Private Sub FRA_WriteSetup_Click()
    
    Dim i As Integer
    Dim ConfigData(100) As Byte
    Dim SizeConfigData As Integer
    
    Dim ReturnConfigData(100) As Byte
    Dim SizeReturnConfigData As Integer
    SizeReturnConfigData = 100
    
    ' Type 2 packets always begin with 'B1 00'
    '
    i = 0
    ConfigData(i) = &HB1&
    i = i + 1
    ConfigData(i) = 0
    
    ' add Slot function code and the slot number
    '
    i = i + 1
    ConfigData(i) = 0
    i = i + 1
    ConfigData(i) = FRA_Slot
    
    ' add Data Type
    i = i + 1
    ConfigData(i) = DF_CONFIG
    ' add Data Size
    i = i + 1
    ConfigData(i) = 1
    
    ' add the Data
    i = i + 1
    ConfigData(i) = &H80 + FRA_Channels
    
    ' add Data Type
    i = i + 1
    ConfigData(i) = &HFF

    SizeConfigData = i + 1
    
    Dim WCDError As Boolean
    WCDError = False
    
    Rc = PASCAL_HEIWriteConfigData(aDevices(tDevice), ConfigData(0), SizeConfigData, ReturnConfigData(0), SizeReturnConfigData)
    If Rc <> 0 Then
        ' if only high digit is non-zero, writing configuration data was successful
        '
        If (Rc And &HFFF&) <> 0 Then
            WCDError = True
        End If
     
    End If
         
    DisplayList.Clear
    
    If WCDError = True Then
        DisplayList.AddItem "Error (" + Str$(Rc) + ") writing configuration data"
     
    Else
        DisplayList.AddItem "Successfully wrote configuration data"
     
    End If

End Sub


Private Sub UseIP_Click()

    DisplayList.Clear
    
    If ScanNetwork.Enabled = True Then ScanNetwork.Enabled = False
    If Connect.Enabled = True Then Connect.Enabled = False
    
End Sub

Private Sub UseIPX_Click()

    DisplayList.Clear
    
    If ScanNetwork.Enabled = True Then ScanNetwork.Enabled = False
    If Connect.Enabled = True Then Connect.Enabled = False
    
End Sub

Private Sub WIO_8Discrete_Click()
    
    WIO_8DiscreteData.Enabled = True
    WIO_16DiscreteData.Enabled = False
    WIO_32DiscreteData.Enabled = False
    WIO_64DiscreteData.Enabled = False
    
    WIO_Analog_Ch1.Enabled = False
    WIO_Analog_Ch2.Enabled = False
    WIO_Analog_Ch3.Enabled = False
    WIO_Analog_Ch4.Enabled = False
    WIO_Analog_Ch5.Enabled = False
    WIO_Analog_Ch6.Enabled = False
    WIO_Analog_Ch7.Enabled = False
    WIO_Analog_Ch8.Enabled = False
    WIO_Analog_Ch9.Enabled = False
    WIO_Analog_Ch10.Enabled = False
    WIO_Analog_Ch11.Enabled = False
    WIO_Analog_Ch12.Enabled = False
    WIO_Analog_Ch13.Enabled = False
    WIO_Analog_Ch14.Enabled = False
    WIO_Analog_Ch15.Enabled = False
    WIO_Analog_Ch16.Enabled = False
    
End Sub

Private Sub WIO_16Discrete_Click()
    
    WIO_8DiscreteData.Enabled = False
    WIO_16DiscreteData.Enabled = True
    WIO_32DiscreteData.Enabled = False
    WIO_64DiscreteData.Enabled = False
    
    WIO_Analog_Ch1.Enabled = False
    WIO_Analog_Ch2.Enabled = False
    WIO_Analog_Ch3.Enabled = False
    WIO_Analog_Ch4.Enabled = False
    WIO_Analog_Ch5.Enabled = False
    WIO_Analog_Ch6.Enabled = False
    WIO_Analog_Ch7.Enabled = False
    WIO_Analog_Ch8.Enabled = False
    WIO_Analog_Ch9.Enabled = False
    WIO_Analog_Ch10.Enabled = False
    WIO_Analog_Ch11.Enabled = False
    WIO_Analog_Ch12.Enabled = False
    WIO_Analog_Ch13.Enabled = False
    WIO_Analog_Ch14.Enabled = False
    WIO_Analog_Ch15.Enabled = False
    WIO_Analog_Ch16.Enabled = False
    
End Sub

Private Sub WIO_32Discrete_Click()
    
    WIO_8DiscreteData.Enabled = False
    WIO_16DiscreteData.Enabled = False
    WIO_32DiscreteData.Enabled = True
    WIO_64DiscreteData.Enabled = False
       
    WIO_Analog_Ch1.Enabled = False
    WIO_Analog_Ch2.Enabled = False
    WIO_Analog_Ch3.Enabled = False
    WIO_Analog_Ch4.Enabled = False
    WIO_Analog_Ch5.Enabled = False
    WIO_Analog_Ch6.Enabled = False
    WIO_Analog_Ch7.Enabled = False
    WIO_Analog_Ch8.Enabled = False
    WIO_Analog_Ch9.Enabled = False
    WIO_Analog_Ch10.Enabled = False
    WIO_Analog_Ch11.Enabled = False
    WIO_Analog_Ch12.Enabled = False
    WIO_Analog_Ch13.Enabled = False
    WIO_Analog_Ch14.Enabled = False
    WIO_Analog_Ch15.Enabled = False
    WIO_Analog_Ch16.Enabled = False

End Sub

Private Sub WIO_64Discrete_Click()
    WIO_8DiscreteData.Enabled = False
    WIO_16DiscreteData.Enabled = False
    WIO_32DiscreteData.Enabled = False
    WIO_64DiscreteData.Enabled = True
    
    WIO_Analog_Ch1.Enabled = False
    WIO_Analog_Ch2.Enabled = False
    WIO_Analog_Ch3.Enabled = False
    WIO_Analog_Ch4.Enabled = False
    WIO_Analog_Ch5.Enabled = False
    WIO_Analog_Ch6.Enabled = False
    WIO_Analog_Ch7.Enabled = False
    WIO_Analog_Ch8.Enabled = False
    WIO_Analog_Ch9.Enabled = False
    WIO_Analog_Ch10.Enabled = False
    WIO_Analog_Ch11.Enabled = False
    WIO_Analog_Ch12.Enabled = False
    WIO_Analog_Ch13.Enabled = False
    WIO_Analog_Ch14.Enabled = False
    WIO_Analog_Ch15.Enabled = False
    WIO_Analog_Ch16.Enabled = False


End Sub

Private Sub WIO_2Analog_Click()
    WIO_Analog_Ch1.Enabled = True
    WIO_Analog_Ch2.Enabled = True
    WIO_Analog_Ch3.Enabled = False
    WIO_Analog_Ch4.Enabled = False
    WIO_Analog_Ch5.Enabled = False
    WIO_Analog_Ch6.Enabled = False
    WIO_Analog_Ch7.Enabled = False
    WIO_Analog_Ch8.Enabled = False
    WIO_Analog_Ch9.Enabled = False
    WIO_Analog_Ch10.Enabled = False
    WIO_Analog_Ch11.Enabled = False
    WIO_Analog_Ch12.Enabled = False
    WIO_Analog_Ch13.Enabled = False
    WIO_Analog_Ch14.Enabled = False
    WIO_Analog_Ch15.Enabled = False
    WIO_Analog_Ch16.Enabled = False
    
    WIO_8DiscreteData.Enabled = False
    WIO_16DiscreteData.Enabled = False
    WIO_32DiscreteData.Enabled = False
    WIO_64DiscreteData.Enabled = False

End Sub

Private Sub WIO_4Analog_Click()
    WIO_Analog_Ch1.Enabled = True
    WIO_Analog_Ch2.Enabled = True
    WIO_Analog_Ch3.Enabled = True
    WIO_Analog_Ch4.Enabled = True
    WIO_Analog_Ch5.Enabled = False
    WIO_Analog_Ch6.Enabled = False
    WIO_Analog_Ch7.Enabled = False
    WIO_Analog_Ch8.Enabled = False
    WIO_Analog_Ch9.Enabled = False
    WIO_Analog_Ch10.Enabled = False
    WIO_Analog_Ch11.Enabled = False
    WIO_Analog_Ch12.Enabled = False
    WIO_Analog_Ch13.Enabled = False
    WIO_Analog_Ch14.Enabled = False
    WIO_Analog_Ch15.Enabled = False
    WIO_Analog_Ch16.Enabled = False
    
    WIO_8DiscreteData.Enabled = False
    WIO_16DiscreteData.Enabled = False
    WIO_32DiscreteData.Enabled = False
    WIO_64DiscreteData.Enabled = False

End Sub

Private Sub WIO_8Analog_Click()
    WIO_Analog_Ch1.Enabled = True
    WIO_Analog_Ch2.Enabled = True
    WIO_Analog_Ch3.Enabled = True
    WIO_Analog_Ch4.Enabled = True
    WIO_Analog_Ch5.Enabled = True
    WIO_Analog_Ch6.Enabled = True
    WIO_Analog_Ch7.Enabled = True
    WIO_Analog_Ch8.Enabled = True
    WIO_Analog_Ch9.Enabled = False
    WIO_Analog_Ch10.Enabled = False
    WIO_Analog_Ch11.Enabled = False
    WIO_Analog_Ch12.Enabled = False
    WIO_Analog_Ch13.Enabled = False
    WIO_Analog_Ch14.Enabled = False
    WIO_Analog_Ch15.Enabled = False
    WIO_Analog_Ch16.Enabled = False
    
    WIO_8DiscreteData.Enabled = False
    WIO_16DiscreteData.Enabled = False
    WIO_32DiscreteData.Enabled = False
    WIO_64DiscreteData.Enabled = False

End Sub

Private Sub WIO_16Analog_Click()
    WIO_Analog_Ch1.Enabled = True
    WIO_Analog_Ch2.Enabled = True
    WIO_Analog_Ch3.Enabled = True
    WIO_Analog_Ch4.Enabled = True
    WIO_Analog_Ch5.Enabled = True
    WIO_Analog_Ch6.Enabled = True
    WIO_Analog_Ch7.Enabled = True
    WIO_Analog_Ch8.Enabled = True
    WIO_Analog_Ch9.Enabled = True
    WIO_Analog_Ch10.Enabled = True
    WIO_Analog_Ch11.Enabled = True
    WIO_Analog_Ch12.Enabled = True
    WIO_Analog_Ch13.Enabled = True
    WIO_Analog_Ch14.Enabled = True
    WIO_Analog_Ch15.Enabled = True
    WIO_Analog_Ch16.Enabled = True
    
    WIO_8DiscreteData.Enabled = False
    WIO_16DiscreteData.Enabled = False
    WIO_32DiscreteData.Enabled = False
    WIO_64DiscreteData.Enabled = False

End Sub

Private Sub Form_Load()
    
    ' set the default protocol to UDP/IP
    '
    UseIP = True
    DisplayOnlyEbcs = True
    
    ' set the initial button states
    '
    NetworkInit.Enabled = True
    ScanNetwork.Enabled = False
    Connect.Enabled = False
    Disconnect.Enabled = False
    
    ShowBaseConfig.Enabled = False
    ReadIO.Enabled = False
    ReadIOLoop.Enabled = False
    TIOBaseInit.Enabled = False
    
    WriteIO.Enabled = False
    WIO_Frame.Enabled = False
    WIO_Base.Enabled = False
    WIO_Base_Label.Enabled = False
    WIO_Slot.Enabled = False
    WIO_Slot_Label.Enabled = False
       
    WIO_8Discrete.Enabled = False
    WIO_8DiscreteData.Enabled = False
    
    WIO_16Discrete.Enabled = False
    WIO_16DiscreteData.Enabled = False
    
    WIO_32Discrete.Enabled = False
    WIO_32DiscreteData.Enabled = False
    
    WIO_64Discrete.Enabled = False
    WIO_64DiscreteData.Enabled = False
    
    WIO_2Analog.Enabled = False
    WIO_4Analog.Enabled = False
    WIO_8Analog.Enabled = False
    WIO_16Analog.Enabled = False
    WIO_Analog_Ch1.Enabled = False
    WIO_Analog_Ch2.Enabled = False
    WIO_Analog_Ch3.Enabled = False
    WIO_Analog_Ch4.Enabled = False
    WIO_Analog_Ch5.Enabled = False
    WIO_Analog_Ch6.Enabled = False
    WIO_Analog_Ch7.Enabled = False
    WIO_Analog_Ch8.Enabled = False
    WIO_Analog_Ch9.Enabled = False
    WIO_Analog_Ch10.Enabled = False
    WIO_Analog_Ch11.Enabled = False
    WIO_Analog_Ch12.Enabled = False
    WIO_Analog_Ch13.Enabled = False
    WIO_Analog_Ch14.Enabled = False
    WIO_Analog_Ch15.Enabled = False
    WIO_Analog_Ch16.Enabled = False
   
    T1HEBC_AO_WriteSetup.Enabled = False
    T1HEBC_AO_PolarityFrame.Enabled = False
    T1HEBC_AO_PolarityLabel.Enabled = False
    T1HEBC_AO_RangeFrame.Enabled = False
    T1HEBC_AO_RangeLabel.Enabled = False
    T1HEBC_AO_Slot_Label.Enabled = False
    T1HEBC_AO_Slot.Enabled = False
    T1HEBC_AO_UNI.Enabled = False
    T1HEBC_AO_BI.Enabled = False
    T1HEBC_AO_5V.Enabled = False
    T1HEBC_AO_10V.Enabled = False
    
    FRA_Setup_Frame.Enabled = False
    FRA_Slot_Label.Enabled = False
    FRA_Slot.Enabled = False
    FRA_Channels_Label.Enabled = False
    FRA_Channels.Enabled = False
    FRA_WriteSetup.Enabled = False
    
    DisplayList.Clear
        
End Sub

Private Sub ClearDisplay_Click()

    DisplayList.Clear
    
End Sub

Private Sub Exit_Click()
        
    Rc = PASCAL_HEICloseTransport(TP)
    Rc = PASCAL_HEIClose()
        
    Unload HostEthernetIO
    
End Sub

' Determines if the selected device is a Terminator I/O EBC (T1H-EBC)
'
Private Function DeviceIsTerminatorEBC(ByRef Device As HEIDevice) As Boolean

    Dim DDBuffer As DeviceDef
    Dim DDSize As Long
    DDSize = 42
    Dim eRc As Long
        
    eRc = PASCAL_HEIReadDeviceDef(Device, DDBuffer, DDSize)
    If eRc = 0 And DDBuffer.Device(2) = MT_EBC And DDBuffer.Device(0) = MF_TERM Then
        DeviceIsTerminatorEBC = True
    
    Else
        DeviceIsTerminatorEBC = False
                
    End If

End Function

' Determines if the selected device is an EBC (H2-EBC, H4-EBC or T1H-EBC)
'
Private Function DeviceIsEBC(ByRef Device As HEIDevice) As Boolean

    Dim DDBuffer As DeviceDef
    Dim DDSize As Long
    DDSize = 42
    Dim eRc As Long
     
    eRc = PASCAL_HEIReadDeviceDef(Device, DDBuffer, DDSize)
    If eRc = 0 And (DDBuffer.Device(2) = MT_EBC Or DDBuffer.Device(2) = MT_DRIVE) Then
        DeviceIsEBC = True
    
    Else
        DeviceIsEBC = False
                
    End If

End Function

Private Function BuildTypeString(ByRef Device As HEIDevice, ByRef DDError As Boolean) As String
    
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ' First
    ' Read the Device Definition Data
    '
    Dim DDBuffer As DeviceDef
    Dim DDSize As Long
    Dim t
    Dim eRc As Long

     
    DDSize = 42
     
    eRc = PASCAL_HEIReadDeviceDef(Device, DDBuffer, DDSize)
    If eRc <> 0 Then
        DDError = True
         
    Else
        ' device byte 0 determines the Module Family
        '
        ' device byte 2 determines the Module Type, MSB determines media type
        '
        Select Case DDBuffer.Device(2)
            Case MT_EBC
                Select Case DDBuffer.Device(0)
                    Case MF_005
                        t = "H0-"
                    Case MF_205
                        t = "H2-"
                    Case MF_305
                        t = "H3-"
                    Case MF_405
                        t = "H4-"
                    Case MF_TERM
                        t = "T1H-"
                End Select
                
                If (DDBuffer.Device(2) And &H80&) = &H80& Then
                    t = t + "EBC-F"
                Else
                    t = t + "EBC"
                End If
             
            Case MT_ECOM
                Select Case DDBuffer.Device(0)
                    Case MF_005
                        t = "H0-"
                    Case MF_205
                        t = "H2-"
                    Case MF_305
                        t = "H3-"
                    Case MF_405
                        t = "H4-"
                End Select
                
                If (DDBuffer.Device(2) And &H81&) = &H81& Then
                    t = t + "ECOM-F"
                Else
                    t = t + "ECOM"
                End If
             
            Case MT_WPLC
                Select Case DDBuffer.Device(0)
                    Case MF_005
                        t = "H0-"
                    Case MF_205
                        t = "H2-"
                    Case MF_305
                        t = "H3-"
                    Case MF_405
                        t = "H4-"
                End Select
                    
                t = t + "WPLC"
             
            Case MT_DRIVE
                Select Case DDBuffer.Device(0)
                    Case MF_100_SERIES
                        t = "HA-EDRV2"
                    Case MF_J300
                        t = "HA-EDRV3"
                    Case MF_300_Series
                        t = "HA-EDRV"
                    Case MF_GS
                        t = "GS-EDRV"
                End Select
            
            Case MT_ERMA
                Select Case DDBuffer.Device(0)
                    Case MF_005
                        t = "H0-"
                    Case MF_205
                        t = "H2-"
                    Case MF_305
                        t = "H3-"
                    Case MF_405
                        t = "H4-"
                End Select
                
                If (DDBuffer.Device(2) And &H84&) = &H84& Then
                    t = t + "ERM-F"
                Else
                    t = t + "ERM"
                End If
             
            Case MT_CTRIO
                    t = t + "CTRIO"
             
            Case MT_AVG_DISP
                    t = t + "EZTOUCH"
            
            Case MT_PBC
                    t = t + "PBC"
             
            Case MT_PBCC
                    t = t + "PBCC"
             
            Case MT_UNK
                    t = t + "UNKNOWN"
        End Select
             
    End If
                        
    If DDError = True Then
        BuildTypeString = " ??????????? "
    Else
        BuildTypeString = t
    End If

End Function

Private Function UseTypeString(ByRef Buffer() As Byte, Size As Integer) As String
    Dim i, t
    
    ' convert each byte to a printable character,
    For i = 0 To Size - 1
        If Buffer(i) > 0 Then
            t = t + Chr(Buffer(i))
        End If
    Next
    
    UseTypeString = t

End Function

' This function will extract and format the Ethernet (MAC) address from the HEIDevice buffer
'
Private Function GetMACFromBuffer(ByRef Buffer() As Byte) As String

    Dim Y, t
    
    For Y = 30 To 35
        If Buffer(Y) = 0 Then
            t = t + "00 "
        Else
            'make sure each piece of the address has two digits by adding a leading 0 to
            'single digit values
            If Buffer(Y) < 16 Then
                t = t + "0" + Hex(Buffer(Y)) + " "
            Else
                t = t + Hex(Buffer(Y)) + " "
            End If
        End If
    Next Y
                    
    GetMACFromBuffer = t
    
End Function

' This function will format the IP address retrieved from DT_IP_ADDRESS
'
Private Function GetIPFromBuffer(ByRef Buffer() As Byte) As String
    
    Dim Y, t
    
    For Y = 0 To 3
         
        'make a printable version of each octet, add leading zeros to make a three digit number
        t = t + Format(StrConv(Buffer(Y), 1, Len(Buffer(Y))), "000")
         
        ' place a decimal point between the octets
        If Y < 3 Then
            t = t + "."
        Else
            t = t + " "
        End If
         
    Next Y

    GetIPFromBuffer = t
    
End Function

' This function will format the Node Number retrieved from DT_NODE_NUMBER
'
Private Function GetNodeNumberFromBuffer(ByRef Buffer() As Byte) As Long
    
    Dim tNN As Long
    
    ' the Node Number can be a 32bit number ( 4 bytes)
    '
    tNN = Buffer(0) + (Buffer(1) * 256&) + (Buffer(2) * 65536#) + (Buffer(3) * 16777216#)

    GetNodeNumberFromBuffer = tNN
    
End Function

' This function will format the Node Name retrieved from DT_NODE_NAME
'
Private Function GetNodeNameFromBuffer(ByRef Buffer() As Byte, Size As Integer) As String

    Dim i
    Dim NameText
    
    For i = 0 To Size - 1
        NameText = NameText + Chr(Buffer(i))
    Next

    GetNodeNameFromBuffer = NameText
    
End Function

' This function will format the Node Description retrieved from DT_NODE_DESCRIPTION
'
Private Function GetNodeDescFromBuffer(ByRef Buffer() As Byte, Size As Integer) As String

    Dim i
    Dim DescText
    
    For i = 0 To Size - 1
        DescText = DescText + Chr(Buffer(i))
    Next

    GetNodeDescFromBuffer = DescText

End Function
    
' This function will display some text for a given error code
'
Private Function ShowHEIErrorText(ErrorCode As Long) As String

    Select Case ErrorCode
        Case 32769:
            ShowHEIErrorText = "HEI Version Mismatch"
        
        Case 32771:
            ShowHEIErrorText = "Invalid Device"
        
        Case 32772:
            ShowHEIErrorText = "Data Buffer Too Small"
            
        Case 32773:
            ShowHEIErrorText = "0 Bytes of Data Received"

        Case 32774:
            ShowHEIErrorText = "Timeout Error"
        
        Case 32775:
            ShowHEIErrorText = "Unsupported Protocol"
        
        Case 32776:
            ShowHEIErrorText = "IP Address not Initialized"
            
        Case 32778:
            ShowHEIErrorText = "IPX Transport Not Initialized"
        
        Case 32779:
            ShowHEIErrorText = "Error Opening IPX Socket"
        
        Case 32787:
            ShowHEIErrorText = "Data Too Large"
        
        Case 41079:
            ShowHEIErrorText = "Invalid Data"
        
        Case Else
            ShowHEIErrorText = "unknown"

        
    End Select
        
End Function
'***********************************************************************
' Since the PASCAL_HEIxxxx calls require a byte buffer, convert the user
' entered strings to byte arrays
'
Function StringToByteArray(ByVal inString As String, ByRef Buffer() As Byte) As Integer
Dim i
Dim u() As Byte
    
    'Make sure all alpha characters are uppercase
    u = StrConv(inString, vbUpperCase)
    
    'skip over the Unicode byte
    For i = 0 To (Len(inString) - 1)
        Buffer(i) = u(i * 2)
    Next i
            
    StringToByteArray = 0
    
End Function

'***********************************************************************
' Swap successive entries in a byte array
'
Function ByteSwap(ByRef Buffer() As Byte, Count As Integer) As Integer
Dim i
Dim Temp As Byte

    For i = 0 To Count Step 2
        Temp = Buffer(i)
        Buffer(i) = Buffer(i + 1)
        Buffer(i + 1) = Temp
    Next i
                                    
    ByteSwap = i
    
End Function

'************************************************************************
' Convert a byte array of character codes to a packed array of characters
'
Function HexConvert(ByRef Buffer() As Byte, Count As Integer) As Integer
Dim i
                                
    'convert each character code
    For i = 0 To Count
        
        'have to manually process HEX character digits
        If (Buffer(i) > 64) And (Buffer(i) < 71) Then
            Select Case Buffer(i)
                Case 65 'A
                    Buffer(i) = 10
                Case 66 'B
                    Buffer(i) = 11
                Case 67 'C
                    Buffer(i) = 12
                Case 68 'D
                    Buffer(i) = 13
                Case 69 'E
                    Buffer(i) = 14
                Case 70 'F
                    Buffer(i) = 15
            End Select
        
        Else
            'numeric digits are much easier
            Buffer(i) = Chr(Buffer(i))
        
        End If
    
    Next i
    
    'Now pack two HEX characters into a byte
    Dim x
    x = 0
    For i = 0 To Count Step 2
        Buffer(x) = (Buffer(i) * 16) + Buffer(i + 1)
        x = x + 1
    Next i
    
    'Now clear the remainder of the byte array - just to be neat and complete
    For i = x To Count
        Buffer(i) = 0
    Next i
    
    HexConvert = x
    
End Function

'***********************************************************************
' Brute force method of converting a 4 character string to a HEX number
'
Function StringToHexInt(inData As String) As Integer
    
    Dim i
    Dim t(4) As Byte
    
    i = StringToByteArray(inData, t)
    
    'convert each character code
    For i = 0 To (Len(inData) - 1)
        
        'have to manually process HEX characters digits
        If (t(i) > 64) And (t(i) < 71) Then
            Select Case t(i)
                Case 65 'A
                    t(i) = 10
                Case 66 'B
                    t(i) = 11
                Case 67 'C
                    t(i) = 12
                Case 68 'D
                    t(i) = 13
                Case 69 'E
                    t(i) = 14
                Case 70 'F
                    t(i) = 15
            End Select
        
        Else
            'numeric digits are much easier
            t(i) = Chr(t(i))
        
        End If
    Next i
    
    Select Case Len(inData)
        Case 0
            StringToHexInt = 0
        Case 1
            StringToHexInt = t(0)
        Case 2
            StringToHexInt = (t(0) * 16) + t(1)
        Case 3
            StringToHexInt = (t(0) * 256) + (t(1) * 16) + t(2)
        Case 4
            StringToHexInt = (t(0) * 4096) + (t(1) * 256) + (t(2) * 16) + t(3)
    End Select

End Function
