VERSION 5.00
Begin VB.Form EQ_Form 
   Caption         =   "EtherQuery - Query Network for Ethernet Devices - Copyright(c) 1998, Host Engineering, Inc."
   ClientHeight    =   5940
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10905
   LinkTopic       =   "Form1"
   ScaleHeight     =   5940
   ScaleWidth      =   10905
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton QueryClear 
      Caption         =   "Clear Screen"
      Height          =   375
      Left            =   0
      TabIndex        =   15
      Top             =   480
      Width           =   1335
   End
   Begin VB.TextBox Description 
      Height          =   285
      Left            =   3960
      TabIndex        =   13
      Top             =   1080
      Width           =   2895
   End
   Begin VB.OptionButton DescCheck 
      Caption         =   "Desc"
      Height          =   195
      Left            =   3240
      TabIndex        =   12
      Top             =   1080
      Width           =   735
   End
   Begin VB.ListBox ModuleList 
      Height          =   4545
      Left            =   0
      TabIndex        =   7
      Top             =   1440
      Width           =   10935
   End
   Begin VB.OptionButton NameCheck 
      Caption         =   "Name"
      Height          =   195
      Left            =   3240
      TabIndex        =   5
      Top             =   720
      Width           =   735
   End
   Begin VB.OptionButton IDCheck 
      Caption         =   "ID"
      Height          =   195
      Left            =   3240
      TabIndex        =   4
      Top             =   360
      Width           =   735
   End
   Begin VB.TextBox ModuleName 
      Height          =   285
      Left            =   3960
      TabIndex        =   3
      Top             =   720
      Width           =   2895
   End
   Begin VB.TextBox ModID 
      BeginProperty DataFormat 
         Type            =   1
         Format          =   "0"
         HaveTrueFalseNull=   0
         FirstDayOfWeek  =   0
         FirstWeekOfYear =   0
         LCID            =   1033
         SubFormatType   =   1
      EndProperty
      Height          =   285
      Left            =   3960
      TabIndex        =   2
      Top             =   360
      Width           =   615
   End
   Begin VB.CommandButton QueryExit 
      Caption         =   "Exit"
      Height          =   375
      Left            =   0
      TabIndex        =   1
      Top             =   960
      Width           =   1335
   End
   Begin VB.CommandButton QueryAll 
      Caption         =   "Do the Query"
      Height          =   375
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1335
   End
   Begin VB.OptionButton AllCheck 
      Caption         =   "All Devices"
      Height          =   195
      Left            =   3240
      TabIndex        =   6
      Top             =   0
      Width           =   1335
   End
   Begin VB.Frame Frame1 
      Caption         =   " Protocol"
      Height          =   855
      Left            =   1680
      TabIndex        =   8
      Top             =   0
      Width           =   1215
      Begin VB.OptionButton UseIP 
         Caption         =   "Use IP"
         Height          =   255
         Left            =   120
         TabIndex        =   10
         Top             =   240
         Width           =   975
      End
      Begin VB.OptionButton UseIPX 
         Caption         =   "Use IPX"
         Height          =   255
         Left            =   120
         TabIndex        =   9
         Top             =   480
         Width           =   975
      End
   End
   Begin VB.Label Label8 
      Caption         =   "(Case Sensitive)"
      Height          =   255
      Left            =   6960
      TabIndex        =   14
      Top             =   1080
      Width           =   1215
   End
   Begin VB.Label Label6 
      Caption         =   "(Case Sensitive)"
      Height          =   255
      Left            =   6960
      TabIndex        =   11
      Top             =   720
      Width           =   1215
   End
End
Attribute VB_Name = "EQ_Form"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit                 ' Must explicitly declare variable types

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' HEI API Defines
'
Const HEIAPIVersion As Byte = 3
Const HEIAPIVersionString = "3"
Const HEIP_HOST As Integer = 1
Const HEIP_IPX As Integer = 2
Const HEIP_IP As Integer = 3
Const HEIT_HOST As Integer = 1
Const HEIT_IPX As Integer = 2
Const HEIT_WINSOCK As Integer = 4

Const DefDevTimeout As Integer = 50                        ' value in milliseconds
Const DefDevRetrys As Byte = 3
Const DefDevUseAddressedBroadcast As Boolean = False

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Error Messages
'
Const HEIE_NULL As Integer = 0                              ' No error
Const HEIE_FIRST_ERROR As Integer = &H8000                  ' Number for first error
Const HEIE_LAST_ERROR As Integer = &HFFFF                   ' Number for last error
Const HEIE_NOT_IMPLEMENTED As Integer = &H8000              ' Function not implemented
Const HEIE_VER_MISMATCH As Integer = &H8001                 ' Version passed to function is not correct for the library
Const HEIE_UNSUPPORTED_TRANSPORT As Integer = &H8002        ' Supplied transport is not supported
Const HEIE_INVALID_DEVICE As Integer = &H8003               ' Supplied device is not valid
Const HEIE_BUFFER_TOO_SMALL As Integer = &H8004             ' Supplied buffer is too small
Const HEIE_ZERO_BYTES_RECEIVED As Integer = &H8005          ' Zero packets returned in the packet
Const HEIE_TIMEOUT As Integer = &H8006                      ' Timeout error
Const HEIE_UNSUPPORTED_PROTOCOL As Integer = &H8007         ' Supplied protocol not supported
Const HEIE_IP_ADDRESS_NOT_INITIALIZED As Integer = &H8008   ' The device's IP address has not been assigned
Const HEIE_NULL_TRANSPORT As Integer = &H8009               ' No Transport specified
Const HEIE_IPX_NOT_INITIALIZED As Integer = &H800A          ' IPX Transport not installed
Const HEIE_IPX_OPEN_SOCKET As Integer = &H800B              ' Error opening IPX socket
Const HEIE_NO_PACKET_DRIVER As Integer = &H800C             ' No packet driver found
Const HEIE_CRC_MISMATCH As Integer = &H800D                 ' CRC did not match
Const HEIE_ALLOCATION_ERROR As Integer = &H800E             ' Memory allocation failed
Const HEIE_NO_IPX_CACHE As Integer = &H800F                 ' No cache has been allocated for IPX
Const HEIE_INVALID_REQUEST As Integer = &H8010              ' Invalid CCM Request
Const HEIE_NO_RESPONSE As Integer = &H8011                  ' No response was available/requested
Const HEIE_INVALID_RESPONSE As Integer = &H8012             ' Invalid format response was received
Const HEIE_DATA_TOO_LARGE As Integer = &H8013               ' Given data is too large
Const HEIE_LOAD_PROC_ERROR As Integer = &H8014              ' Error loading procedures
Const HEIE_NOT_LOADED As Integer = &H8015                   ' Attempted command before succesfull OpenTransport()
Const HEIE_LOAD_ERROR As Integer = &H9000                   ' Error on loading

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' If PASCAL_HEIOpenTransport()fails for WinSock, it will return one of the following errors:
'
' &h8014    Error getting address from WinSock.DLL
' &h8100    System was out of memory, or executable file was corrupt, or sharing or network-protection error
' &h8101    Unused
' &h8102    file was not found
' &h8103    Path was not found
' &h8104    Unused
' &h8105    Attempt was made to dynamically link to a task, or there was a sharing or network-protection error
' &h8106    Library required separate data segments for each task
' &h8107    Unused
' &h8108    There was insufficient memory to start the application
' &h8109    Unused
' &h810A    Windows version was incorrect
' &h810B    Executable file was invalid, it's either not a Windows application or there was an error in the .EXE image.
' &h810C    Application was designed for a different operating system
' &h810D    Application was designed for MS-DOS 4.0
' &h810E    Type of executable was unknown
' &h810F    Attempt was made to load a real-mode application (developed for an earlier version of Windows )
' &h8110    Attempt was made to load a second instance of an application file containing multiple data segments that were not marked read-only
' &h8113    Attempt was made to load a compressed executable file. The file must be decompressed before it can be loaded
' &h8114    Dynamic-link library (DLL) file was invalid. One of the DLLs required to run this application was corrupt
' &h8115    Application requires Microsoft Windows 32-bit extensions
'
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Warnings
'
    Const HEIW_FIRST_WARNING As Integer = &H4000    ' Number for First Warning
    Const HEIW_LAST_WARNING As Integer = &H4FFF     ' Number for Last Warning
    Const HEIW_RETRY As Integer = &H4000            ' One or More Retrys have occurred

' These are masks for values returned from HEIReadIO and/or HEIWriteIO and indicate that some
' error/warning/info/internal condition exists for some module in the base ( it could be an I/O
' module or it could be the ethernet module. The function HEIReadModuleStatus can then be used
' to retrieve the actual conditions. Note that more than one of the conditions can exist at any time.
'
    Const MASK_DEVICE_ERROR As Integer = &H1000
    Const MASK_DEVICE_WARNING As Integer = &H2000
    Const MASK_DEVICE_INFO As Integer = &H4000

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Data Types
'
    Const DT_IP_ADDRESS As Integer = &H10           ' 4-byte IP Address
    Const DT_NODE_NUMBER As Integer = &H20          ' 4-byte Node Number
    Const DT_NODE_NAME As Integer = &H16            ' 256-byte Node Name
    Const DT_DESCRIPTION As Integer = &H26          ' 256-byte Node Description
    Const DT_SUBNET_MASK As Integer = &H30          ' 4-byte Subnet Mask
    Const DT_LINK_MONITOR As Integer = &H8006       ' 256 Byte Link monitor setup (Ram Based) - see link monitor structure below
    Const DT_RXWX_SETTINGS As Integer = &H15        ' 128 Byte setings for RXWX configuration
    Const DT_SERIAL_SETTINGS As Integer = &H11      ' 8 Byte Serial Setup
    Const DT_BASE_DEF As Integer = &H17             ' 512 Byte Base Definition (405 HEIWriteBaseDef)
    Const DT_MODULE_SETUP As Integer = &H24         ' 64-byte data from FLASH (see ModuleSetup structure)
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Terminator Hot-Swap Defines
'
    Const HEIE_MODULE_NOT_RESPONDING = 153          ' one or more module(s) removed
    Const HEIE_BASE_CHANGED = 154                   ' one or more module(s) added
    Const RESCAN_LEAVE_IMAGE_RAM = 0                ' Don't clear the image RAM
    Const RESCAN_CLEAR_IMAGE_RAM = 1                ' Clear the image RAM

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Structure Definitions
'
    Private Type EthernetStats
        SizeOfEthernetStats As Integer
        MissedFrameCount As Long
        TransmitCollisionCount As Long
        DiscardedPackets As Long
        BadCRCCount As Long
        UnknownTypeCount As Long
        SendErrorCount As Long
    End Type
    
    Private Type SupportDef
        Version As Byte
        Bytes2Follow As Byte
        UnusedBytes(15) As Byte
        'bit fields in Byte 1
        'FUN_POLLING As Byte             ' Polling one base
        'FUN_READ_VER_INFO As Byte       ' Version Info
        'FUN_READ_SUPPORT_INFO As Byte   ' Support Info
        'FUN_READ_DEVICE_INFO As Byte    ' Device Info
        'FUN_POLLING_ALL As Byte         ' Polling All bases (returns ethernet address)
        'FUN_WRITE_IO As Byte            ' Write IO Base
        'FUN_READ_IO As Byte             ' Read IO Base
        '
        'bit fields in Byte 2
        'FUN_READ_BASE_DEF As Byte       ' Read Base Def
        'FUN_ENUM_SETUP_DATA As Byte     ' Emunerate the Setup Data
        'FUN_READ_SETUP_DATA As Byte     ' Read Setup Data
        'FUN_WRITE_SETUP_DATA As Byte    ' Write Setup Data
        'FUN_DELETE_SETUP_DATA As Byte   ' Delete Setup Data
        'FUN_READ_ETHERNET_STATS As Byte ' Read Ethernet Statistics
        'FUN_PET_LINK As Byte            ' Used to keep the link sense timer from firing in the absense of REadIO or WriteIO messages
        'FUN_ADDRESSED_BROADCAST As Byte ' Used to broadcast to a particular ethernet address
        '
        'bit fields in Byte 3
        'FUN_READ_MODULE_STATUS As Byte  ' Read module status (short bytes)
        'FUN_EXTENDED As Byte            ' Extended function
        'FUN_QUERY_SETUP_DATA As Byte    ' Query for particular data type/value
        'FUN_INIT_BASE_DEF As Byte       ' Initialize base def from backplane
        'FUN_DATA_BROADCAST As Byte      ' Broadcast to a particular data type
        'FUN_CCM_REQUEST As Byte         ' Perform CCM Request
        'FUN_KSEQ_REQUEST As Byte        ' Perform a KSequence Request
        'FUN_BACKPLANE_REQUEST As Byte   ' Perform backplane request
    End Type
    
    Private Type SerialSetup
        BaudRate As Long
        ConfigData(2) As Byte
        'bit fields in Byte 1
        ' StopBits
        ' DataBits
        ' Parity
        ' Mode
        ' Reserved
    End Type
    
    Private Type VersionDef
        MajorVersion As Byte
        MinorVersion As Byte
        BuildVersion As Long
    End Type
    
    Private Type VersionInfoDef
        SizeofVersionInfo As Byte
        BootVersion As VersionDef
        OSVersion As VersionDef
        NumOSExtensions As Byte
        OSExt(9) As VersionDef
    End Type
    
    Private Type DeviceDef
        'PLCFamily As Byte               ' 1= HA, 2= 205, 3= 305, 4= 405
        'Unused1 As Byte
        'ModuleType As Byte              ' 0= EBC, 1= ECOM, &H80= Fiber, 3= Drive, 4= ERM, 6= AVG
        'StatusCode As Byte
        'EthernetAddress(5) As Byte      ' Hardware Ethernet Address
        'RamSize As Integer              ' in K-byte increments
        'FlashSize As Integer            ' in K-byte increments
        'DipSettings As Byte             ' setting of the 8 element dip switch
        'MediaType As Byte               ' 0= 10Base-T,1= 10Base-F
        'EPFCount As Long                ' Early Power Fail Count - 405 only
        'Status As Byte                  '  Status:1 = Run Relay Status
        '                                '  Status:2 = Battery Low Indicator
        '                                '  Status:6 = unused bits
        'unused(21) As Byte
        device(43) As Byte               ' 44-byte byte array (VB packs on 4-byte boundaries)
    End Type
    
    Private Type LinkMonitor
        'Timeout As Long                 ' 0= don't use Link Monitor
        'Mode As Byte                    ' 0= Clear Outputs
        '                                ' 1= Use pattern
        Data(255) As Byte                ' Pattern, same format as used for HEIWriteIO
    End Type
    
    Private Type MemoryTypeDef
        Type As Integer
        size As Long
        unused(3) As Long
    End Type
    
    Private Type Encryption
        Algorithm As Byte               ' Algorithm to use for encryption: 0= No encryption, 1= private key encryption
        Unused1(2) As Byte              ' Reserved
        Key(59) As Byte                 ' Encryption key (null terminated)
    End Type
    
    Private Type EnetAddress
            'union
        '{
        '   ' Use this for HEIP_HOST protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_UNSPEC == 0
        '       char Nodenum[6];            ' Ethernet network address
        '       unsigned short LANNum;      ' Lana number
        '   }  AddressHost;
        '
        '   ' Use this for HEIP_IPX protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_IPX == 6
        '       char Netnum[4];             ' Network Number
        '       char Nodenum[6];            ' Ethernet network address
        '       unsigned short Socket;      ' Socket Number == 0x7070
        '   } AddressIPX;
        '
        '   ' Use this for HEIP_IP protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_INET == 2
        '       unsigned short Port;        ' Port number == 0x7070
        '       union
        '       {
        '           struct { unsigned char b1, b2, b3, b4; } bAddr;  ' Byte Addressing
        '           struct { unsigned short w1, w2; } wAddr;         ' Word addressing
        '           unsigned long lAddr;                             ' DWord addressing
        '       } AddressingType;
        '       char Zero[8];               ' initialize to zeros
        '   } AddressIP;
        '
        '   struct
        '   {
        '       Byte    Commport;
        '       Byte    ByteSize;
        '       Byte    Parity;
        '       Byte    StopBits;
        '       Long    Baud;
        '       Long    *hLocal;
        '   } AddressSerial;
        
        '   BYTE Raw[20];
        '}Address
        '
        Address(19) As Byte
    End Type
    
    
    Private Type HEITransport
        Transport As Integer
        Protocol As Integer
        Encrypt As Encryption
        SourceAddress As EnetAddress
        Reserved(47) As Byte
    End Type
    
    Private Type HEIDevice
        'union
        '{
        '   ' Use this for HEIP_HOST protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_UNSPEC == 0
        '       char Nodenum[6];            ' Ethernet network address
        '       unsigned short LANNum;      ' Lana number
        '   }  AddressHost;
        '
        '   ' Use this for HEIP_IPX protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_IPX == 6
        '       char Netnum[4];             ' Network Number
        '       char Nodenum[6];            ' Ethernet network address
        '       unsigned short Socket;      ' Socket Number == 0x7070
        '   } AddressIPX;
        '
        '   ' Use this for HEIP_IP protocol addressing
        '   struct
        '   {
        '       short Family;               ' AF_INET == 2
        '       unsigned short Port;        ' Port number == 0x7070
        '       union
        '       {
        '           struct { unsigned char b1, b2, b3, b4; } bAddr;  ' Byte Addressing
        '           struct { unsigned short w1, w2; } wAddr;         ' Word addressing
        '           unsigned long lAddr;                             ' DWord addressing
        '       } AddressingType;
        '       char Zero[8];               ' initialize to zeros
        '   } AddressIP;
        '
        '   struct
        '   {
        '       Byte    Commport;
        '       Byte    ByteSize;
        '       Byte    Parity;
        '       Byte    StopBits;
        '       Long    Baud;
        '       Long    *hLocal;
        '   } AddressSerial;
        
        '   BYTE Raw[20];
        '}Address
        '
        'Address(19) As Byte
        'wParam As Integer
        'dw_Param As Long
        'Timeout As Integer             ' Timeout value in ms
        'Retrys As Integer              ' Number of times to retry a transaction
        'EnetAddress(5) As Byte         ' Address placed here in HEIQueryDevice(s)
        'RetryCount As Integer          ' number of retrys that have occurred
        'BadCRCCount As Integer         ' number of packets received with a bad CRC
        'LatePacketCount As Integer     ' number of packets received after a timeout
        'ParallelPackets As Boolean     ' If set TRUE, (after HEIOpenDevice), will enable application
                                        ' to send multiple HEIReadIO, HEIWriteIO, HEICCMRequest or
                                        ' HEIKseqRequest transactions to different devices before waiting
                                        ' for any reponses. The application will then need to implement
                                        ' it's own timeout/retry mechanism while waiting on responses.
                                        ' Use HEIGetResponse() to see if responses have arrived.
                                        ' NOTE: do not send multiple requests to a single device.
        '
        'Internal Use Only -- Do Not Touch !!--
        'UseAddressedBroadcast As Boolean
        'UseBroadcast As Boolean
        'dwParam As Long
        'DataOffset As Integer
        'pTransport As Long
        'SizeOfData As Long
        'pData As Long
        'pBuffer As Long
        'LastAppVal As Integer
        'Byte UseProxy
        'Byte ProxyBase
        'Byte ProxySlot
        'Byte ProxyDevNum
        'Bytes Reserved(43)
        'Address(77) As Byte             ' 78-byte byte array (VB packs on 4-byte boundaries)
        Address(125) As Byte             ' 122-byte byte array (VB packs on 4-byte boundaries)
    End Type
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Host Ethernet APIs
'
    Private Declare Function PASCAL_HEIOpen Lib "hei_pas" ( _
        ByVal HEIAPIVersion As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIClose Lib "hei_pas" ( _
    ) As Long
    
    Private Declare Function PASCAL_HEIOpenTransport Lib "hei_pas" ( _
        ByRef pTransport As HEITransport, _
        ByVal HEIAPIVersion As Integer, _
        ByVal EnetAdress As Long _
    ) As Long
    
    Private Declare Function PASCAL_HEICloseTransport Lib "hei_pas" ( _
        ByRef pTransport As HEITransport _
    ) As Long
    
    Private Declare Function PASCAL_HEIQueryDevices Lib "hei_pas" ( _
        ByRef pTransport As HEITransport, _
        ByRef pDevice As HEIDevice, _
        ByRef pNumDevices As Long, _
        ByVal HEIAPIVersion As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIQueryDeviceData Lib "hei_pas" ( _
        ByRef pTransport As HEITransport, _
        ByRef pDevice As HEIDevice, _
        ByRef pNumDevices As Long, _
        ByVal HEIAPIVersion As Integer, _
        ByVal DataType As Integer, _
        ByRef pData As Byte, _
        ByVal SizeOFData As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIOpenDevice Lib "hei_pas" ( _
        ByRef pTransport As HEITransport, _
        ByRef pDevice As HEIDevice, _
        ByVal HEIAPIVersion As Integer, _
        ByVal Timeout As Integer, _
        ByVal Retrys As Integer, _
        ByRef UseAddressedBroadcast As Boolean _
    ) As Long
    
    Private Declare Function PASCAL_HEICloseDevice Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice _
    ) As Long
    
    Private Declare Function PASCAL_HEIReadSetupData Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByVal SetupType As Integer, _
        ByRef pData As Byte, _
        ByRef pSizeOfData As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIWriteSetupData Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByVal SetupType As Integer, _
        ByRef pData As Byte, _
        ByVal SizeOFData As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIReadDeviceDef Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pModuleDefInfo As DeviceDef, _
        ByVal pSizeOfModuleDefInfo As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIReadIO Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pData As Byte, _
        ByRef pDataSize As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIWriteIO Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pData As Byte, _
        ByVal SizeOFData As Integer, _
        ByRef pReturnData As Byte, _
        ByRef pSizeOfReturnData As Integer _
    ) As Long
    
    Private Declare Function PASCAL_HEIReadModuleStatus Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pData As Byte, _
        ByRef pSizeOfData As Integer, _
        ByVal Clear As Integer _
    ) As Long

    Private Declare Function PASCAL_HEIReadBaseDef Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pData As Byte, _
        ByRef pDataSize As Integer _
    ) As Long
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' H4-EBC only
'
    Private Declare Function PASCAL_HEIWriteBaseDef Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByRef pData As Byte, _
        ByRef pDataSize As Integer _
    ) As Long
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Terminator I/O specific APIs
'
    Private Declare Function PASCAL_HEIRescanBase Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByVal pRescanFlags As Integer, _
        ByRef pBaseDefInfo As Byte, _
        ByRef pDataSize As Integer _
    ) As Long
    
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' ECOM Specific APIs
'
    Private Declare Function PASCAL_HEICCMRequest Lib "hei_pas" ( _
        ByRef pDevice As HEIDevice, _
        ByVal bWrite As Integer, _
        ByVal DataType As Byte, _
        ByVal Address As Integer, _
        ByVal pDataLen As Integer, _
        ByRef pData As Byte _
    ) As Long
    
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Global Variables
'
Dim Protocol As Integer


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'EtherQuery is our version of Ping. It will query the network for any
'Host Engineering Ethernet Devices. It will read the setup data from
'each module it finds.
'
Sub EtherQuery()

Const QT_NORMAL = 0
Const QT_ID = 1
Const QT_NAME = 2
Const QT_DESC = 3
Dim QueryType

Const MAXDEVICES = 20
Dim DeviceNum, DeviceCount As Long
DeviceCount = MAXDEVICES

'Array of HEIDevice Structures
Dim aDevices(MAXDEVICES) As HEIDevice


Dim TP As HEITransport
Dim RecordSize As Integer
Dim Msg, Style, Title, Help, Ctxt, Rc, i As Long
Dim EnetAddress, ModuleID, ModIP, ModName, ModDesc, ModuleType
Dim Duff(255) As Byte

Dim Separator, LineItem
Separator = "    -----------------------------------------------------"

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Step One,  Initialize the driver
'           Called once at startup
'
Rc = PASCAL_HEIOpen(HEIAPIVersion)
If Rc <> 0 Then
    LineItem = "Unable to initialize the driver: rc= " + Hex(Rc)
    ModuleList.AddItem LineItem
    ModuleList.AddItem Separator
    
Else
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    'Step two,  Initialize the transport
    '           Under Win32, the only valid transport is WinSock
    '
    TP.Transport = HEIT_WINSOCK
    TP.Protocol = Protocol
    
    Rc = PASCAL_HEIOpenTransport(TP, HEIAPIVersion, 0)
    If Rc <> 0 Then
        LineItem = "Unable to open Winsock Transport: rc= " + Hex(Rc)
        ModuleList.AddItem LineItem
        ModuleList.AddItem Separator
 
    Else
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        'Step 3, Query the network for Ethernet Devices
        '
        If AllCheck = True Then
            QueryType = QT_NORMAL
        End If
        
        If IDCheck = True Then
            QueryType = QT_ID
        End If
        
        If NameCheck = True Then
            QueryType = QT_NAME
        End If
        
        If DescCheck = True Then
            QueryType = QT_DESC
        End If
        
        Select Case QueryType
            Case QT_NORMAL
                
                '''''''''''''''''''''''''''''''''''''''''''''''''''''''
                'PASCAL_HEIQueryDevices uses a broadcast to detect any
                'ethernet modules on the network.
                '
                Rc = PASCAL_HEIQueryDevices(TP, aDevices(0), DeviceCount, HEIAPIVersion)
                If Rc <> 0 Then
                    LineItem = "Error Querying the Network: rc= " + Hex(Rc)
                    ModuleList.AddItem LineItem
                    ModuleList.AddItem Separator
                End If
                        
            Case QT_ID
                
                '''''''''''''''''''''''''''''''''''''''''''''''''''''''
                'PASCAL_HEIQueryDeviceData uses a broadcast and the
                'additional filtering information supplied to detect
                'a specific ethernet module on the network
                '
                Dim IDQ(4) As Byte
                Dim Temp As Long
                Temp = ModID
                IDQ(0) = Temp
                
                Rc = PASCAL_HEIQueryDeviceData(TP, aDevices(0), DeviceCount, HEIAPIVersion, DT_NODE_NUMBER, IDQ(0), 4)
                If Rc <> 0 Then
                    LineItem = "Error Querying By Module ID: rc= " + Hex(Rc)
                    ModuleList.AddItem LineItem
                    ModuleList.AddItem Separator
                End If
            
            Case QT_NAME
                
                '''''''''''''''''''''''''''''''''''''''''''''''''''''''
                'PASCAL_HEIQueryDeviceData uses a broadcast and the
                'additional filtering information supplied to detect
                'a specific ethernet module on the network
                '
                Dim NameQ(255) As Byte
                Dim T() As Byte
                
                T = ModuleName
                
                'skip the Unicode byte
                For i = 0 To Len(ModuleName) - 1
                    NameQ(i) = T(i * 2)
                Next i
                
                'NULL terminator
                NameQ(i) = 0
                
                Rc = PASCAL_HEIQueryDeviceData(TP, aDevices(0), DeviceCount, HEIAPIVersion, DT_NODE_NAME, NameQ(0), i)
                If Rc <> 0 Then
                    LineItem = "Error Querying by Module Name: rc= " + Hex(Rc)
                    ModuleList.AddItem LineItem
                    ModuleList.AddItem Separator
                End If
            
            Case QT_DESC
                
                '''''''''''''''''''''''''''''''''''''''''''''''''''''''
                'PASCAL_HEIQueryDeviceData uses a broadcast and the
                'additional filtering information supplied to detect
                'a specific ethernet module on the network
                '
                Dim DescQ(255) As Byte
                Dim T1() As Byte
                
                T1 = Description
                
                'skip the Unicode byte
                For i = 0 To Len(Description) - 1
                    DescQ(i) = T1(i * 2)
                Next i
                
                'NULL terminator
                DescQ(i) = 0
                
                Rc = PASCAL_HEIQueryDeviceData(TP, aDevices(0), DeviceCount, HEIAPIVersion, DT_DESCRIPTION, DescQ(0), i)
                If Rc <> 0 Then
                    LineItem = "Error Querying by Module Description: rc= " + Hex(Rc)
                    ModuleList.AddItem LineItem
                    ModuleList.AddItem Separator
                End If
            
        End Select
        
        'After a Query, DeviceCount contains the number of devices found that match the criterion
        '
        If DeviceCount > 0 Then
            LineItem = "Found " + Str$(DeviceCount) + " Device(s)"
            ModuleList.AddItem LineItem
            
            '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
            'Step 4, Open each device in the array
            '
            For DeviceNum = 0 To DeviceCount - 1
                Rc = PASCAL_HEIOpenDevice(TP, aDevices(DeviceNum), HEIAPIVersion, 25, 3, False)
                If Rc <> 0 Then
                    LineItem = "Unable to open the device: rc= " + Hex(Rc)
                    ModuleList.AddItem LineItem
                    ModuleList.AddItem Separator
                
                Else
                    'set each array element to 0 before it is used.
                    Erase Duff
                    
                    '''''''''''''''''''''''''''''''''''''''''''''''''''
                    'Step 5, Communicate with the device
                    '        Read setup information from the module
                    '
                    RecordSize = 4
                    Rc = PASCAL_HEIReadSetupData(aDevices(DeviceNum), DT_NODE_NUMBER, Duff(0), RecordSize)
                    ModuleID = Str$(Duff(0))
                    
                    RecordSize = 4
                    Rc = PASCAL_HEIReadSetupData(aDevices(DeviceNum), DT_IP_ADDRESS, Duff(0), RecordSize)
                    ModIP = Str$(Duff(0)) + "." + Str$(Duff(1)) + "." + Str$(Duff(2)) + "." + Str$(Duff(3))
                    
                    RecordSize = 10
                    Rc = PASCAL_HEIReadSetupData(aDevices(DeviceNum), DT_NODE_NAME, Duff(0), RecordSize)
                    
                    'determine the length of the text
                    i = 0
                    While Duff(i) <> 0
                        i = i + 1
                    Wend
                    
                    'convert & copy to a string, so that Mid$ will work
                    ModName = StrConv(Duff, vbUnicode)
                    ModName = Mid$(ModName, 1, i)
                                                                   
                    RecordSize = 40
                    Rc = PASCAL_HEIReadSetupData(aDevices(DeviceNum), DT_DESCRIPTION, Duff(0), RecordSize)
                    
                    'determine the length of the text
                    i = 0
                    While Duff(i) <> 0
                        i = i + 1
                    Wend
                    
                    'convert & copy to a string, so that Mid$ will work
                    ModDesc = StrConv(Duff, vbUnicode)
                    ModDesc = Mid$(ModDesc, 1, i)
                                    
                    '''''''''''''''''''''''''''''''''''''''''''''''''''
                    'Read additional information from the module
                    '
                    Dim DD As DeviceDef
                    Dim DDSize As Long
                    DDSize = 42
                    
                    Rc = PASCAL_HEIReadDeviceDef(aDevices(DeviceNum), DD, DDSize)
                    If Rc <> 0 Then
                        LineItem = "Unable to read the device definition: rc= " + Hex(Rc)
                        ModuleList.AddItem LineItem
                        ModuleList.AddItem Separator
                        
                    Else


                        'construct a printable version of the IP address
                        EnetAddress = Hex(DD.device(4)) + " " + Hex(DD.device(5)) + " " + _
                                      Hex(DD.device(6)) + " " + Hex(DD.device(7)) + " " + _
                                      Hex(DD.device(8)) + " " + Hex(DD.device(9))
                                      
                        'construct a printable vesion of the model number
                        Select Case DD.device(0)
                            Case 2
                                ModuleType = "H2-"
                                
                            Case 3
                                ModuleType = "H3-"
                                
                            Case 4
                                ModuleType = "H4-"
                                
                            Case Else
                                ModuleType = "XX-"
                        End Select
                        
                        Select Case DD.device(2)
                            Case 0
                                If DD.device(19) = 0 Then
                                    ModuleType = ModuleType + "EBC   "
                                Else
                                    ModuleType = ModuleType + "EBC-F "
                                End If
                                
                            Case 1
                                If DD.device(19) = 0 Then
                                    ModuleType = ModuleType + "ECOM  "
                                Else
                                    ModuleType = ModuleType + "ECOM-F"
                                End If
                                
                            Case Else
                                ModuleType = ModuleType + "XXXXXX"
                        End Select
                        
                        'Put all of the pieces together for the display
                        LineItem = EnetAddress + _
                                   " Type=" + ModuleType + _
                                   " ModID=" + ModuleID + _
                                   " ModIP =" + ModIP + _
                                   " ModName=" + ModName + _
                                   " ModDesc=" + ModDesc
        
                        'add this line item to the ListBox
                        '
                        ModuleList.AddItem LineItem
                    
                    End If
                    
                    '''''''''''''''''''''''''''''''''''''''''''''''''''
                    'Step 6, Close this device
                    '
                    Rc = PASCAL_HEICloseDevice(aDevices(DeviceNum))
                    If Rc <> 0 Then
                        LineItem = "unable to close the device: rc= " + Hex(Rc)
                        ModuleList.AddItem LineItem
                        ModuleList.AddItem Separator
                    End If
                
                End If
            
            'get next device in the array
            Next DeviceNum
    
            'Add a separator to distinguish between the queries
            ModuleList.AddItem Separator
            
        'No devices found that match query criterion
        '
        Else
            Select Case QueryType
                Case QT_NORMAL
                    LineItem = "No Devices Found!"
                    
                Case QT_ID
                    LineItem = "No device(s) with Module ID of " + Str(IDQ(0)) + " found!"
                    
                Case QT_NAME
                    'determine the length of the text
                    i = 0
                    While NameQ(i) <> 0
                        i = i + 1
                    Wend
                    
                    'convert & copy to a string, so that Mid$ will work
                    Dim z
                    z = StrConv(NameQ, vbUnicode)
                    z = Mid$(z, 1, i)
                    LineItem = "No device(s) named " + z + " found!"
                    
            End Select
            
            'display the message
            '
            ModuleList.AddItem LineItem
            
            'Add a separator to distinguish between the queries
            '
            ModuleList.AddItem Separator
            
        End If
        
        '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
        'Step 7, Close the WinSock Transport
        '
        Rc = PASCAL_HEICloseTransport(TP)
        If Rc <> 0 Then
            LineItem = "Unable to close the Transport: rc= " + Hex(Rc)
            ModuleList.AddItem LineItem
            ModuleList.AddItem Separator
        End If
    End If
    
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    'Step 8, Shut down the driver, unload Winsock
    '
    Rc = PASCAL_HEIClose()
    If Rc <> 0 Then
        LineItem = "Unable to close the driver: rc= " + Hex(Rc)
        ModuleList.AddItem LineItem
        ModuleList.AddItem Separator
    End If

End If

End Sub


Private Sub DescCheck_Click()
    
    AllCheck = False
    ModID.Enabled = False
    
    ModuleName.Enabled = False
    Label6.ForeColor = &H808080
    
    Description.Enabled = True
    Label8.ForeColor = &H0
    
End Sub

Private Sub Form_Load()
    
    UseIP = True
    AllCheck = True
    ModID.Enabled = False
    
    ModuleName.Enabled = False
    Label6.ForeColor = &H808080
    
    Description.Enabled = False
    Label8.ForeColor = &H808080
    
End Sub


Private Sub AllCheck_Click()
    
    ModID.Enabled = False
    
    ModuleName.Enabled = False
    Label6.ForeColor = &H808080
    
    Description.Enabled = False
    Label8.ForeColor = &H808080
    
End Sub
Private Sub IDCheck_Click()
    
    ModID.Enabled = True
    
    ModuleName.Enabled = False
    Label6.ForeColor = &H808080
    
    Description.Enabled = False
    Label8.ForeColor = &H808080
    
End Sub

Private Sub NameCheck_Click()
    
    ModID.Enabled = False
    
    ModuleName.Enabled = True
    Label6.ForeColor = &H0

    Description.Enabled = False
    Label8.ForeColor = &H808080
    
End Sub

Private Sub QueryAll_Click()

    Call EtherQuery

End Sub

Private Sub QueryClear_Click()
    
    ModuleList.Clear
    
End Sub

Private Sub QueryExit_Click()

    Unload EQ_Form
    
End Sub

Private Sub UseIP_Click()
    
    Protocol = HEIP_IP
    ModuleList.Clear

End Sub

Private Sub UseIPX_Click()
    
    Protocol = HEIP_IPX
    ModuleList.Clear

End Sub
